/* Enterprise Web Application Stack */'use strict';Object.defineProperty(exports,'__esModule',{value:!0});function _interopDefault(e){return e&&'object'==typeof e&&'default'in e?e['default']:e}var web=require('@e2/web'),mongodb=require('@e2/mongodb'),protobufjs=require('protobufjs'),querystring=require('querystring'),agentframework=require('agentframework'),crypto=require('crypto'),url=require('url'),path=require('path'),axios=_interopDefault(require('axios')),lib=require('@e2/lib'),stream=require('stream'),azureStorage=require('azure-storage'),lodash=require('lodash'),core=require('@e2/core'),Stripe=require('stripe'),gtoken=require('gtoken'),cronParser=require('cron-parser');/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */function __decorate(e,t,o,n){var a,s=arguments.length,p=3>s?t:null===n?n=Object.getOwnPropertyDescriptor(t,o):n;if('object'==typeof Reflect&&'function'==typeof Reflect.decorate)p=Reflect.decorate(e,t,o,n);else for(var l=e.length-1;0<=l;l--)(a=e[l])&&(p=(3>s?a(p):3<s?a(t,o,p):a(t,o))||p);return 3<s&&p&&Object.defineProperty(t,o,p),p}function __metadata(e,t){if('object'==typeof Reflect&&'function'==typeof Reflect.metadata)return Reflect.metadata(e,t)}class SecuredCookie extends web.Resolvable{get name(){return'SecuredCookie'}constructor(e){super(e),console.log('WEB_SESSION_COOKIE_SECRET',e.settings.constructor.name,e.settings.WEB_SESSION_COOKIE_SECRET),this.crypts=new web.Keygrip(e.settings.WEB_SESSION_COOKIE_SECRET,'sha1'),this.base72=new web.BaseX('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ:/?&=.-,@%')}sign(e){const t=this.crypts.sign(e);return web.Base62.fromBuffer(this.base72.toBuffer(e))+'.'+web.Base62.fromBuffer(t)}verify(e){try{const t=e.split('.'),o=this.base72.fromBuffer(web.Base62.toBuffer(t[0])),r=web.Base62.toBuffer(t[1]);return!!this.crypts.verify(o,r)&&o}catch(e){return this.logger.warn(e,'Unable to verify signed cookie'),!1}}}let SessionCookieManager=class e extends web.Resolvable{get name(){return'SessionCookieManager'}get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t){const o=this.security.verify(t);if(o)return o;e.logger.warn({fingerprint:e.fingerprint(),cookie:t},'[INTRUSION DETECTED] User sent invalidate auth token:')}return null}set(e,t){const o={path:'/api',httpOnly:!0,secure:e.settings.SECURE,overwrite:!0};e.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,this.security.sign(t),o)}clear(e){const t={path:'/api',httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:e.settings.SECURE,overwrite:!0};e.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,'',t)}};__decorate([web.singleton(),__metadata('design:type',SecuredCookie)],SessionCookieManager.prototype,'security',void 0),SessionCookieManager=__decorate([web.service()],SessionCookieManager);class SessionProtocol{static[web.Symbols.Singleton](){return protobufjs.Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:'bytes',id:1},displayName:{type:'string',id:2},displayImageURL:{type:'string',id:3}}},WebSession:{fields:{session:{type:'bytes',id:1},user:{type:'bytes',id:2},token:{type:'bytes',id:3},roles:{type:'string',rule:'repeated',id:4},groups:{type:'string',rule:'repeated',id:5},scope:{type:'string',rule:'repeated',id:6},profile:{type:'IdentityProfile',id:7},theme:{type:'string',id:8},timezone:{type:'string',id:9},locale:{type:'string',id:10}}}}}).lookupType('WebSession')}static get schema(){const e=this[web.Symbols.Singleton];if(e){const e=this[web.Symbols.Singleton]();return Reflect.defineProperty(this,'schema',{value:e}),e}throw new Error('Symbols.Singleton is not found')}}class SessionScheme extends SessionProtocol{static encode(e){const t=Object.assign({},e);e.session instanceof mongodb.ObjectId&&(t.session=e.session.id),e.user instanceof mongodb.ObjectId&&(t.user=e.user.id),e.token instanceof mongodb.ObjectId&&(t.token=e.token.id),e.token instanceof mongodb.ObjectId&&(t.token=e.token.id);const o=t.profile;if(o){let e;e=o._id instanceof mongodb.ObjectId?o._id.id:'string'==typeof o._id?Buffer.from(o._id,'hex'):new Buffer(0),o._id=e}return new Buffer(this.schema.encode(t).finish())}static decode(e){let t,o;try{o=this.schema.decode(e),t=o.toJSON()}catch(e){return null}Buffer.isBuffer(o.session)&&(t.session=new mongodb.ObjectId(o.session)),Buffer.isBuffer(o.user)&&(t.user=new mongodb.ObjectId(o.user)),Buffer.isBuffer(o.token)&&(t.token=new mongodb.ObjectId(o.token));const r=o.profile;if(r){let e;e=Buffer.isBuffer(r._id)?new mongodb.ObjectId(r._id):null,t.profile._id=e}return t}}class InternalSymbol{}InternalSymbol.ServiceContext=Symbol('WfCtx');class WebFoundationService extends web.Resolvable{}class WebFoundationUserService extends web.Resolvable{constructor(e,t){if(!t)throw new Error('User scoped service only can be created using ctx.resolve()');super(e),this[InternalSymbol.ServiceContext]=t}get domain(){const e=this[InternalSymbol.ServiceContext];return Reflect.defineProperty(this,'domain',{value:e.domain}),e.domain}addResponseHeader(e,t){this[InternalSymbol.ServiceContext].res.headers.append(e,t)}getRequestHeader(e){return this[InternalSymbol.ServiceContext].req.headers[e]}}class WfService extends WebFoundationService{}exports.WebSessionService=class e extends WfService{get name(){return'WebSessionService'}create(e,t){const o=this.sessionCookie.get(e);return o&&o.length?SessionScheme.decode(web.Base62.toBuffer(o)):null}update(e,t){const o=Object.keys(t);if(!o.length)throw new web.ParameterError('Unable to update empty identity, please use WebIdentityService.clear() instead');const r=SessionScheme.encode(t);if(!r||!r.byteLength)throw new web.AuthenticationError('Invalid session data (byteLength=0)');this.sessionCookie.set(e,web.Base62.fromBuffer(r))}clear(e){for(const t of Object.keys(e.identity))'id'!==t&&'address'!==t&&delete e.identity[t];this.sessionCookie.clear(e)}},__decorate([web.singleton(),__metadata('design:type',SessionCookieManager)],exports.WebSessionService.prototype,'sessionCookie',void 0),exports.WebSessionService=__decorate([web.service()],exports.WebSessionService);class WebIdentity{}class WebFoundationApplication extends web.WebApplication{get root(){const e=this.onCreatingRootDirectory();return web.defineProperty(this,'root',e),e}directory(e=''){return this.root.directory(e)}file(e){return this.root.file(e)}get session(){const e=this.onCreatingWebSessionService();return web.defineProperty(this,'session',e),e}onCreatingWebSessionService(){return this.construct(exports.WebSessionService)}onCreatingRootDirectory(){return web.Directory.withReadPermission(process.cwd())}onCreatingRequestIdentity(e){const t=new WebIdentity;t.id=web.RequestIdentityHelper.getDeviceId(e)||web.RequestIdentityHelper.createDeviceId(e),t.address=web.RequestIdentityHelper.createRequestAddress(e);const o=this.session.create(e);return o?Object.assign(t,o):t}}const SYSTEM_MAX_UPLOAD_SIZE=15728640,SYSTEM_MAX_CHUNK_SIZE=262144,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1;var OIDC_PROFILE_IMAGE_POLICIES;(function(e){e.REDIRECT='redirect',e.PROXY='proxy',e.AUTO='auto'})(OIDC_PROFILE_IMAGE_POLICIES||(OIDC_PROFILE_IMAGE_POLICIES={}));class WebFoundationSettings extends web.WebApplicationSettings{constructor(){super(...arguments),this.TRUSTED_EMAIL_PROVIDERS=[],this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[],this.WEB_SESSION_COOKIE_PATH='/api',this.WEB_SESSION_COOKIE_KEY='y',this.WEB_SESSION_COOKIE_SECRET=['1234567890abcdefgh'],this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEB_SIGNIN_PATH='/authentication/signin',this.WEB_SIGNIN_SUCCESS_PATH='/authentication/validate',this.WEB_SIGNIN_FAILED_PATH='/authentication/failed',this.WEB_ACCESS_DENIED_PATH='/authentication/access_denied',this.WEB_SIGNOUT_PATH='/authentication/signout',this.WEB_SIGNOUT_COMPLETE_PATH='/',this.MAX_NUMBER_OF_ACCOUNTS_PER_USER=SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,this.MAX_UPLOAD_SIZE=SYSTEM_MAX_UPLOAD_SIZE,this.MAX_CHUNK_SIZE=SYSTEM_MAX_CHUNK_SIZE,this.OIDC_PROFILE_IMAGE_POLICY=OIDC_PROFILE_IMAGE_POLICIES.REDIRECT}}const nodeFetch=require('node-fetch');function parseHTTPRequestArguments(e){const t=e.length-1;let o=null,r=null;for(let i=0;i<=t;i++)if(!o&&'string'==typeof e[i])o=e[i];else if(!r&&'object'==typeof e[i])r=e[i];else break;return{url:o,init:r}}function SendHTTPRequest(e,t,o){let r='json';const i={method:'get',headers:{"user-agent":e?e.req.headers['user-agent']:'fetch',"x-request-id":e?e.logger.context().req_id:`REQ/${mongodb.CreateIdString()}`},redirect:'error'};if(o){if(o.url&&!t&&(t=o.url),o.method&&(i.method=(o.method+'').toLowerCase()),o.proxy&&e)for(const t of Object.keys(e.req.headers))i.headers[t.toLowerCase()]=e.req.headers[t];if(o.credentials&&e&&(i.headers.authorization='Bearer '+e.domain.token),o.headers)for(const e of Object.keys(o.headers))i.headers[e.toLowerCase()]=o.headers[e];o.data&&(i.body=o.data),o.agent&&(i.agent=o.agent),'boolean'==typeof o.compress&&(i.compress=o.compress),'number'==typeof o.follow&&(i.follow=o.follow),'number'==typeof o.size&&(i.size=o.size),'number'==typeof o.timeout&&(i.timeout=o.timeout),o.responseType&&(r=o.responseType)}if(i.method=i.method||'get',!t)throw new Error('InvalidURL');return nodeFetch(t,i).then(o=>{if(console.log('res'),e){const t=o.headers.get('server-timing');if(t&&t.length)for(const o of t)e.res.headers.append('server-timing',o)}const i={ok:o.ok,url:o.url,redirected:o.url!=t,headers:o.headers,status:o.status};if(!r||'json'===r)return o.json().then(e=>(Array.isArray(e)?i.results=e:i.result=e,i));if('stream'===r)i.stream=o.body||void 0;else{if('arraybuffer'===r)return o.arrayBuffer().then(e=>(i.data=e,i));if('blob'===r)return o.blob().then(e=>(i.data=e,i))}return i},e=>{throw console.log(e),e})}class InternalContextDomain{constructor(e,t){this.ctx=e,this.db=t}dispose(e){this.disposing=!0,delete this.ctx,delete this.db}get identity(){return this.ctx.identity}get resolver(){return this.ctx.req.resolver}construct(e,t,o){return this.resolver.construct(e,t,o)}resolve(e,t,o){return this.resolver.resolve(e,t,o)}get settings(){return this.ctx.settings}has(e){return Reflect.has(this.ctx.settings,e)}set(e,t){return this.ctx.set(e,t)}get logger(){return this.ctx.logger}get token(){throw new Error('Not Implemented')}collection(e){if(!this.db)throw new Error('Database support is disabled');return this.db.collection(e)}trace(e,t,...o){this.logger.trace.apply(this.logger,arguments)}debug(e,t,...o){this.logger.debug.apply(this.logger,arguments)}log(e,t,...o){this.logger.log.apply(this.logger,arguments)}info(e,t,...o){this.logger.info.apply(this.logger,arguments)}warn(e,t,...o){this.logger.warn.apply(this.logger,arguments)}error(e,t,...o){this.logger.error.apply(this.logger,arguments)}fatal(e,t,...o){this.logger.fatal.apply(this.logger,arguments)}child(e){return this.logger.child(e)}update(e){return this.logger.update(e)}context(){return this.logger.context()}async fetch(){const{url:e,init:t}=parseHTTPRequestArguments(arguments);return SendHTTPRequest(this.ctx,e,t)}}class Database extends mongodb.MongoDatabase{constructor(e,t){super(e,t),this.identity=e.identity}audit(e,t={},o){return'boolean'==typeof o&&(t[''+e]=o),t[''+e+'At']=new Date,t[''+e+'From']=this.identity.address+'/id/'+this.identity.id,t[''+e+'By']=this.identity.profile,t}}var _a;class WebFoundationController extends web.WebController{async[_a=Symbol('Upgrade')](e,t){if(e.domain=e.settings.MONGODB_URL?new InternalContextDomain(e,(await e.resolve(Database))):new InternalContextDomain(e),e.identity&&e.identity.profile){const t=e.identity.profile;if(t&&t._id&&t._id.toString){const o=t._id.toString();e.state.uid=o,e.req.logger.update({uid:o})}}return t().then(t=>{const o=e.domain;return delete e.domain,o.dispose(!0),t},t=>{const o=e.domain;return delete e.domain,o.dispose(!0),Promise.reject(t)})}async getFailureURL(e,t){if(e.settings.WEB_SIGNIN_FAILED_PATH){const{req_id:o}=e.logger.context(),r={req_id:o,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEB_SIGNIN_FAILED_PATH+'?'+querystring.stringify(r)}throw new web.Exception(t,'"WEB_SIGNIN_FAILED_PATH" is not set')}}__decorate([web.middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],WebFoundationController.prototype,_a,null);class DatabaseError extends web.HttpError{get statusCode(){return 503}get statusMessage(){return'Database Error'}}class ValidationError extends web.HttpError{get statusCode(){return 400}get statusMessage(){return'Validation Error'}}class RoleAttribute{constructor(e){this.role=e}beforeDecorate(e,t,o){return!0}getInterceptor(){return this}intercept(e,t){const o=t[0];if(!o.identity.user)throw new web.AuthenticationError(`Please sign in`);if(!o.identity.roles||!o.identity.roles.includes(this.role))throw new web.PermissionError(`Require ${this.role} permission`);return e.invoke(t)}}function user(){return agentframework.decorateClassMethod(new RoleAttribute('user'))}function admin(){return agentframework.decorateClassMethod(new RoleAttribute('admin'))}function role(e){return agentframework.decorateClassMethod(new RoleAttribute(e))}const sizeUnits=['B','KB','MB','GB','TB','PB'],timespanUnits=[{displayName:'d',value:864e5},{displayName:'h',value:36e5},{displayName:'m',value:6e4},{displayName:'s',value:1e3}];function formatTime(e){return 1e3>e?'':6e4>e?formatNumber(e,{format:'time',start:3,end:4}):formatNumber(e,{format:'time',start:1,end:3})}function formatNumber(e,o){if('percentage'===o.format){const t=new Intl.NumberFormat;return t.format(100*e)+'%'}if('time'===o.format){let r='',i=e;const n=o.end||timespanUnits.length;for(let e=o.start||0;e<n;e++){const t=timespanUnits[e],o=Math.floor(i/t.value);i-=o*t.value,r&&(r+=' '),r=r+o+t.displayName}return r}if('byte'===o.format){if(isNaN(e)||!isFinite(e))return'?';let t=0;for(;1024<=e;)e/=1024,t++;return e.toFixed(t?2:0)+' '+sizeUnits[t]}if('currency'===o.format){const t=new Intl.NumberFormat('en-US',{style:'currency',currency:o.format_currency_code||'USD'});return t.format(e)}if('number'===o.format){const t=new Intl.NumberFormat;return t.format(e)}return e+''}class Time{static duration(e,t){const o=t.getTime()-e.getTime();return formatTime(o)}}function merge(...e){return Object.assign({},e.map(e=>e||{}))}class Fetcher extends WebFoundationService{constructor(e,t){super(e),this.ctx=t||null}async fetch(){const{url:e,init:t}=parseHTTPRequestArguments(arguments);return SendHTTPRequest(this.ctx,e,t)}}class ImmutableModel extends mongodb.MongoModel{}__decorate([mongodb.property(),__metadata('design:type',Date)],ImmutableModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],ImmutableModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],ImmutableModel.prototype,'createdBy',void 0);class Model extends ImmutableModel{}__decorate([mongodb.property(),__metadata('design:type',Date)],Model.prototype,'expireAt',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],Model.prototype,'updatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'updatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],Model.prototype,'updatedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],Model.prototype,'activated',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],Model.prototype,'activatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'activatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],Model.prototype,'activatedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'activatedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],Model.prototype,'blocked',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],Model.prototype,'blockedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'blockedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],Model.prototype,'blockedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'blockedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],Model.prototype,'deleted',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],Model.prototype,'deletedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'deletedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],Model.prototype,'deletedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],Model.prototype,'deletedReason',void 0);class Collection extends mongodb.MongoCollection{static[web.Symbols.Initializer](e,t){const o=t||e;let r;t&&t.settings.MONGODB_URL&&t.settings.MONGODB_URL!==e.settings.MONGODB_URL?(r=t,r.logger.log({collection:this.name},'Resolving mongodb client from user scope for new collection')):r=e;const i=r.construct(mongodb.MongoClient);return i.connected?o.construct(Database).collection(this):(i.logger.log({collection:this.name},'MongoClient is not ready, trying connecting database'),i.connect().then(()=>o.construct(Database).collection(this)))}}class Validator{static validate(e){if(!e)throw new ValidationError(`model should not be null`);if(e.deleted)if(e.deletedAt)throw new ValidationError(`${e.getType()} has been deleted at ${e.deletedAt.toISOString()}`);else throw new ValidationError(`${e.getType()} has been deleted`);if(e.blocked)if(e.blockedAt)throw new ValidationError(`${e.getType()} has been blocked at ${e.blockedAt.toISOString()}`);else throw new ValidationError(`${e.getType()} has been blocked`);if(e.expireAt&&e.expireAt.getTime()<Date.now())throw new ValidationError(`${e.getType()} has been expired at ${e.expireAt.toISOString()}`)}}class VertexModel extends Model{}exports.EdgeModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',String)],exports.EdgeModel.prototype,'outType',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EdgeModel.prototype,'label',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EdgeModel.prototype,'inType',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.EdgeModel.prototype,'outV',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.EdgeModel.prototype,'inV',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.EdgeModel.prototype,'meta',void 0),exports.EdgeModel=__decorate([mongodb.model('edge')],exports.EdgeModel);let EdgeSymbolKey=Symbol('agentframework.mongodb.graph.edge');class EdgeCollection extends Collection{constructor(e){super(e,exports.EdgeModel)}findInVertices(e,t,o,r){const i=o.getType();return this.aggregation({filter:r?{outV:e,outType:t,label:r,inType:i}:{outV:e,outType:t,inType:i},lookup:{inV:i}}).then(e=>{const t=[];return e.forEach(e=>{const r=o.wrap(e.inV)||{deleted:!0};Reflect.set(r,EdgeSymbolKey,e),t.push(r)}),t})}findOutVertices(e,t,o,r){const i=o.getType();return this.aggregation({filter:r?{inV:e,inType:t,label:r,outType:i}:{inV:e,inType:t,outType:i},lookup:{outV:i}}).then(e=>{const t=[];return e.forEach(e=>{const r=o.wrap(e.outV)||{deleted:!0};Reflect.set(r,EdgeSymbolKey,e),t.push(r)}),t})}outV(e,t,o={},r={},i={}){return this.aggregation({filter:merge(o,{outV:e,label:t}),lookup:{inV:t},projection:r,sort:i})}inV(e,t,o,r={},i={},n={}){return this.aggregation({filter:merge(r,{inV:e,label:t}),lookup:{outV:o},projection:i,sort:n})}removeRelationships(e){return Promise.all([this.find({outV:e}).then(e=>e.results),this.find({inV:e}).then(e=>e.results)]).then(([e,t])=>e.length||t.length?this.deleteMany([...e,...t]):[])}static getIndices(){return[{name:'unique_relationship',key:{inV:1,inType:1,label:1,outV:1,outType:1},unique:!0},{name:'index_outV_outType_inV_inType',key:{outV:1,outType:1,inV:1,inType:1}},{name:'index_outV_outType_label_inType',key:{outV:1,outType:1,label:1,inType:1}},{name:'index_outV_outType_label',key:{outV:1,outType:1,label:1}},{name:'index_outV_outType_inType',key:{outV:1,outType:1,inType:1}},{name:'index_outV_outType',key:{outV:1,outType:1}},{name:'index_inV_inType_label_inType',key:{inV:1,inType:1,label:1,outType:1}},{name:'index_inV_inType_label',key:{inV:1,inType:1,label:1}},{name:'index_inV_inType_inType',key:{inV:1,inType:1,outType:1}},{name:'index_inV_inType',key:{inV:1,inType:1}},{name:'index_deleted',key:{deleted:1}},{name:'index_blocked',key:{blocked:1}}]}createIndices(){return super.createIndex(EdgeCollection.getIndices())}}exports.EmailModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.EmailModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.EmailModel.prototype,'verified',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.EmailModel.prototype,'verifiedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.EmailModel.prototype,'verifiedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'verifiedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'verifiedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'verifyToken',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.EmailModel.prototype,'verifyTokenFailures',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.EmailModel.prototype,'verifyTokenExpires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.EmailModel.prototype,'resetPasswordAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'resetPasswordFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.EmailModel.prototype,'resetPasswordBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EmailModel.prototype,'resetPasswordToken',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.EmailModel.prototype,'resetPasswordTokenFailures',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.EmailModel.prototype,'resetPasswordTokenExpires',void 0),exports.EmailModel=__decorate([mongodb.model('email')],exports.EmailModel);class EmailCollection extends Collection{constructor(e){super(e,exports.EmailModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(EmailCollection.getIndices())}}exports.MobileModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.MobileModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.MobileModel.prototype,'verified',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.MobileModel.prototype,'verifiedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.MobileModel.prototype,'verifiedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'verifiedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'verifiedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'verifyToken',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.MobileModel.prototype,'verifyTokenFailures',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.MobileModel.prototype,'verifyTokenExpires',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.MobileModel.prototype,'resetPasswordAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'resetPasswordFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.MobileModel.prototype,'resetPasswordBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.MobileModel.prototype,'resetPasswordToken',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.MobileModel.prototype,'resetPasswordTokenFailures',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.MobileModel.prototype,'resetPasswordTokenExpires',void 0),exports.MobileModel=__decorate([mongodb.model('mobile')],exports.MobileModel);class MobileCollection extends Collection{constructor(e){super(e,exports.MobileModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(MobileCollection.getIndices())}}exports.ExternalProviderModel=class e extends Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):'{}',expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):'{}'}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}},__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'provider',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'providerProtocol',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'providerURL',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'providerFingerprint',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalProviderModel.prototype,'providerConfiguration',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'appID',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'appSecret',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'scope',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'displayImageURL',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'description',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalProviderModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ExternalProviderModel.prototype,'createdBy',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalProviderModel.prototype,'expireAt',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalProviderModel.prototype,'updatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalProviderModel.prototype,'updatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ExternalProviderModel.prototype,'updatedBy',void 0),exports.ExternalProviderModel=__decorate([mongodb.model('external_provider')],exports.ExternalProviderModel);class ExternalProviderCollection extends Collection{constructor(e){super(e,exports.ExternalProviderModel)}static getIndices(){return[{name:'unique_external_provider',key:{provider:1,providerProtocol:1,providerURL:1,appID:1},unique:!0}]}createIndices(){return super.createIndex(ExternalProviderCollection.getIndices())}}exports.ExternalUserModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'uid',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'provider',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'providerProtocol',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.ExternalUserModel.prototype,'providerId',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'providerData',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'userData',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.ExternalUserModel.prototype,'identities',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'username',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'domain',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'email',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'emailCertified',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'mobile',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'mobileCertified',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'displayImageURL',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.ExternalUserModel.prototype,'displayImageFile',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'familyName',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'givenName',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'gender',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'dob',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'status',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'bio',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'homepage',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ExternalUserModel.prototype,'locale',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'blocked',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalUserModel.prototype,'blockedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'blockedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ExternalUserModel.prototype,'blockedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'blockedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.ExternalUserModel.prototype,'deleted',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ExternalUserModel.prototype,'deletedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'deletedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ExternalUserModel.prototype,'deletedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ExternalUserModel.prototype,'deletedReason',void 0),exports.ExternalUserModel=__decorate([mongodb.model('external_user')],exports.ExternalUserModel);class ExternalUserCollection extends Collection{constructor(e){super(e,exports.ExternalUserModel)}static getIndices(){return[{name:'unique_external_user',key:{provider:1,providerProtocol:1,uid:1},unique:!0},{name:'index_provider',key:{provider:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(ExternalUserCollection.getIndices())}}exports.SessionModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'device',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'provider',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.SessionModel.prototype,'providerId',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.SessionModel.prototype,'authenticator',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.SessionModel.prototype,'authenticationToken',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.SessionModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.SessionModel.prototype,'roles',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.SessionModel.prototype,'token',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.SessionModel.prototype,'tokens',void 0),__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],exports.SessionModel.prototype,'previous',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.SessionModel.prototype,'impersonated',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.SessionModel.prototype,'impersonatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'impersonatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.SessionModel.prototype,'impersonatedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'impersonatedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.SessionModel.prototype,'blocked',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.SessionModel.prototype,'blockedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'blockedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.SessionModel.prototype,'blockedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'blockedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.SessionModel.prototype,'deleted',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.SessionModel.prototype,'deletedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'deletedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.SessionModel.prototype,'deletedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.SessionModel.prototype,'deletedReason',void 0),exports.SessionModel=__decorate([mongodb.model('session')],exports.SessionModel);class SessionCollection extends Collection{constructor(e){super(e,exports.SessionModel)}static getIndices(){return[{name:'expires',key:{expireAt:1},expireAfterSeconds:0,sparse:!0}]}createIndices(){return super.createIndex(SessionCollection.getIndices())}}exports.UserModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',Number)],exports.UserModel.prototype,'id',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'displayImageURL',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.UserModel.prototype,'signature',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.UserModel.prototype,'location',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.UserModel.prototype,'address',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'email',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'mobile',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.UserModel.prototype,'roles',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.UserModel.prototype,'identities',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.UserModel.prototype,'settings',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'theme',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'timezone',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'locale',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'password',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'passwordSalt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'paymentPassword',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.UserModel.prototype,'paymentPasswordSalt',void 0),exports.UserModel=__decorate([mongodb.model('user')],exports.UserModel);class UserCollection extends Collection{constructor(e){super(e,exports.UserModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(UserCollection.getIndices())}}exports.ApfsFileChunkModel=class e extends ImmutableModel{},__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ApfsFileChunkModel.prototype,'hash',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileChunkModel.prototype,'type',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileChunkModel.prototype,'byteLength',void 0),__decorate([mongodb.property(),__metadata('design:type',Buffer)],exports.ApfsFileChunkModel.prototype,'data',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileChunkModel.prototype,'dataOffset',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileChunkModel.prototype,'dataByteLength',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileChunkModel.prototype,'dataEncoding',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ApfsFileChunkModel.prototype,'expireAt',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ApfsFileChunkModel.prototype,'createdAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileChunkModel.prototype,'createdFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ApfsFileChunkModel.prototype,'createdBy',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.ApfsFileChunkModel.prototype,'updatedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileChunkModel.prototype,'updatedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.ApfsFileChunkModel.prototype,'updatedBy',void 0),exports.ApfsFileChunkModel=__decorate([mongodb.model('apfs_chunk')],exports.ApfsFileChunkModel);class ApfsFileChunkCollection extends Collection{constructor(e){super(e,exports.ApfsFileChunkModel)}static getIndices(){return[{name:'unique_chunk',key:{"hash.md5":1,"hash.sha1":1,"hash.sha256":1,"hash.ipfs":1},unique:!0,sparse:!0},{name:'index_hash_1',key:{"hash.md5":'hashed'}},{name:'index_hash_2',key:{"hash.sha1":'hashed'}},{name:'index_hash_3',key:{"hash.sha256":'hashed'}},{name:'index_hash_4',key:{"hash.ipfs":'hashed'}}]}createIndices(){return super.createIndex(ApfsFileChunkCollection.getIndices())}}exports.ApfsFileModel=class e extends Model{toUrl(){return'apfs://'+this.path}},__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileModel.prototype,'path',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileModel.prototype,'type',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileModel.prototype,'byteLength',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.ApfsFileModel.prototype,'originalname',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileModel.prototype,'width',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileModel.prototype,'height',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.ApfsFileModel.prototype,'duration',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ApfsFileModel.prototype,'hash',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.ApfsFileModel.prototype,'chunks',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ApfsFileModel.prototype,'context',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.ApfsFileModel.prototype,'stats',void 0),__decorate([mongodb.property(),__metadata('design:type',Array)],exports.ApfsFileModel.prototype,'tokens',void 0),__decorate([mongodb.property(),__metadata('design:type',web.ObjectId)],exports.ApfsFileModel.prototype,'previous',void 0),exports.ApfsFileModel=__decorate([mongodb.model('apfs_file')],exports.ApfsFileModel);class ApfsFileCollection extends Collection{constructor(e){super(e,exports.ApfsFileModel)}static getIndices(){return[{name:'unique_file',key:{path:1},unique:!0,sparse:!0}]}createIndices(){return super.createIndex(ApfsFileCollection.getIndices())}}(function(e){e.SIGN_UP='sign-up',e.SIGN_UP_FAILED='sign-up-failed',e.SIGN_IN='sign-in',e.SIGN_IN_FAILED='sign-in-failed',e.SIGN_OUT='sign-out',e.SESSION_EXPIRED='session-expired',e.ACCESS_DENIED='access-denied'})(exports.EventType||(exports.EventType={})),exports.EventModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',Number)],exports.EventModel.prototype,'id',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.EventModel.prototype,'type',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.EventModel.prototype,'context',void 0),exports.EventModel=__decorate([mongodb.model('event')],exports.EventModel);class EventCollection extends Collection{constructor(e){super(e,exports.EventModel)}static getIndices(){return[{name:'unique_event_id',key:{id:1},unique:!0}]}createIndices(){return super.createIndex(EventCollection.getIndices())}}let StripeCustomerModel=class e extends Model{};__decorate([mongodb.property(),__metadata('design:type',mongodb.ObjectId)],StripeCustomerModel.prototype,'user',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'customerId',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],StripeCustomerModel.prototype,'blocked',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],StripeCustomerModel.prototype,'blockedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'blockedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],StripeCustomerModel.prototype,'blockedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'blockedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],StripeCustomerModel.prototype,'deleted',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],StripeCustomerModel.prototype,'deletedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'deletedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],StripeCustomerModel.prototype,'deletedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'deletedReason',void 0),StripeCustomerModel=__decorate([mongodb.model('payment_stripe_customer')],StripeCustomerModel);class StripeCustomerCollection extends Collection{constructor(e){super(e,StripeCustomerModel)}static getIndices(){return[{name:'unique_payment_stripe',key:{user:1},unique:!0}]}createIndices(){return super.createIndex(StripeCustomerCollection.getIndices())}}exports.OrganizationModel=class e extends VertexModel{},__decorate([mongodb.property(),__metadata('design:type',Number)],exports.OrganizationModel.prototype,'id',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'name',void 0),__decorate([mongodb.property(),__metadata('design:type',web.ObjectId)],exports.OrganizationModel.prototype,'owner',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'displayName',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'displayImageURL',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.OrganizationModel.prototype,'settings',void 0),__decorate([mongodb.property(),__metadata('design:type',Boolean)],exports.OrganizationModel.prototype,'verified',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.OrganizationModel.prototype,'verifiedAt',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'verifiedFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.OrganizationModel.prototype,'verifiedBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'verifiedReason',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.OrganizationModel.prototype,'verifyToken',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.OrganizationModel.prototype,'verifyTokenFailures',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.OrganizationModel.prototype,'verifyTokenExpires',void 0),exports.OrganizationModel=__decorate([mongodb.model('organization')],exports.OrganizationModel);class OrganizationCollection extends Collection{constructor(e){super(e,exports.OrganizationModel)}static getIndices(){return[{name:'unique_organization_id',key:{id:1},unique:!0},{name:'unique_organization_name',key:{name:1},unique:!0}]}createIndices(){return super.createIndex(OrganizationCollection.getIndices())}makeIdQuery(e){let t;if(e instanceof web.ObjectId)t={_id:e};else if('number'==typeof e){if(isNaN(e))throw new Error('Organization id should not be an NaN');t={id:e}}else t={name:e+''};return t}}exports.CronJobModel=class e extends Model{},__decorate([mongodb.property(),__metadata('design:type',String)],exports.CronJobModel.prototype,'cron',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.CronJobModel.prototype,'intervalInSeconds',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.CronJobModel.prototype,'nextScheduleAt',void 0),__decorate([mongodb.property(),__metadata('design:type',Date)],exports.CronJobModel.prototype,'lastScheduleAt',void 0),__decorate([mongodb.property(),__metadata('design:type',web.IdentityProfile)],exports.CronJobModel.prototype,'lastScheduleBy',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.CronJobModel.prototype,'lastScheduleFrom',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.CronJobModel.prototype,'lastScheduleRetries',void 0),__decorate([mongodb.property(),__metadata('design:type',Number)],exports.CronJobModel.prototype,'lastScheduleDuration',void 0),__decorate([mongodb.property(),__metadata('design:type',String)],exports.CronJobModel.prototype,'lastScheduleResult',void 0),__decorate([mongodb.property(),__metadata('design:type',Object)],exports.CronJobModel.prototype,'payload',void 0),exports.CronJobModel=__decorate([mongodb.model('cronjob')],exports.CronJobModel);class CronJobCollection extends Collection{constructor(e){super(e,exports.CronJobModel)}static getIndices(){return[{name:'unique_key',key:{key:1},unique:!0,sparse:!0},{name:'index_nextScheduleAt',key:{nextScheduleAt:1}},{name:'index_lastScheduleAt',key:{lastScheduleAt:1}},{name:'index_blocked',key:{blocked:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(CronJobCollection.getIndices())}}exports.AdminService=class e extends WebFoundationService{constructor(e){super(e)}async createIndices(e){const t=[await e.collection(ApfsFileChunkCollection).createIndices(),await e.collection(ApfsFileCollection).createIndices(),await e.collection(EventCollection).createIndices(),await e.collection(ExternalProviderCollection).createIndices(),await e.collection(ExternalUserCollection).createIndices(),await e.collection(EdgeCollection).createIndices(),await e.collection(SessionCollection).createIndices(),await e.collection(StripeCustomerCollection).createIndices(),await e.collection(OrganizationCollection).createIndices(),await e.collection(CronJobCollection).createIndices(),await e.collection(EmailCollection).createIndices(),await e.collection(MobileCollection).createIndices(),await e.collection(UserCollection).createIndices()];return t}},exports.AdminService=__decorate([web.service(),__metadata('design:paramtypes',[WebFoundationApplication])],exports.AdminService);const ApfsFileMetadataFields=['originalname','duration','width','height','type'];exports.ApfsService=class e extends web.Resolvable{get name(){return'ApfsService'}parse(e){try{const t=new url.URL(e);return'apfs:'===t.protocol?{filename:t.pathname}:null}catch(e){return null}}async download(e,t,o=!1){return axios({method:'get',url:t,responseType:'stream'}).then(e=>e,e=>(this.logger.warn(e,`Unable to fetch remote url ${t}`),null))}async save(e,t,o=!1){const r=t.filename,i={md5:crypto.createHash('md5').update(t.data).digest(),sha1:crypto.createHash('sha1').update(t.data).digest(),sha256:crypto.createHash('sha256').update(t.data).digest()},n=e.collection(ApfsFileCollection),d=await n.findOne({path:r});let a=!1;if(d){if(!o)throw new Error(`File ${r} already exists`);let e=!0;for(const o of ApfsFileMetadataFields)'undefined'!=typeof t[o]&&(e=e&&d[o]===t[o]);let s=!0;if(s=s&&Buffer.isBuffer(d.hash.md5)&&0===Buffer.compare(i.md5,d.hash.md5),s=s&&Buffer.isBuffer(d.hash.sha1)&&0===Buffer.compare(i.sha1,d.hash.sha1),s=s&&Buffer.isBuffer(d.hash.sha256)&&0===Buffer.compare(i.sha256,d.hash.sha256),e&&s)return this.logger.trace({fileType:d.type,byteLength:d.byteLength},`Ignore updating same file ${d._id} at apfs://${r}`),d;if(!s){a=!0;const e=await n.findOneAndUpdate({_id:d._id},{$unset:{path:''}});this.logger.trace({fileType:d.type,byteLength:d.byteLength,unlinked:!!e},`Unlinked file ${d._id} from apfs://${r}`)}}else a=!0;let s;if(a){const o=e.collection(ApfsFileChunkCollection),{n:r,results:n}=await o.find({$and:[{"hash.md5":i.md5},{"hash.sha1":i.sha1},{"hash.sha256":i.sha256}]},{data:0});if(r!==n.length)throw new Error('Too many chunks for a hash, sha256='+i.sha256);if(!r){const r=t.data.byteLength;if(r>e.settings.MAX_UPLOAD_SIZE)throw new web.PayloadTooLargeError('Buffer size over system limit');const d=await o.insertOne({hash:i,type:t.type,byteLength:r,data:t.data,dataOffset:0,dataByteLength:t.data.byteLength,dataEncoding:'binary'});d&&n.push(d)}if(!n.length)throw new Error('unable to find or save file chunk');const d=n.reduce((e,t)=>e+t.dataByteLength,0);s={byteLength:d,hash:i,chunks:n.map(e=>({_id:e._id,offset:e.dataOffset,byteLength:e.dataByteLength}))}}else s={};for(const r of ApfsFileMetadataFields)'undefined'!=typeof t[r]&&(s[r]=t[r]);d&&(s.previous=d._id);const p=await n.findOneAndUpsert({path:t.filename},{$setOnInsert:{path:t.filename,name:path.basename(t.filename),stats:{update:0,read:0},tokens:[],context:null},$set:s},{_id:1});if(!p)throw new Error('Unable to save ');return n.findOneAndUpdate({_id:p._id},{$inc:{"stats.update":1}}).then(e=>e||p)}async load(e,t){const o=this.parse(t);if(!o)throw new Error('Invalid apfs url '+t);const r=o.filename,i=await e.collection(ApfsFileCollection),n=e.collection(ApfsFileChunkCollection),d=await i.findOneAndUpdate({path:r},{$inc:{"stats.read":1}});if(d&&d.chunks&&d.chunks.length){const e=d.chunks.map(e=>e._id),{results:t}=await n.find({_id:{$in:e}}),o=new Buffer(d.byteLength);for(const e of t)if(Buffer.isBuffer(e.data))e.data.copy(o,e.dataOffset);else throw new Error(`Invalid chunk, id: ${e._id} from: ${e.dataOffset} to: ${e.dataByteLength}`);return{filename:d.path,type:d.type,data:o,byteLength:d.byteLength,hash:d.hash,context:d.context,stats:d.stats,width:d.width,height:d.height,duration:d.duration,originalname:d.originalname,createdAt:d.createdAt,updatedAt:d.updatedAt}}return null}},exports.ApfsService=__decorate([web.service()],exports.ApfsService);class ApfsFile{}class Security{static encrypt(e){const t=crypto.randomBytes(16),o=crypto.randomBytes(32),r=crypto.createCipheriv('aes-256-cbc',o,t);let i=r.update(e);return i=Buffer.concat([i,r.final()]),{data:i.toString('hex'),salt:t.toString('hex')+'n'+o.toString('hex')}}static decrypt(e){const t=e.salt.split('n'),o=Buffer.from(t[0],'hex'),r=Buffer.from(t[1],'hex'),i=crypto.createDecipheriv('aes-256-cbc',r,o);let n=i.update(Buffer.from(e.data,'hex'));return n=Buffer.concat([n,i.final()]),n.toString()}}class EmailGetters{static async findOneByEmail(e,t){const o=e.collection(EmailCollection);return o.findOne({name:t})}static async findOneByUser(e,t){const o=e.collection(EmailCollection);return o.findOne({user:t})}}class UserGetters{static findOneById(e,t){const o=e.collection(UserCollection);return o.findOneById(t)}static findOneByName(e,t){const o=e.collection(UserCollection);return o.findOne({name:t})}}class UserMutations{static async insertOne(e,t){if(!t)throw new TypeError('user to insert should not be null');if(!t.displayName)throw new TypeError('displayName is required');const o=e.collection(UserCollection);return t.settings||(t.settings={}),o.insertOne(t).then(e=>{if(!e)throw new DatabaseError({user:t},'Unable to create user');return e})}static async updateUser(e,t,o,r){const i=e.collection(UserCollection);return i.findOneAndUpdate({_id:new web.ObjectId(t)},{$set:{[o]:r}})}static async updateUserFields(e,t,o){const r=e.collection(UserCollection);return r.findOneAndUpdate({_id:new web.ObjectId(t)},{$set:o})}}class MobileGetters{static async findOneByEmail(e,t){const o=e.collection(MobileCollection);return o.findOne({name:t})}static async findOneByUser(e,t){const o=e.collection(MobileCollection);return o.findOne({user:t})}}class UserDataProvider extends WfService{async findOneById(e,t){return UserGetters.findOneById(e,t)}async findOneByName(e,t){return UserGetters.findOneByName(e,t)}async findOneByEmail(e,t){const o=await EmailGetters.findOneByEmail(e,t);return o&&o.user?UserGetters.findOneById(e,o.user):null}insertOne(e,t){return UserMutations.insertOne(e,t)}updateUserFields(e,t,o){return UserMutations.updateUserFields(e,t,o)}updateUser(e,t,o,r){return UserMutations.updateUser(e,t,o,r)}findEmailByUser(e,t){return EmailGetters.findOneByUser(e,t)}findMobileByUser(e,t){return MobileGetters.findOneByUser(e,t)}}exports.UserService=class e extends WfService{get name(){return'UserService'}findEmailByUser(e,t){return this.data.findEmailByUser(e,t)}findMobileByUser(e,t){return this.data.findMobileByUser(e,t)}findOneById(e,t){if(!t)throw new Error('UserIdRequired');return this.data.findOneById(e,t)}findOneByName(e,t){if(!t)throw new Error('UsernameRequired');return this.data.findOneByName(e,t)}async findOneByEmail(e,t){if(!t)throw new TypeError('email is required');return this.data.findOneByEmail(e,t)}async insertOne(e,t){return this.data.insertOne(e,t)}async update(e,t,o,r){if(t){if('password'===o){const o=Security.encrypt(r),i={password:o.data,passwordSalt:o.salt};return this.data.updateUserFields(e,t,i)}return this.data.updateUser(e,t,o,r)}return null}async getCredential(e,t){if(t){const o=await this.data.findOneById(e,t);if(o)return{username:o.name,password:Security.decrypt({data:o.password,salt:o.passwordSalt})}}return null}},__decorate([lib.singleton(),__metadata('design:type',UserDataProvider)],exports.UserService.prototype,'data',void 0),exports.UserService=__decorate([lib.service()],exports.UserService);class CurrentUser extends exports.UserModel{static async[web.Symbols.Initializer](e,t){if(!t)throw new Error('CurrentUser is only resolvable from ctx scope');const o=t.identity.user;return o instanceof web.ObjectId?t.resolve(exports.UserService).then(e=>e.findOneById(t.domain,o).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentUser.prototype),e))):null}}class LineReader{constructor(e,t='\r\n'){this.raw=e,this.linebreak=t,this.pos=0,this.ended=!1}read(){const e=this.raw.indexOf(this.linebreak,this.pos);let t;return 0>e?(this.ended=!0,t=this.raw.slice(this.pos),this.pos=this.raw.length):(t=this.raw.slice(this.pos,e),this.pos=e+this.linebreak.length),t}next(){const e=this.raw.indexOf(this.linebreak,this.pos);0>e?(this.ended=!0,this.pos=this.raw.length):this.pos=e+this.linebreak.length}rest(){const e=this.raw.slice(this.pos);return this.ended=!0,this.pos=this.raw.length,e}end(){return this.ended}}function ParseResponses(e){const t=e.headers.get('content-type'),o=extractBoundaryFromContentType(t),r=[];if(o){let t=e.text.split('--'+o);for(const e of t)e.length&&'--\r\n'!==e&&'--\n'!==e&&r.push(parseResponse(e))}else r.push(parseResponse(e.text));return r}function ParseResponse(e){return parseResponse(e.text)}function extractBoundaryFromContentType(e){if(!e||'string'!=typeof e)return'';const t=e.split(';');return 2>t.length||'multipart/mixed'!==t[0].toLowerCase()||0>t[1].indexOf('=')?'':t[1].split('=')[1]}function parseResponse(e){const t={status:0,statusText:'',headers:new Headers,text:'',json:null};e.startsWith('\r\n')?e=e.slice(2):e.startsWith('\n')&&(e=e.slice(1));for(const o=new LineReader(e);!o.end();){const e=o.read();if(e){const o=e.indexOf(':');if(0<o){const r=e.slice(0,o),i=e.slice(o+2);t.headers.set(r,i)}else{const o=e.split(' ');t.status=+o[1],t.statusText=o.slice(2).join(' ')}}else{const e=o.rest(),r=t.headers.get('content-type');r&&r.startsWith('application/json')?t.json=JSON.parse(e):t.text=e}}return t}const digestLength=32,blockSize=64,K=new Uint32Array([1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298]);function hashBlocks(t,o,e,r,n){for(let s,a,p,l,d,y,c,g,m,u,i,f,h;64<=n;){for(s=o[0],a=o[1],p=o[2],l=o[3],d=o[4],y=o[5],c=o[6],g=o[7],u=0;16>u;u++)i=r+4*u,t[u]=(255&e[i])<<24|(255&e[i+1])<<16|(255&e[i+2])<<8|255&e[i+3];for(u=16;64>u;u++)m=t[u-2],f=(m>>>17|m<<15)^(m>>>19|m<<13)^m>>>10,m=t[u-15],h=(m>>>7|m<<25)^(m>>>18|m<<14)^m>>>3,t[u]=(0|f+t[u-7])+(0|h+t[u-16]);for(u=0;64>u;u++)f=0|(0|((d>>>6|d<<26)^(d>>>11|d<<21)^(d>>>25|d<<7))+(d&y^~d&c))+(0|g+(0|K[u]+t[u])),h=0|((s>>>2|s<<30)^(s>>>13|s<<19)^(s>>>22|s<<10))+(s&a^s&p^a&p),g=c,c=y,y=d,d=0|l+f,l=p,p=a,a=s,s=0|f+h;o[0]+=s,o[1]+=a,o[2]+=p,o[3]+=l,o[4]+=d,o[5]+=y,o[6]+=c,o[7]+=g,r+=64,n-=64}return r}class Hash{constructor(){this.digestLength=digestLength,this.blockSize=blockSize,this.state=new Int32Array(8),this.temp=new Int32Array(64),this.buffer=new Uint8Array(128),this.bufferLength=0,this.bytesHashed=0,this.finished=!1,this.reset()}reset(){return this.state[0]=1779033703,this.state[1]=3144134277,this.state[2]=1013904242,this.state[3]=2773480762,this.state[4]=1359893119,this.state[5]=2600822924,this.state[6]=528734635,this.state[7]=1541459225,this.bufferLength=0,this.bytesHashed=0,this.finished=!1,this}clean(){for(let e=0;e<this.buffer.length;e++)this.buffer[e]=0;for(let e=0;e<this.temp.length;e++)this.temp[e]=0;this.reset()}update(e,t=e.length){if(this.finished)throw new Error('SHA256: can\'t update because hash was finished.');let o=0;if(this.bytesHashed+=t,0<this.bufferLength){for(;64>this.bufferLength&&0<t;)this.buffer[this.bufferLength++]=e[o++],t--;64===this.bufferLength&&(hashBlocks(this.temp,this.state,this.buffer,0,64),this.bufferLength=0)}for(64<=t&&(o=hashBlocks(this.temp,this.state,e,o,t),t%=64);0<t;)this.buffer[this.bufferLength++]=e[o++],t--;return this}finish(e){if(!this.finished){const e=this.bytesHashed,t=this.bufferLength,o=0|e/536870912,r=e<<3,n=56>e%64?64:128;this.buffer[t]=128;for(let e=t+1;e<n-8;e++)this.buffer[e]=0;this.buffer[n-8]=255&o>>>24,this.buffer[n-7]=255&o>>>16,this.buffer[n-6]=255&o>>>8,this.buffer[n-5]=255&o>>>0,this.buffer[n-4]=255&r>>>24,this.buffer[n-3]=255&r>>>16,this.buffer[n-2]=255&r>>>8,this.buffer[n-1]=255&r>>>0,hashBlocks(this.temp,this.state,this.buffer,0,n),this.finished=!0}for(let t=0;8>t;t++)e[4*t+0]=255&this.state[t]>>>24,e[4*t+1]=255&this.state[t]>>>16,e[4*t+2]=255&this.state[t]>>>8,e[4*t+3]=255&this.state[t]>>>0;return this}digest(){const e=new Uint8Array(this.digestLength);return this.finish(e),e}_saveState(e){for(let t=0;t<this.state.length;t++)e[t]=this.state[t]}_restoreState(e,t){for(let o=0;o<this.state.length;o++)this.state[o]=e[o];this.bytesHashed=t,this.finished=!1,this.bufferLength=0}}class HMAC{constructor(e){this.inner=new Hash,this.outer=new Hash,this.blockSize=this.inner.blockSize,this.digestLength=this.inner.digestLength;const t=new Uint8Array(this.blockSize);if(e.length>this.blockSize)new Hash().update(e).finish(t).clean();else for(let o=0;o<e.length;o++)t[o]=e[o];for(let o=0;o<t.length;o++)t[o]^=54;this.inner.update(t);for(let o=0;o<t.length;o++)t[o]^=106;this.outer.update(t),this.istate=new Uint32Array(8),this.ostate=new Uint32Array(8),this.inner._saveState(this.istate),this.outer._saveState(this.ostate);for(let o=0;o<t.length;o++)t[o]=0}reset(){return this.inner._restoreState(this.istate,this.inner.blockSize),this.outer._restoreState(this.ostate,this.outer.blockSize),this}clean(){for(let e=0;e<this.istate.length;e++)this.ostate[e]=this.istate[e]=0;this.inner.clean(),this.outer.clean()}update(e){return this.inner.update(e),this}finish(e){return this.outer.finished?this.outer.finish(e):(this.inner.finish(e),this.outer.update(e,this.digestLength).finish(e)),this}digest(){const e=new Uint8Array(this.digestLength);return this.finish(e),e}}function hmac(e,t){const o=new HMAC(e).update(t),r=o.digest();return o.clean(),r}const fetch=require('node-fetch');class FetchClient{constructor(e={}){this.defaults=e}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),o=Object.assign({},this.defaults.headers,e.headers||{}),r=Object.assign({},this.defaults,e),i=r.headers=new Headers(o),n=new url.URL(r.url);for(const o of Object.keys(t))n.searchParams.append(o,t[o]);return r.data&&(r.body='application/json'===i.get('Content-Type')?JSON.stringify(r.data):r.data,'string'==typeof r.body&&i.append('Content-Length',r.body.length+'')),delete r.url,delete r.query,{url:n.toString(),init:r}}request(e){const{url:t,init:o}=this.makeFetchOptions(e);return fetch(t,o).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get('content-type')||'text/html',body:e,data:{},text:''};return t.type.startsWith('application/json')?t.data=await e.json():t.type.startsWith('text/')&&(t.text=await e.text()),t})}post(e,t,o={}){return o.method='POST',o.url=e,o.data=t,this.request(o)}put(e,t,o={}){return o.method='PUT',o.url=e,o.data=t,this.request(o)}get(e,t={}){return t.method='GET',t.url=e,this.request(t)}delete(e,t={}){return t.method='DELETE',t.url=e,this.request(t)}}class TableStorageRestClient extends FetchClient{constructor(e,t){super(),this.account=e,this.key=t,this.endpointSuffix='core.windows.net',this.timeoutInSeconds=30,this.version='2018-03-28'}request(e){return super.request(e).then(this.throwErrorForNon2xxCode)}post(e,t,o={}){return super.post(e,t,o).then(this.throwErrorForNon2xxCode)}put(e,t,o={}){return super.put(e,t,o).then(this.throwErrorForNon2xxCode)}merge(e,t,o={}){return o.method='MERGE',o.url=e,o.data=t,super.request(o).then(this.throwErrorForNon2xxCode)}get(e,t={}){return super.get(e,t).then(this.throwErrorForNon2xxCode)}delete(e,t={}){return super.delete(e,t).then(this.throwErrorForNon2xxCode)}makeAuthorizationHeader(e,t){const o=new Date,r=o.toUTCString()+'\n'+`/${this.account}${t}`;return console.log('sig --->',JSON.stringify(r)),{Accept:'application/json;odata=fullmetadata',Authorization:`SharedKeyLite ${this.account}:${this.sign(r)}`,"Content-Type":'application/json',DataServiceVersion:'3.0',Date:o.toUTCString(),"x-ms-version":'2018-03-28'}}makeRequestUrl(e,t=''){const o='https://'+this.account+'.'+(e||'table')+'.'+this.endpointSuffix;return t?o+t:o}encodeSpecialCharacters(e){return e.replace(/'/g,'%27')}sign(e){const t=Buffer.from(this.key,'base64');return new Buffer(hmac(t,Buffer.from(e,'utf8'))).toString('base64')}throwErrorForNon2xxCode(e){if(e.data&&e.data['odata.error']){const t=e.data['odata.error'].code;throw console.log('unknown error',e.data['odata.error']),new Error(t||e.statusText)}else return e}}class TableStorage extends TableStorageRestClient{constructor(){super(...arguments),this.etags=new WeakMap,this.tableNameRegex=/^[A-Za-z][A-Za-z0-9]{2,62}$/,this.entityNameRegex=/^[A-Za-z0-9\-_.]{1,1023}$/}static[web.Symbols.Initializer](e,t){const o=t?t.settings:e.settings;return new TableStorage(o.AZURE_STORAGE_ACCOUNT,o.AZURE_STORAGE_ACCESS_KEY)}queryTables(){const e=this.makeRequestUrl('table','/Tables'),t=this.makeAuthorizationHeader('table','/Tables');return this.get(e,{headers:t}).then(e=>e.data.value.map(e=>e.TableName))}async createTable(e){if(!this.isValidTableName(e))throw new Error('InvalidTableName');const t=this.makeRequestUrl('table','/Tables'),o=this.makeAuthorizationHeader('table','/Tables');return this.post(t,{TableName:e},{headers:o}).then(e=>e.data.TableName)}async deleteTable(e){if(!this.isValidTableName(e))throw new Error('InvalidTableName');const t=`/Tables(%27${e}%27)`,o=this.makeRequestUrl('table'),r=this.makeAuthorizationHeader('table',t);return this.delete(o+t,{headers:r}).then(()=>e,e=>'ResourceNotFound'===e.message?Promise.reject(new Error('TableNotFound')):Promise.reject(e))}batch(e){return new TableBatchRestClient(this,e)}async insertEntity(t,e){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if(!e)throw new Error('InvalidEntity');if('string'!=typeof e.PartitionKey)throw new Error('InvalidPartitionKey');if('string'!=typeof e.RowKey)throw new Error('InvalidRowKey');const o='/'+t,r=this.makeRequestUrl('table',o),i=this.makeAuthorizationHeader('table',o),n=()=>this.post(r,this.fromEntity(e),{headers:i}).then(e=>this.toEntity(e.data,e.headers));return n().catch(o=>{if('TableNotFound'===o.message)return this.createTable(t).then(()=>n());throw o})}upsertEntity(t,e){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if(!e)throw new Error('InvalidEntity');if('string'!=typeof e.PartitionKey)throw new Error('InvalidPartitionKey');if('string'!=typeof e.RowKey)throw new Error('InvalidRowKey');const o='/'+t+`(PartitionKey=%27${encodeURIComponent(e.PartitionKey)}%27,RowKey=%27${encodeURIComponent(e.RowKey)}%27)`,r=this.makeRequestUrl('table',o),i=this.makeAuthorizationHeader('table',o),n=()=>this.put(r,e,{headers:i}).then(t=>this.toEntity(t.data,t.headers,e));return n().catch(o=>{if('TableNotFound'===o.message)return this.createTable(t).then(()=>n());throw o})}updateEntity(e,t,o,r){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof o)throw new Error('InvalidRowKey');const i='/'+e+`(PartitionKey=%27${encodeURIComponent(t)}%27,RowKey=%27${encodeURIComponent(o)}%27)`,n=this.makeRequestUrl('table',i),d=this.makeAuthorizationHeader('table',i);return d['If-Match']='*',this.merge(n,r,{headers:d}).then(e=>this.toEntity(Object.assign(e.data,r,{PartitionKey:t,RowKey:o}),e.headers,r),e=>'ResourceNotFound'===e.message?Promise.reject(new Error('EntityNotFound')):Promise.reject(e))}deleteEntity(e,t,o,r){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof o)throw new Error('InvalidRowKey');const i='/'+e+`(PartitionKey=%27${encodeURIComponent(t)}%27,RowKey=%27${encodeURIComponent(o)}%27)`,n=this.makeRequestUrl('table',i),d=this.makeAuthorizationHeader('table',i);return d['If-Match']=r||'*',console.log('delete',i),this.delete(n,{headers:d}).then(()=>!0,e=>{if('ResourceNotFound'===e.message)return!1;throw e}).catch(t=>{if('TableNotFound'===t.message)return!0;throw t})}queryEntity(t,e,o){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if('string'!=typeof e)throw new Error('InvalidPartitionKey');if('string'!=typeof o)throw new Error('InvalidRowKey');const r='/'+t+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(o)}%27)`,i=this.makeRequestUrl('table',r),n=this.makeAuthorizationHeader('table',r);return this.get(i,{headers:n}).then(e=>this.toEntity(e.data,e.headers)).catch(o=>{if('TableNotFound'===o.message)return this.createTable(t).then(()=>null);if('ResourceNotFound'===o.message)return null;throw o})}queryEntities(t,e={}){if(!this.isValidTableName(t))throw new Error('InvalidTableName');const o='/'+t+`()`,r=this.makeRequestUrl('table',o),i=this.makeAuthorizationHeader('table',o);return this.get(r,{headers:i,query:e}).then(e=>e.data.value.map(e=>this.toEntity(e))).catch(o=>{if('TableNotFound'===o.message)return this.createTable(t).then(()=>[]);throw o})}queryEntitiesByPartitionKey(e,t){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');const o='/'+e+`()`,r=this.makeRequestUrl('table',o),i=this.makeAuthorizationHeader('table',o);return this.get(r,{headers:i,query:{$filter:`PartitionKey eq '${t}'`}}).then(e=>e.data.value.map(e=>this.toEntity(e))).catch(t=>{if('TableNotFound'===t.message)return[];throw t})}queryEntitiesWithPrefix(e,t,o){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof o)throw new Error('InvalidRowKey');const r='/'+e+`()`,i=this.makeRequestUrl('table',r),n=this.makeAuthorizationHeader('table',r);return this.get(i,{headers:n,query:{$filter:`PartitionKey gt '${t}~' and PartitionKey lt '${t}~~' and RowKey gt '${o}~' and RowKey lt '${o}~~'`}}).then(e=>e.data.value.map(t=>this.toEntity(t,e.headers))).catch(t=>{if('TableNotFound'===t.message)return[];throw t})}getETag(e){return this.etags.get(e)}isValidTableName(e){return!!('string'==typeof e&&2<e.length&&64>e.length)&&'Tables'!==e&&'tables'!==e&&this.tableNameRegex.test(e)}isValidTableEntityName(e){return!!('string'==typeof e&&0<e.length&&1025>e.length)&&this.entityNameRegex.test(e)}fromEntity(e){for(const t of Object.keys(e)){const o=e[t];'[object Date]'===Object.prototype.toString.call(o)&&(e[t+'@odata.type']='Edm.DateTime')}return e}toEntity(e,t,o){const r=e['odata.etag']||e['@odata.etag']||t&&t.get('etag');if(!r)throw new Error('ETagNotFound');this.etags.set(e,r);const i=!e.Timestamp;o&&Object.assign(e,o),i&&(e.Timestamp=decodeURIComponent(r.split('\'')[1]));for(const r of Object.keys(e)){const t=e[r];if(r.startsWith('odata.'))delete e[r];else if(r.endsWith('@odata.type'))if('Edm.DateTime'===t){const t=r.slice(0,-11);e[t]=new Date(e[t]),delete e[r]}else console.log('delete typing without change',r,t),delete e[r]}return e}}class TableBatchResult{}class TableBatchRestClient{constructor(e,t){this.client=e,this.tableName=t,this.batchBoundary='batch_'+Date.now(),this.changesetBoundary='changeset_'+Date.now(),this.payload=[],this.secondaryKeys=new Set,this.count=0}get size(){return this.count}insertEntity(e){this.validate(e.PartitionKey,e.RowKey);const t='/'+this.tableName,o=this.client.makeRequestUrl('table',t);return this.addNewRequest('POST',o,e),this}upsertEntity(e){this.validate(e.PartitionKey,e.RowKey);const t='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e.PartitionKey)}%27,RowKey=%27${encodeURIComponent(e.RowKey)}%27)`,o=this.client.makeRequestUrl('table',t);return this.addNewRequest('MERGE',o,e),this}deleteEntity(e,t,o){this.validate(e,t);const r='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(t)}%27)`,i=this.client.makeRequestUrl('table',r);return this.addNewRequest('DELETE',i,null,o),this}updateEntity(e,t,o){this.validate(e,t);const r='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(t)}%27)`,i=this.client.makeRequestUrl('table',r);return this.addNewRequest('MERGE',i,o),this}commit(){const e=this.client.makeRequestUrl('table','/$batch'),t=this.client.makeAuthorizationHeader('table','/$batch');t['Content-Type']='multipart/mixed; boundary='+this.batchBoundary;const o=[`--${this.batchBoundary}`,`Content-Type: multipart/mixed; boundary=${this.changesetBoundary}`,'',`${this.payload.join('\n')}`,'',`--${this.changesetBoundary}--`,`--${this.batchBoundary}--`,''];return this.client.post(e,o.join('\n'),{headers:t}).then(e=>e.body.text().then(t=>{e.text=t;const o=ParseResponses(e).map(e=>ParseResponses(e).map(e=>ParseResponse(e)));let r;if(o.length&&o[0].length&&o[0][0]){if(r=o[0][0].json,r&&r['odata.error']&&r['odata.error'].code){const{code:e,message:t}=r['odata.error'];if('CommandsInBatchActOnDifferentPartitions'===e)throw new Error('InconstantPrimaryKey');else if('InvalidDuplicateRow'===e)throw new Error('DuplicateSecondaryKey');else if('InvalidInput'===e)throw console.log('error',r['odata.error']),new Error('InvalidRequest');throw console.log('Error commit batch: '+t.value),new Error(e)}return{ok:1,n:o[0].length}}return{ok:1,n:0}}))}validate(e,t){if('string'!=typeof e)throw new Error('InvalidPartitionKey');if('string'!=typeof t)throw new Error('InvalidRowKey');if(this.primaryKey&&e!==this.primaryKey)throw new Error('InconstantPrimaryKey');if(this.primaryKey=e,this.secondaryKeys.has(t))throw new Error('DuplicateSecondaryKey');if(this.secondaryKeys.add(t),100<=this.count)throw new Error('BatchTooLarge');this.count++}addNewRequest(e,t,o,r){this.payload.push('--'+this.changesetBoundary),this.payload.push('Content-Type: application/http'),this.payload.push('Content-Transfer-Encoding: binary'),this.payload.push(''),this.payload.push(`${e} ${t} HTTP/1.1`),this.payload.push('Content-Type: application/json'),this.payload.push('Accept: application/json;odata=fullmetadata'),this.payload.push('DataServiceVersion: 3.0;'),'DELETE'===e?this.payload.push(`If-Match: ${r||'*'}`):o&&(this.payload.push(''),this.payload.push(JSON.stringify(o))),this.payload.push('')}}class AzureKey{constructor(e='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'){this.digits=e.split(''),this.base=e.length,this.last=0,this.lastIndex=0}generate(){return this.fromDateTime(new Date)}convert(e){return e?this.fromDateTime(new Date(e)):this.generate()}fromDateTime(e){var t=Math.floor;const o=3468672e9-100*e.getTime(),r=this.base;let i=o,n='';for(this.last==o?(this.lastIndex++,i=o-this.lastIndex):(this.lastIndex=0,this.last=o);1<=i;)n=this.digits[i-r*t(i/r)]+n,i=t(i/r);return n}}function bufferToStream(e){let t=new stream.Duplex;return t.push(e),t.push(null),t}class StorageService extends WfService{constructor(){super(...arguments),this.key=new AzureKey}static[lib.Symbols.Initializer](e,t){const o=t||e,r=new StorageService(o);return r.identity=o.identity,r.table=new TableStorage(o.settings.AZURE_STORAGE_ACCOUNT,o.settings.AZURE_STORAGE_ACCESS_KEY),r.blob=azureStorage.createBlobService(o.settings.AZURE_STORAGE_ACCOUNT,o.settings.AZURE_STORAGE_ACCESS_KEY),r}async createTable(e){return this.table.createTable(e)}async update(e,t,o,r){return this.table.updateEntity(e,t,o,r)}async updateById(e,t,o){let r=this.parseId(t);return this.table.updateEntity(e,r,'metadata',o)}async updateChild(e,t,o,r,i){const n=`id~${t}`,d=`${o}~${r}`;return this.table.updateEntity(e,n,d,i)}async find(e,t){return this.table.queryEntities(e,t)}async findAll(e){return this.table.queryEntities(e,{$filter:`RowKey eq 'metadata'`})}async findOneById(e,t){let o=this.parseId(t);return this.table.queryEntity(e,o,'metadata')}async findOneChild(e,t,o,r){const i=`id~${t}`,n=`${o}~${r}`;return this.table.queryEntity(e,i,n)}async findAllById(e,t){const o={$filter:`PartitionKey eq 'id~${t}'`};return this.table.queryEntities(e,o)}async findChildByType(e,t,o){const r={$filter:`PartitionKey eq 'id~${t}' and RowKey gt '${o}~' and RowKey lt '${o}~~'`};return this.table.queryEntities(e,r)}async insertOne(e,t,o){console.log('ins',this.settings);const r=this.parseId(t);return this.table.insertEntity(e,Object.assign({},o,{PartitionKey:r,RowKey:'metadata',id:t}))}async insert(e,t){const o=t.id||mongodb.CreateIdString(),r=this.parseId(o);return this.table.insertEntity(e,Object.assign({},t,{PartitionKey:r,RowKey:'metadata',id:o}))}async insertChild(e,t,o,r){return this.table.insertEntity(e,Object.assign({},r,{PartitionKey:`id~${t}`,RowKey:`${o}~${r.id}`,type:o,parentId:t}))}async removeChild(e,t,o,r){return this.table.deleteEntity(e,`id~${t}`,`${o}~${r}`)}async removeById(e,t){return this.table.deleteEntity(e,`id~${t}`,'metadata')}async remove(e,t,o){return this.table.deleteEntity(e,t,o)}async removeAll(e,t){const o=await this.findAllById(e,t);for(const r of o)await this.table.deleteEntity(e,r.PartitionKey,r.RowKey);return o}async insertBlob(e,t){const o=mongodb.CreateIdString(),r=bufferToStream(t.data);return new Promise((e,i)=>{this.blob.createBlockBlobFromStream('files',o,r,t.data.length,{contentSettings:{contentType:t.mimetype}},(r,n)=>{r?i(r):e({id:o,title:t.originalname,type:t.mimetype,size:t.data.length,url:this.blob.getUrl('files',o),blob:n})})})}async removeBlob(e,t){return new Promise((o,r)=>{this.blob.deleteBlobIfExists(e,t,(e,t)=>{e?r(e):o(t)})})}parseId(e){if(e instanceof mongodb.ObjectId)return`id~${e.toHexString()}`;return e?`id~${e}`:''}}class UserDataAzureStorageProvider extends UserDataProvider{async findOneById(e,t){if(!t)return null;const o=await e.resolve(StorageService);let r=await o.findOneById('User',t);if(r){const e=new exports.UserModel;return Object.assign(e,r),e}return null}async findOneByEmail(e,t){const o=await e.resolve(StorageService),r=await o.findOneById('UserEmail',t);if(r){console.log('findOneByEmail ref',r);const e=await o.findOneById('User',r.user);if(console.log('findOneByEmail user',e),e){const t=new exports.UserModel;return Object.assign(t,e),t}}return null}findOneByName(e,t){throw new Error('NotImplemented')}async insertOne(e,t){throw new Error('NotImplemented')}async update(e,t,o,r){throw new Error('NotImplemented')}async getCredential(e,t){throw new Error('NotImplemented')}}function IsExpires(e){return!e||e<new Date}function IsEqual(e,t){return!(e!==t)||('function'==typeof e&&'function'==typeof t?e.toString()===t.toString():e instanceof Date&&t instanceof Date?e.getTime()===t.getTime():e instanceof RegExp&&t instanceof RegExp?e.source===t.source:e instanceof web.ObjectId&&t instanceof web.ObjectId?0===Buffer.compare(e.id,t.id):!!('number'==typeof e&&'number'==typeof t&&isNaN(e)&&isNaN(t))||!(typeof e==typeof t||!e!=!t)||e==t)}class SessionMutations{static async CreateSession(e,t,o,r,i,n,d){Validator.validate(t);const a=mongodb.CreateObjectId(),s={device:e.identity.id,provider:o.provider,providerId:o.providerId,authenticator:o._id,authenticationToken:o.token,user:t._id,roles:lodash.intersection(t.roles,r),expireAt:new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS),token:a,tokens:[{token:a,context:i}]};n&&(s.previous=n._id.toString(),d&&(s.impersonated=!0,s.impersonatedAt=new Date));const p=e.collection(SessionCollection);return web.retry(()=>p.insertOne(s)).then(e=>{if(!e)throw new web.AuthenticationError('unable to create session');return e})}static async CreateOrUpdateSession(e,t,o,r,i){const n=mongodb.CreateObjectId(),d=e.collection(SessionCollection);return d.findOneAndUpdate({_id:mongodb.CreateObjectId(e.identity.id)},{$set:{user:mongodb.IdStr(t),device:e.identity.id,account:r,roles:lodash.intersection(t.roles,o),token:n,expires:new Date(Date.now()+31536000000)},$push:{tokens:{token:n,context:i}}}).then(a=>a?a:d.insertOne({_id:mongodb.CreateObjectId(e.identity.id),user:mongodb.IdStr(t),device:e.identity.id,account:r,roles:lodash.intersection(t.roles,o),expireAt:new Date(Date.now()+31536000000),token:n,tokens:[{token:n,context:i}]}))}static async ExtendSession(e,t){const o=mongodb.CreateObjectId(),r=e.identity,i=e.collection(SessionCollection),n=r.session;return n?(e.debug({session:n,device:r.id},'extending session'),i.findOneAndUpdate({_id:n,device:r.id,user:r.user,token:r.token,expireAt:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:o,expireAt:new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS)},$push:{tokens:{token:o,context:t}}},{tokens:0}).then(t=>t?t:(e.info({session:n,device:r.id},'session is been extended by another connection'),i.findOne({_id:n,tokens:{$elemMatch:{token:r.token}}},{tokens:0}).then(e=>{if(!e)throw new web.AuthenticationError('Session not found');if(!IsEqual(e.device,r.id))throw new web.AuthenticationError('Unable to extend other device\'s session');if(!IsEqual(e.user,r.user))throw new web.AuthenticationError('Unable to extend other user\'s session');if(IsExpires(e.expireAt))throw new web.AuthenticationError('Unable to extend expired session');if(e.deleted)throw new web.AuthenticationError('Unable to extend deleted session');if(e.blocked)throw new web.AuthenticationError('Unable to extend blocked session');return e})))):Promise.reject(new web.AuthenticationError('No session to extend'))}static async RestoreSession(e,t,o,r){const i=mongodb.CreateObjectId(),n=e.identity,d=e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS,a=e.collection(SessionCollection);return a.findOneAndUpdate({_id:t._id.toString(),device:n.id,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:i,expireAt:new Date(Date.now()+d)},$push:{tokens:{token:i,context:o,restoreReason:r}}},{tokens:0})}static async TerminateSession(e,t){const o=e.identity;if(!o.session)return Promise.resolve(null);const r=e.collection(SessionCollection);return r.findOneAndAudit({_id:mongodb.CreateObjectId(o.session),user:o.user,device:o.id},mongodb.MongoAuditEvents.Deleted,!0,{$set:{deletedReason:t}},{tokens:0}).then(t=>(t||e.warn({identity:{user:e.identity.user,session:e.identity.session}},`SessionMutations.TerminateSession(): Session not found or already terminated`),t),e=>{throw new web.Exception(e,`Error during terminate user session, need manual update session '${o.session}.exited' to 'true'`)})}}class SessionGetters{static async GetSessionById(e,t){if(!t)return null;const o=e.collection(SessionCollection);return o.findOneById(t)}static async GetExternalUserFromUser(e,t,o,r){const i=e.collection(ExternalUserCollection);return i.findOne({user:t._id,provider:o,providerProtocol:r})}}class SessionDataProvider extends WfService{FindSessionById(e,t){return SessionGetters.GetSessionById(e,t)}CreateSession(e,t,o,r,i,n,d){return SessionMutations.CreateSession(e,t,o,r,i,n,d)}ExtendSession(e,t){return SessionMutations.ExtendSession(e,t)}TerminateSession(e,t){return SessionMutations.TerminateSession(e,t)}}class SessionDataAzureStorageProvider extends SessionDataProvider{CreateSession(e,t,o,r,i,n,d){throw new Error('NotImplemented')}ExtendSession(e,t){throw new Error('NotImplemented')}TerminateSession(e,t){throw new Error('NotImplemented')}}class CurrentSession extends exports.SessionModel{static[web.Symbols.Initializer](e,t){const o=t.identity.session;return o instanceof web.ObjectId?t.domain.resolve(SessionDataProvider).then(e=>e.FindSessionById(t.domain,o).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentSession.prototype),e))):null}}exports.WebAuthenticationService=class e extends WfService{async login(e,t,o,r=['user','admin']){const i=e.identity,n=e.domain,d=e.fingerprint();if(e.logger.context().new_device)throw new Error('Unable to authenticate without identity');let a;if(t instanceof web.ObjectId||'string'==typeof t?a=await this.Users.findOneById(e.domain,t):t instanceof exports.UserModel&&(a=t),!a)throw new Error('Not a user for login');let s=null;if(i.session){const t=await this.Sessions.TerminateSession(n,'new login');t&&(e.logger.debug({session:t._id},'Automatically logged out previous session for new user login'),s=await this.Sessions.CreateSession(n,a,o,r,d,t))}return s||(s=await this.Sessions.CreateSession(n,a,o,r,d)),this.updateWebSession(e,s,a),s}async update(e,t){const o=await e.resolve(CurrentSession);let r;if(t instanceof web.ObjectId||'string'==typeof t?r=await this.Users.findOneById(e.domain,t):t instanceof exports.UserModel&&(r=t),!r)throw new web.AuthenticationError('Unable to find user '+e.identity.user+' for extended session '+e.identity.session);return this.updateWebSession(e,o,r),o}async refresh(e,t){const o=await this.Sessions.ExtendSession(e.domain,e.fingerprint());if(!o)throw new web.AuthenticationError('Unable to extend session '+e.identity.session);let r;if(t instanceof web.ObjectId||'string'==typeof t?r=await this.Users.findOneById(e.domain,t):t instanceof exports.UserModel&&(r=t),!r)throw new web.AuthenticationError('Unable to find user '+e.identity.user+' for extended session '+e.identity.session);return this.updateWebSession(e,o,r),o}async logout(e,t='LogOut'){const o=await this.Sessions.TerminateSession(e.domain,t);return this.WebSessions.clear(e),o}updateWebSession(e,t,o){this.WebSessions.update(e,{session:t._id,user:t.user,token:t.token,roles:t.roles,groups:[],scope:[],profile:{_id:o._id,displayName:o.displayName,displayImageURL:o.displayImageURL},theme:o.theme,timezone:o.timezone,locale:o.locale})}},__decorate([web.singleton(),__metadata('design:type',SessionDataProvider)],exports.WebAuthenticationService.prototype,'Sessions',void 0),__decorate([web.singleton(),__metadata('design:type',exports.WebSessionService)],exports.WebAuthenticationService.prototype,'WebSessions',void 0),__decorate([web.singleton(),__metadata('design:type',exports.UserService)],exports.WebAuthenticationService.prototype,'Users',void 0),exports.WebAuthenticationService=__decorate([web.service()],exports.WebAuthenticationService);class AuthenticatedController extends WebFoundationController{async __WebFoundationController_InitRequest(e,t){return e.identity.user?t():void e.redirect(e.settings.WEB_SIGNIN_PATH)}async getFailureURL(e,t){if(e.settings.WEB_SIGNIN_FAILED_PATH){const o=e.res.get('X-Request-Id')||'',r={req_id:o,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEB_SIGNIN_FAILED_PATH+'?'+querystring.stringify(r)}throw new web.Exception(t,'"WEB_SIGNIN_FAILED_PATH" is not set')}}__decorate([web.middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],AuthenticatedController.prototype,'__WebFoundationController_InitRequest',null);class ExternalProviderMutations{static async findExternalProviderById(e,t){const o=e.collection(ExternalProviderCollection);return o.findOneById(t)}static async updateExternalProvider(e,t,o){const r=e.collection(ExternalProviderCollection),i=await r.insertOne({_id:t,provider:o.provider+'',providerProtocol:o.providerProtocol+'',providerURL:o.providerURL+'',providerFingerprint:o.providerFingerprint?o.providerFingerprint+'':null,providerConfiguration:o.providerConfiguration,appID:o.appID?o.appID+'':null,appSecret:o.appSecret?o.appSecret+'':null,scope:o.scope||null,displayName:o.displayName?o.displayName+'':null,displayImageURL:o.displayImageURL?o.displayImageURL+'':null});if(!i)throw new Error('Unable to create external provider');return i}static async GetExternalProvider(e,t){const o=e.collection(ExternalProviderCollection);return o.findOneById(t)}}function Audit(e,t,o={},r,i){return'boolean'==typeof r&&(o[''+t]=r),o[''+t+'At']=new Date,o[''+t+'From']=e.address||null,o[''+t+'By']=e.profile||null,i&&(o[''+t+'Reason']=i),o}class ExternalUserMutations{static async CreateOrUpdateExternalUser(e,t){const o=e.collection(ExternalUserCollection),r={uid:agentframework.IsNumber(t.uid)?+t.uid:t.uid+'',providerId:new mongodb.ObjectId(t.providerId)};return o.findOneAndUpsertDifference(r,t).then(e=>{if(!e)throw new Error('Unable to create external user');return e})}static async FindOrCreateUser(e,t){const o=e.collection(UserCollection);return t.user?o.findOneById(t.user).then(e=>{if(!e)throw new web.AuthenticationError(`External user ${t._id.toString()} connected to an non-exists user`);return e}):ExternalUserMutations.CreateNewUserFromExternalUser(e,t)}static async CreateNewUserFromExternalUser(e,t){const o=e.collection(UserCollection),r=e.collection(ExternalUserCollection),i=await o.nextSequenceId(!0),n=e.settings,d={id:i,displayName:t.displayName,displayImageURL:t.displayImageURL,roles:['user']};return t.emailCertified&&n.ADMIN_EMAIL&&n.ADMIN_EMAIL===t.email&&d.roles.push('admin'),UserMutations.insertOne(e,d).then(o=>r.findOneAndUpdate({_id:t._id,user:{$exists:!1}},{$set:{user:o._id}}).then(r=>{if(!r)throw new web.ApplicationError(`Unable to update external user ${t._id} with new created user. Need delete user ${o._id}`);return r.email&&r.emailCertified?ExternalUserMutations.CreateEmail(e,r).then(()=>o,()=>o):o}))}static async UpdateUserFromExternalUser(e,t){if(!t.user)throw new web.ApplicationError(`Unable to update user (${t.user}) info from external user ${t._id}`);const o=e.collection(UserCollection),r={displayName:t.displayName,displayImageURL:t.displayImageURL};return o.findOneAndUpdate({_id:t.user},{$set:r}).then(e=>{if(!e)throw new web.ApplicationError(`Unable to update user ${t.user} from external user ${t._id}`);return e})}static async CreateEmail(e,t){if(!t.user)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without user account linked`);if(!t.email)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without a valid email address`);if(!t.emailCertified)throw new web.AuthenticationError(`Unable to create email for external user ${t._id} without a certified email address`);const o=Audit(e.identity,'verified',{name:t.email,displayName:t.displayName,user:t.user},!0,`Certified by ${t.provider} account ${t.uid}@${t.providerId}`),r=e.collection(EmailCollection);return r.insertOne(o)}}class FederationDataProvider extends WfService{findExternalProviderById(e,t){return ExternalProviderMutations.findExternalProviderById(e,t)}updateExternalProvider(e,t,o){return ExternalProviderMutations.updateExternalProvider(e,t,o)}createOrUpdateExternalUser(e,t){return ExternalUserMutations.CreateOrUpdateExternalUser(e,t)}findOrCreateUser(e,t){return ExternalUserMutations.FindOrCreateUser(e,t)}updateUserFromExternalUser(e,t){return ExternalUserMutations.UpdateUserFromExternalUser(e,t)}}class FederationDataAzureStorageProvider extends FederationDataProvider{async findExternalProviderById(e,t){const o=await e.resolve(StorageService);let r=await o.findOneById('ExternalProvider',t);if(r){const e=new exports.ExternalProviderModel;return console.log('findExternalProviderById',r),e.fromJSON(r),e}return null}async updateExternalProvider(e,t,o){const r=await e.resolve(StorageService),i=exports.ExternalProviderModel.toJSON(o);console.log('profile',i);let n=await r.insert('ExternalProvider',Object.assign({id:t},i));const d=new exports.ExternalProviderModel;return console.log('updateExternalProvider',n),d.fromJSON(n),d}async createOrUpdateExternalUser(e,t){const o=t.providerId+'~'+t.uid,r=await e.resolve(StorageService);let i=await r.findOneById('ExternalUser',o);throw console.log('data',i),new core.NotImplementedException('createOrUpdateExternalUser')}async findOrCreateUser(e,t){throw new core.NotImplementedException('findOrCreateUser')}async updateUserFromExternalUser(e,t){throw new core.NotImplementedException('updateUserFromExternalUser')}}class OpenIdConnect extends WfService{constructor(){super(...arguments),this.ConfigurationEndpoint='/.well-known/openid-configuration'}discovery(e){e.pathname=path.join(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return axios(t).then(e=>e.data)}}exports.ExternalProviderService=class e extends WfService{get name(){return'ExternalProviderService'}async findOrDiscoverExternalProvider(e,t){if(!t.provider||!t.providerProtocol||!t.providerURL)throw new Error('Unable to find provider without primary fields');const o=this.createProviderId(t),r=await this.data.findExternalProviderById(e,o);if(r)return r;if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error('Unable to discover external id provider');return this.data.updateExternalProvider(e,o,t)}createProviderId(e){const t=[e.provider+'',e.providerProtocol+'',e.providerURL+''];return e.appID&&t.push(e.appID+''),core.CreateHashedObjectId(t)}async discoverProviderConfiguration(e,t){let o;try{o=new url.URL(t)}catch(e){throw new web.Exception(e,'Invalid external provider: '+t)}if('https:'!==o.protocol)throw new Error('Unsupported external id provider protocol: '+t);const r=e.construct(OpenIdConnect);return r.discovery(o).catch(t=>(e.warn(t,{issuer:o},'Unable to discover the configuration'),null))}},__decorate([core.singleton(),__metadata('design:type',FederationDataProvider)],exports.ExternalProviderService.prototype,'data',void 0),exports.ExternalProviderService=__decorate([web.service()],exports.ExternalProviderService),exports.ExternalUserService=class e extends WfService{get name(){return'ExternalUserService'}createOrUpdateExternalUser(e,t){if(!t)throw new web.ApplicationError('Unable to create external user without profile');return this.data.createOrUpdateExternalUser(e,t)}findOrCreateUser(e,t){return this.data.findOrCreateUser(e,t)}updateUserFromExternalUser(e,t){return this.data.updateUserFromExternalUser(e,t)}saveProfileImage(e,t,o,r,i){const n={type:r,data:i,filename:'/Federation/Google/ProfileImages/'+o.uid};return this.apfs.save(e,n,!0).then(e=>e?e.toUrl():null).catch(e=>(this.logger.warn(e,`Unable to save profile image for user ${o.uid} on ${o.provider}`),null))}async getProfileImage(e,t){if(e.settings.OIDC_PROFILE_IMAGE_POLICY===OIDC_PROFILE_IMAGE_POLICIES.PROXY){const o=t.displayImageURL||e.settings.OIDC_PROFILE_IMAGE_URL,r=await e.fetch(o,{responseType:'arraybuffer'});if(r.ok&&Buffer.isBuffer(r.data)){let e;try{e=path.basename(new url.URL(o).pathname)}catch(t){e=''}return{filename:e,type:r.headers['content-type'],data:r.data}}}else e.warn('OIDC_PROFILE_IMAGE_POLICY: '+e.settings.OIDC_PROFILE_IMAGE_POLICY+' is not supported, fall back to REDIRECT');return t.displayImageURL||e.settings.OIDC_PROFILE_IMAGE_URL}},__decorate([web.singleton(),__metadata('design:type',FederationDataProvider)],exports.ExternalUserService.prototype,'data',void 0),__decorate([web.singleton(),__metadata('design:type',exports.ApfsService)],exports.ExternalUserService.prototype,'apfs',void 0),exports.ExternalUserService=__decorate([web.service()],exports.ExternalUserService);class RestClient{constructor(e={}){this.defaults=e}makeAxiosOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),o=Object.assign({},this.defaults.headers,e.headers||{}),r=Object.assign({},this.defaults,e);return delete r.query,r.params=t,r.headers=o,r}request(e){return axios.request(this.makeAxiosOptions(e)).then(e=>(console.log('res',e.request.res),{status:e.status,statusText:e.statusText,responseUrl:e.request.res.responseUrl,redirects:e.request.res.redirects,headers:e.headers,data:e.data}))}post(e,t,o){return axios.post(e,t,this.makeAxiosOptions(o)).then(e=>e.data)}postBuffer(e,t,o){return this.post(e,t,Object.assign({responseType:'arraybuffer'},o||{}))}put(e,t,o){return axios.put(e,t,this.makeAxiosOptions(o)).then(e=>(console.log('put headers',e.headers),e.data))}putBuffer(e,t,o={}){return this.put(e,t,Object.assign({responseType:'arraybuffer'},o||{}))}get(e,t={}){return axios.get(e,this.makeAxiosOptions(t)).then(e=>e.data)}getBuffer(e,t={}){return this.get(e,Object.assign({responseType:'arraybuffer'},t||{}))}delete(e,t={}){return axios.delete(e,this.makeAxiosOptions(t)).then(e=>e.data)}deleteBuffer(e,t={}){return this.delete(e,Object.assign({responseType:'arraybuffer'},t||{}))}}class OAuthClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}}exports.GitLabService=class e extends WfService{async getProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=new OAuthClient(t.access_token),n=await i.get(o.providerConfiguration.userinfo_endpoint);let d=n.picture;return{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:n,userData:{},identities:[],user:null,username:n.nickname||null,domain:null,email:r.email||n.email||null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:r.name||n.name,displayImageURL:d,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:n.profile||null,locale:null}}},exports.GitLabService=__decorate([web.service()],exports.GitLabService),exports.GitHubService=class e extends WfService{async getProfile(e,t,o){const r=new OAuthClient(t.access_token),i=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const n=await r.get(o.providerConfiguration.userinfo_endpoint),d=await r.get('https://api.github.com/user/emails').then(t=>[]);let a=n.id,s=null,p=n.avatar_url;if(d&&d.length)for(const t of d)t.primary&&t.verified&&(s=t.email);return{uid:a,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:n,userData:{},identities:[],user:null,username:n.login,domain:null,email:s,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.name||n.login,displayImageURL:p,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:n.bio||null,homepage:n.blog||n.html_url||null,locale:i.locale}}},exports.GitHubService=__decorate([web.service()],exports.GitHubService),exports.GoogleService=class e extends WfService{constructor(){super(...arguments),this.TrustedEmailDomains=['gmail.com']}async getProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=new OAuthClient(t.access_token),n=await i.get(o.providerConfiguration.userinfo_endpoint).catch(()=>null);let d=[],a=null,s=null,p=null,l=!1;if(r.picture?p=r.picture:n&&n.picture&&(p=n.picture),r.email&&(a=r.email),a){const e=a.split('@');s=e[0],0<=this.TrustedEmailDomains.indexOf(e[1].toLowerCase())&&(l=r.email_verified)}return a&&l&&d.push({type:'email',value:a}),{uid:r.sub,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:n,userData:{},identities:d,user:null,username:s,domain:null,email:a,emailCertified:l,mobile:null,mobileCertified:!1,displayName:r.name,displayImageURL:p,familyName:r.family_name,givenName:r.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:r.locale}}},exports.GoogleService=__decorate([web.service()],exports.GoogleService);class MicrosoftClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://graph.microsoft.com/v1.0/me')}photo(){return this.get('https://graph.microsoft.com/v1.0/me/photo').catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw new web.Exception(e,e.response.data,'Unable to resolve user photo')})}photoImage(e){return e?this.getBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.getBuffer(`https://graph.microsoft.com/v1.0/me/photo/$value`)}photoImageFile(e){return this.photo().then(t=>{if(!t)return Promise.resolve(null);const o=t['@odata.mediaContentType'],r=t.id;return this.photoImage(r).then(t=>{const[i,n]=r.split('X');return{type:o,data:t,filename:'/Federation/Microsoft/ProfileImages/'+e,width:+i,height:+n}})})}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e['@odata.mediaContentType'],o=e.id;return this.photoImage(o).then(e=>`data:${t};charset=utf-8;base64,${e.toString('base64')}`)})}users(){return this.get(`https://graph.microsoft.com/v1.0/users`)}}exports.MicrosoftService=class e extends WfService{constructor(){super(...arguments),this.TrustedEmailDomains=['outlook.com','hotmail.com','live.com','msn.com','passport.com','passport.net']}async getProfile(e,t,o){const r=t.id_token;if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const i=await new MicrosoftClient(t.access_token).profile().catch(()=>null);let n=null,d=null,a=[],s=null,p=null,l=null,y=!1;if(i?(n=i.id,d=i.displayName):(n=r.oid||r.sub,d=r.name),r.preferred_username?s=r.preferred_username:i&&i.userPrincipalName&&(s=i.userPrincipalName),s){const e=s.split('@');2===e.length&&(p=e[1].toLowerCase())}if(r.email?l=r.email:i&&i.mail&&(l=i.mail),l){const e=l.split('@');2===e.length&&0<=this.TrustedEmailDomains.indexOf(e[1].toLowerCase())&&(y=!0)}return l&&y&&a.push({type:'email',value:l}),{uid:n,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:i,userData:{},identities:a,user:null,username:s,domain:p,email:l,emailCertified:y,mobile:i&&i.mobilePhone,mobileCertified:!1,displayName:d,displayImageURL:null,familyName:i&&i.surname,givenName:i&&i.givenName,gender:null,dob:null,status:null,bio:null,homepage:null,locale:i&&i.preferredLanguage}}},__decorate([web.singleton(),__metadata('design:type',exports.ApfsService)],exports.MicrosoftService.prototype,'apfs',void 0),exports.MicrosoftService=__decorate([web.service()],exports.MicrosoftService);class WeiboClient extends RestClient{constructor(e){if(super({query:{access_token:e}}),!e)throw new Error('Access token can not be null or empty')}comments(e={}){return this.get('https://api.weibo.com/2/comments/to_me.json',e)}mentions(e={}){return this.get('https://api.weibo.com/2/comments/mentions.json',e)}reposts(e={}){return this.get('https://api.weibo.com/2/statuses/mentions.json',e)}weibo(e={}){return this.get('https://api.weibo.com/2/statuses/home_timeline.json',e)}getLimits(){return this.get('https://api.weibo.com/2/account/rate_limit_status.json',{})}}exports.WeiboService=class e extends WfService{async getProfile(e,t,o){if(!o.providerConfiguration||!o.providerConfiguration.userinfo_endpoint)return null;const r=new WeiboClient(t.access_token),i=await r.post('https://api.weibo.com/oauth2/get_token_info');t.appkey=i.appkey;const n=await r.get(o.providerConfiguration.userinfo_endpoint,{query:{uid:t.uid}}).catch(e=>{throw console.log('unable to get weibot profile',e),e});return{uid:n.id,provider:o.provider,providerProtocol:o.providerProtocol,providerId:o._id,providerData:n,userData:{},identities:[],user:null,username:n.domain||null,domain:null,email:null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.screen_name,displayImageURL:n.profile_image_url,familyName:null,givenName:null,gender:n.gender,dob:null,status:n.status?n.status.text:null,bio:n.description,homepage:n.url||null,locale:n.lang}}},exports.WeiboService=__decorate([web.service()],exports.WeiboService);class WfUserService extends WebFoundationUserService{}class OAuth2Client extends RestClient{constructor(e){super({headers:{Accept:'application/json',"Content-Type":'application/json'}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:'code'};Array.isArray(e.scope)&&(e.scope=e.scope.join(' '));const o=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${querystring.stringify(o)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(' '));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:'authorization_code'});return super.post(this.options.token_endpoint,querystring.stringify(t),{headers:{"Content-Type":'application/x-www-form-urlencoded'}}).catch(e=>(console.log('errror get token',e.response),console.log('try get token using json payload',t),super.post(this.options.token_endpoint,t)))}}let OpenIdAuthenticator=class e extends WfUserService{get name(){return'OpenIdAuthenticator'}update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),this.scope=e.scope?e.scope:'openid'}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:t+''})}getSuccessURL(e){return'/#'+this.settings.WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return'/#'+this.settings.WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{try{if(e.id_token){const t=e.id_token.split('.'),o=Buffer.from(t[1],'base64');e.id_token=JSON.parse(o.toString())}else e.id_token={},e.id_token_error='id_token is not found'}catch(t){e.id_token_error=t.message}return e})}async refreshToken(e){throw new Error('Not implemented refresh token')}async getProfile(e){const t=e.id_token;let o=[],r=null,i=null,n=null,d=!1;if(t.email&&(r=t.email,d=t.email_verified),r){const e=r.split('@');i=e[0],n=e[1]}return r&&d&&o.push({type:'email',value:r}),{uid:t.sub,providerData:null,identities:o,username:i,domain:n,email:r,emailCertified:d,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}};OpenIdAuthenticator=__decorate([web.service()],OpenIdAuthenticator);var _a$1,_b;class OpenIdController extends WebFoundationController{async getAuthenticator(e){const t=e.construct(OpenIdAuthenticator,!0),o=await this.discover(e);return t.update({provider:o,issuer:o.providerURL,appID:o.appID,appSecret:o.appSecret,token_endpoint:o.providerConfiguration.token_endpoint,authorization_endpoint:o.providerConfiguration.authorization_endpoint,scope:o.scope}),t}OnProfile(e,t,o){return Promise.resolve(null)}async[_a$1=Symbol('start')](e){let t;try{const o=await this.getAuthenticator(e),r=url.resolve(e.publicUrl,'callback');t=o.getAuthorizeURL(r,Date.now())}catch(o){t=await this.getFailureURL(e,new web.Exception(o,'Unable to start authentication'))}e.redirect(t)}async[_b=Symbol('callback')](e){const t=await this.getAuthenticator(e),o=t.idProvider,r=url.resolve(e.publicUrl,'callback'),i=+e.query.state;if(i>Date.now()||i<Date.now()-e.settings.OIDC_AUTHENTICATION_EXPIRES_IN_MILLISECONDS)return void e.redirect(t.getFailureURL(new Error('Invalid Authentication State')));if(e.query.error){const o=new Error(`${e.query.error}: ${e.query.error_description}`);return e.logger.error(o,'Authentication Error'),void e.redirect(t.getFailureURL(o))}try{const i=e.query.code,n=await t.getToken(r,i);let d=await this.OnProfile(e,n,o).catch(()=>null);if(d||(d=await t.getProfile(n).catch(()=>null)),!d||!d.uid){let o=new Error('Unable to get unique user identity from provider');return e.logger.error(o),void e.redirect(t.getFailureURL(o))}d&&(Reflect.has(d,'user')&&(d.user instanceof web.ObjectId?e.logger.warn(`External user ${d.uid}@${o._id} already set the user field to ${d.user}`):d.user=null),!d.displayImageURL&&e.logger.warn(`External user ${d.uid}@${o._id} do not have a profile image`),d.provider=o.provider,d.providerProtocol=o.providerProtocol,d.providerId=o._id);const a=await this.ExternalUsers.createOrUpdateExternalUser(e.domain,d);let s;if(!a.user)s=null;else if(s=await this.Users.findOneById(e.domain,a.user),s){const t=a.updatedAt||a.createdAt,o=s.updatedAt||s.createdAt;t>o&&(e.logger.warn({eid:a._id,uid:s._id,d1:t,d2:o},`Updating user info from external user`),s=await this.ExternalUsers.updateUserFromExternalUser(e.domain,a))}const p=await e.resolve(CurrentUser),l=await this.OnAuthenticated(e,o,n,a,s,p);e.redirect(t.getSuccessURL(l))}catch(o){e.logger.error(o,'Authentication Callback Error'),e.redirect(t.getFailureURL(o))}}}__decorate([web.singleton(),__metadata('design:type',exports.ExternalUserService)],OpenIdController.prototype,'ExternalUsers',void 0),__decorate([web.singleton(),__metadata('design:type',exports.UserService)],OpenIdController.prototype,'Users',void 0),__decorate([web.method('GET','/start'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OpenIdController.prototype,_a$1,null),__decorate([web.method('GET','/callback'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OpenIdController.prototype,_b,null);class EventGetters{static async GetLatestEvents(e){const t=e.collection(EventCollection);return t.find({},{},{id:-1},0,30).then(e=>e.results)}}class EventMutations{static async createEvent(e,t,o){const r=e.collection(EventCollection),i=await r.nextSequenceId();return r.insertOne({id:i,type:t,context:o||{}})}}class EventDataProvider{async getLatestEvents(e){return EventGetters.GetLatestEvents(e)}async createEvent(e,t,o){return EventMutations.createEvent(e,t,o)}}exports.EventService=class e extends WfService{get name(){return'EventService'}async getLatestEvents(e){return this.data.getLatestEvents(e)}async createSignInEvent(e,t,o){const r=exports.EventType.SIGN_IN,i={provider:t.displayName,providerId:t._id,userId:o._id};return this.data.createEvent(e,r,i)}async createSignUpEvent(e,t,o){const r=exports.EventType.SIGN_UP,i={provider:t.displayName,providerId:t._id,userId:o._id};return this.data.createEvent(e,r,i)}async createSignOutEvent(e,t){const o=exports.EventType.SIGN_OUT,r={provider:t.displayName,providerId:t._id};return this.data.createEvent(e,o,r)}},__decorate([lib.singleton(),__metadata('design:type',EventDataProvider)],exports.EventService.prototype,'data',void 0),exports.EventService=__decorate([lib.service()],exports.EventService);class OpenIdAuthController extends OpenIdController{async OnAuthenticated(e,t,o,r,i,n){const d={_id:r._id,provider:t.provider,providerId:t._id,displayName:r.displayName,displayImageURL:r.displayImageURL,token:o};if(i){const o=await this.WebAuth.login(e,i,d);return e.logger.debug({user:i._id,email:r.email,roles:o.roles.join(','),session:o._id.toString()},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e.domain,t,i),i}if(r.email){const t=await this.Users.findOneByEmail(e.domain,r.email);if(t)throw new web.AuthenticationError(`Please login ${r.email} using password`)}const a=await this.ExternalUsers.findOrCreateUser(e.domain,r);if(!a)throw new web.AuthenticationError(`Unable to register using ${t.displayName}`);return this.WebAuth.login(e,a,d).then(o=>(e.logger.debug({user:a._id,email:r.email,roles:o.roles.join(','),session:o._id.toString()},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e.domain,t,a).then(()=>a)))}}__decorate([web.singleton(),__metadata('design:type',exports.EventService)],OpenIdAuthController.prototype,'Events',void 0),__decorate([web.singleton(),__metadata('design:type',exports.WebAuthenticationService)],OpenIdAuthController.prototype,'WebAuth',void 0),exports.GoogleOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GoogleOpenIdAuthController'}async discover(e){const t={provider:'google',providerProtocol:'openid',providerURL:e.settings.OIDC_GOOGLE_ISSUER_URL,displayName:'Google Account',displayImageURL:'https://www.google.com/favicon.ico'},o=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return o.appID=o.appID||e.settings.OIDC_GOOGLE_CLIENT_ID,o.appSecret=e.settings.OIDC_GOOGLE_CLIENT_SECRET,o.scope=e.settings.OIDC_GOOGLE_SCOPES.join(' '),o}async OnProfile(e,t,o){return this.google.getProfile(e.domain,t,o)}},__decorate([web.singleton(),__metadata('design:type',exports.ExternalProviderService)],exports.GoogleOpenIdAuthController.prototype,'idp',void 0),__decorate([web.singleton(),__metadata('design:type',exports.GoogleService)],exports.GoogleOpenIdAuthController.prototype,'google',void 0),exports.GoogleOpenIdAuthController=__decorate([web.controller('/api/integration/google/auth')],exports.GoogleOpenIdAuthController),exports.MicrosoftOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'MicrosoftOpenIdAuthController'}async discover(e){const t={provider:'microsoft',providerProtocol:'openid',providerURL:e.settings.OIDC_MICROSOFT_ISSUER_URL,displayName:'Microsoft Account',displayImageURL:'https://www.microsoft.com/favicon.ico'},o=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return o.appID=o.appID||e.settings.OIDC_MICROSOFT_CLIENT_ID,o.appSecret=e.settings.OIDC_MICROSOFT_CLIENT_SECRET,o.scope=e.settings.OIDC_MICROSOFT_SCOPES.join(' '),o}async OnProfile(e,t,o){return this.microsoft.getProfile(e.domain,t,o)}},__decorate([web.singleton(),__metadata('design:type',exports.ExternalProviderService)],exports.MicrosoftOpenIdAuthController.prototype,'idp',void 0),__decorate([web.singleton(),__metadata('design:type',exports.MicrosoftService)],exports.MicrosoftOpenIdAuthController.prototype,'microsoft',void 0),exports.MicrosoftOpenIdAuthController=__decorate([web.controller('/api/integration/microsoft/auth')],exports.MicrosoftOpenIdAuthController),exports.GitLabOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GitLabOpenIdAuthController'}async discover(e){const t={provider:'gitlab',providerProtocol:'openid',providerURL:e.settings.OIDC_GITLAB_ISSUER_URL,displayName:'GitLab Account',displayImageURL:'https://about.gitlab.com/ico/favicon-192x192.png'},o=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return o.appID=o.appID||e.settings.OIDC_GITLAB_CLIENT_ID,o.appSecret=e.settings.OIDC_GITLAB_CLIENT_SECRET,o.scope=e.settings.OIDC_GITLAB_SCOPES.join(' '),o}async OnProfile(e,t,o){return this.gitlab.getProfile(e.domain,t,o)}},__decorate([web.singleton(),__metadata('design:type',exports.ExternalProviderService)],exports.GitLabOpenIdAuthController.prototype,'idp',void 0),__decorate([web.singleton(),__metadata('design:type',exports.GitLabService)],exports.GitLabOpenIdAuthController.prototype,'gitlab',void 0),exports.GitLabOpenIdAuthController=__decorate([web.controller('/api/integration/gitlab/auth')],exports.GitLabOpenIdAuthController),exports.GitHubOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GitHubOpenIdAuthController'}async discover(e){const t={provider:'github',providerProtocol:'oauth',providerURL:e.settings.OIDC_GITHUB_ISSUER_URL,displayName:'GitHub Account',displayImageURL:'https://github.com/favicon.ico',providerConfiguration:{issuer:e.settings.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:'https://github.com/login/oauth/authorize',token_endpoint:'https://github.com/login/oauth/access_token',userinfo_endpoint:'https://api.github.com/user'}},o=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return o.appID=o.appID||e.settings.OIDC_GITHUB_CLIENT_ID,o.appSecret=o.appSecret||e.settings.OIDC_GITHUB_CLIENT_SECRET,o.scope=o.scope||e.settings.OIDC_GITHUB_SCOPES.join(' '),o}async OnProfile(e,t,o){return this.github.getProfile(e.domain,t,o)}},__decorate([web.singleton(),__metadata('design:type',exports.ExternalProviderService)],exports.GitHubOpenIdAuthController.prototype,'idp',void 0),__decorate([web.singleton(),__metadata('design:type',exports.GitHubService)],exports.GitHubOpenIdAuthController.prototype,'github',void 0),exports.GitHubOpenIdAuthController=__decorate([web.controller('/api/integration/github/auth')],exports.GitHubOpenIdAuthController),exports.WeiboOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'WeiboOpenIdAuthController'}async discover(e){const t={provider:'weibo',providerProtocol:'oauth',providerURL:e.settings.OIDC_WEIBO_ISSUER_URL,displayName:'Weibo Account',displayImageURL:'https://www.weibo.com/favicon.ico',providerConfiguration:{issuer:e.settings.OIDC_WEIBO_ISSUER_URL,authorization_endpoint:'https://api.weibo.com/oauth2/authorize',token_endpoint:'https://api.weibo.com/oauth2/access_token',userinfo_endpoint:'https://api.weibo.com/2/users/show.json'}},o=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return o.appID=o.appID||e.settings.OIDC_WEIBO_CLIENT_ID,o.appSecret=e.settings.OIDC_WEIBO_CLIENT_SECRET,o.scope=e.settings.OIDC_WEIBO_SCOPES.join(' '),o}async OnProfile(e,t,o){return this.weibo.getProfile(e.domain,t,o)}},__decorate([web.singleton(),__metadata('design:type',exports.ExternalProviderService)],exports.WeiboOpenIdAuthController.prototype,'idp',void 0),__decorate([web.singleton(),__metadata('design:type',exports.WeiboService)],exports.WeiboOpenIdAuthController.prototype,'weibo',void 0),exports.WeiboOpenIdAuthController=__decorate([web.controller('/api/integration/weibo/auth')],exports.WeiboOpenIdAuthController);class EventDataAzureStorageProvider extends EventDataProvider{async getLatestEvents(e){return[]}async createEvent(e,t,o){return null}}var _a$2;class OrganizationController extends WebFoundationController{async[_a$2=Symbol('Tenant')](e,t){if(!e.params.tenant)throw new Error('Missing tenant parameters');return e.req.settings.MONGODB_DATABASE=e.params.tenant,t()}}__decorate([web.middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],OrganizationController.prototype,_a$2,null);class OrganizationMutations{static CreateOrganization(e,t,o){const r=e.collection(OrganizationCollection);return r.nextSequenceId(!0).then(e=>{if(!e)throw new web.ApplicationError('unable to generate Organization id');return r.insertOne({id:e,name:t.name||e+'',owner:o,displayName:t.displayName||'Organization '+(e+''),displayImageURL:t.displayImageURL||null,settings:merge(t.settings,{MAX_MEMBERS:1,LICENSE_TYPE:'FREE',LICENSE_EXPIRE_AT:new Date(Date.now()+316224e5)})}).then(e=>{if(!e)throw new web.ApplicationError('unable to create Organization');return e})})}static UpdateOrganizationField(e,t,o,r){if('string'!=typeof o)throw new Error('invalid field to update');const i=e.collection(OrganizationCollection);return i.findOneAndUpdate(i.makeIdQuery(t),{$set:{[o]:r}})}static UpdateOrganization(e,t,o){const r=e.collection(OrganizationCollection);return r.findOneAndUpdate(r.makeIdQuery(t),{$set:o})}static DeleteOrganization(e,t){const o=e.collection(OrganizationCollection);return o.findOneAndAudit({_id:t._id},mongodb.MongoAuditEvents.Deleted,!0)}}class OrganizationGetters{static FindOrganizations(e,t){const o=e.collection(OrganizationCollection);return o.find({$text:{$search:t,$caseSensitive:!1,$diacriticSensitive:!1},deleted:{$ne:!0}})}static FindOrganizationsByOwner(e,t){const o=e.collection(OrganizationCollection),r=t||e.identity.user;if(!r)throw new Error('owner can not be null');return o.find({owner:new mongodb.ObjectId(r),deleted:{$ne:!0}})}static FindOrganizationsByMember(e,t){const o=e.collection(OrganizationCollection),r=e.collection(EdgeCollection),i=t||e.identity.user;if(!i)throw new Error('member can not be null');return r.findOutVertices(i,exports.UserModel.getType(),o).then(e=>({n:mongodb.GetTotalCount(e),results:e}))}static FindOrganization(e,t){const o=e.collection(OrganizationCollection);return o.findOne(merge(o.makeIdQuery(t),{deleted:{$ne:!0}}))}}class OrganizationService extends WfService{createOrganization(e,t,o){return OrganizationMutations.CreateOrganization(e,t,o)}updateOrganization(e,t,o){const r=arguments[2],i=arguments[3];return i?OrganizationMutations.UpdateOrganizationField(e,t,r,i):OrganizationMutations.UpdateOrganization(e,t,r)}findOrganization(e,t){return OrganizationGetters.FindOrganization(e,t)}findOrganizationsByMember(e,t){return OrganizationGetters.FindOrganizationsByMember(e,t)}findOrganizationsByOwner(e,t){return OrganizationGetters.FindOrganizationsByOwner(e,t)}searchOrganization(e,t){return OrganizationGetters.FindOrganizations(e,t)}}exports.StripeService=class e extends WfService{get client(){const e=new Stripe(this.settings.CUSTOM_STRIPE_SECRET_KEY);return Reflect.set(this,'client',e),e}async addCard(e,t,o){if(!t)throw new Error('Unable create stripe customer without user');const r={user:new web.ObjectId(t)},i={app:this.settings.NAME,uid:r.user.toString()},n=e.collection(StripeCustomerCollection);await n.createIndices(),console.log('qqq',r);const d=await n.findOneAndUpsert(r);if(!d)throw new Error('Unable to create stripe customer mapping');let a;if(d.customerId&&(a=await this.getStripeCustomer(d.customerId)),a){const e=await this.client.customers.createSource(a.id,{source:o.id,metadata:i});return this.normalizeCard(e,a.default_source)}if(a=await this.client.customers.create({description:`Customer for ${t}@${this.settings.NAME}`,source:o.id,metadata:i}),!a)throw new Error('unable to create stripe customer with token');const s=await this.client.customers.retrieveCard(a.id,o.card.id);return n.findOneAndUpdate(r,{$set:{customerId:a.id}}).then(()=>this.normalizeCard(s,s.id),e=>{const o=`Unable to link stripe customer ${a.id} to ${t}, because of: ${e.message}`;throw this.logger.warn(e,o),new web.Exception(e,o)})}async listCards(e,t){if(!t)throw new Error('Unable create stripe customer without user');const o={user:new web.ObjectId(t)},r=e.collection(StripeCustomerCollection),i=await r.findOne(o);if(!i)return[];if(!i.customerId)return[];const n=await this.getStripeCustomer(i.customerId);return n?this.client.customers.listCards(n.id).then(e=>e.data.map(e=>this.normalizeCard(e,n.default_source))):[]}async removeCard(e,t,o){const r=await this.getCustomer(e,t);if(!r.customerId)throw new Error('unable to map to stripe customer');const i=await this.getStripeCustomer(r.customerId);if(!i)throw new Error('unable to remove card for stripe customer: '+r.customerId);return this.client.customers.deleteCard(r.customerId,o)}async activeCard(e,t,o){const r=await this.getCustomer(e,t);if(!r.customerId)throw new Error('unable to map to stripe customer');const i=await this.getStripeCustomer(r.customerId);if(!i)throw new Error('unable to remove card for stripe customer: '+r.customerId);const n=await this.client.customers.update(i.id,{default_source:o});return{id:n.default_source}}async setPrimaryCard(e,t,o){}async getCustomer(e,t){if(!t)throw new Error('Unable create stripe customer without user');const o={user:new web.ObjectId(t)},r=e.collection(StripeCustomerCollection),i=await r.findOneAndUpsert(o);if(!i)throw new Error('Unable to create stripe customer mapping');return i}async getStripeCustomer(e){const t=await this.client.customers.retrieve(e).catch(()=>null);return t&&t.deleted?null:t}normalizeCard(e,t){return{id:e.id,active:e.id===t,type:e.brand,last4:e.last4,name:e.name,expiry:e.exp_month+'/'+e.exp_year}}},exports.StripeService=__decorate([web.service()],exports.StripeService);class GoogleClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://www.googleapis.com/userinfo/v2/me')}people(){return this.get('https://www.googleapis.com/admin/directory/v1/users/userKey')}}class GoogleStorageService extends WfService{constructor(e){super(e),this.google=new gtoken.GoogleToken({key:e.settings.CUSTOM_GOOGLE_API_PRIVATE_KEY,email:e.settings.CUSTOM_GOOGLE_API_EMAIL_ID,scope:['https://www.googleapis.com/auth/devstorage.read_write']})}async insert(e,t,o){const r=await this.google.getToken();if(!r)throw new Error('Error get access token to insert file');const i=new GoogleClient(r);return i.post('https://www.googleapis.com/upload/storage/v1/b/'+e+'/o',o,{query:{uploadType:'media',name:t},headers:{"Content-Type":'application/json'}})}async copy(e,t,o,r){const i=await this.google.getToken();if(!i)throw new Error('Error get access token to insert file');const n=new GoogleClient(i);return n.post(`https://www.googleapis.com/storage/v1/b/${e}/o/${encodeURIComponent(t)}/copyTo/b/${o}/o/${encodeURIComponent(r)}`)}async remove(e,t){const o=await this.google.getToken();if(!o)throw new Error('Error get access token to insert file');const r=new GoogleClient(o);return r.delete('https://www.googleapis.com/storage/v1/b/'+e+'/o/'+encodeURIComponent(t))}async list(e,t){const o=await this.google.getToken();if(!o)throw new Error('Error get access token to insert file');const r=new GoogleClient(o);return r.get('https://www.googleapis.com/storage/v1/b/'+e+'/o',{query:{prefix:t,versions:!0},headers:{"Content-Type":'application/json'}})}}class CronJobService extends WebFoundationService{findAll(e){const t=e.collection(CronJobCollection);return t.find().then(e=>e.results)}insert(e,t,o){const r=e.collection(CronJobCollection),i=this.calculateNextScheduleTime(t),n=web.CreateObjectSignature({trigger:t,payload:o});return r.insertOne({_id:web.CreateHashedObjectId(n),key:n,cron:'string'==typeof t?t:null,intervalInSeconds:'number'==typeof t?t:null,nextScheduleAt:i,lastScheduleAt:new Date(0),lastScheduleBy:null,lastScheduleFrom:null,lastScheduleRetries:0,lastScheduleDuration:0,lastScheduleResult:null,payload:o})}remove(e,t){const o=e.collection(CronJobCollection);return o.findOneAndDelete({_id:t}).then(e=>{if(!e)throw new Error('DeleteCronJobFailed');return e})}async findAllScheduledCronJob(e){const t=e.collection(CronJobCollection);return t.find({nextScheduleAt:{$lt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}}).then(e=>{if(e.n&&Array.isArray(e.results)&&e.results.length){const o=e.results;return Promise.all(o.map(e=>t.findOneAndUpdate({_id:e._id,nextScheduleAt:e.nextScheduleAt,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{nextScheduleAt:this.calculateNextScheduleTime(e)}}))).then(e=>e.filter(e=>null!=e))}return e.results})}async findOneScheduledCronJob(e){const t=e.collection(CronJobCollection),o=await t.findOne({deleted:{$ne:!0},blocked:{$ne:!0},nextScheduleAt:{$lt:new Date}});return o?t.findOneAndUpdate({_id:o._id,nextScheduleAt:o.nextScheduleAt,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{nextScheduleAt:this.calculateNextScheduleTime(o)}}):null}async updateOneScheduledCronJob(e,t,o={}){const r=e.collection(CronJobCollection);return r.findOneAndUpdate({_id:mongodb.CreateObjectId(t)},{$set:{lastScheduleAt:o.lastScheduleAt||new Date,lastScheduleBy:o.lastScheduleBy||null,lastScheduleFrom:o.lastScheduleFrom||null,lastScheduleRetries:o.lastScheduleRetries||0,lastScheduleDuration:o.lastScheduleDuration||0,lastScheduleResult:o.lastScheduleResult||null}})}calculateNextScheduleTime(e){let t;const o=typeof e;if('string'==o)t=this.calculateNextCronTime(e);else if('number'==o)t=this.calculateNextIntervalTime(e);else if(!('object'==o))throw new Error('InvalidCronOrInterval');else if('string'==typeof e.cron&&e.cron)t=this.calculateNextCronTime(e.cron);else if('number'==typeof e.intervalInSeconds&&!isNaN(e.intervalInSeconds))t=this.calculateNextIntervalTime(e.intervalInSeconds);else throw new Error('InvalidCronJob');return t}calculateNextCronTime(e){try{const t=cronParser.parseExpression(e);return t.next().toDate()}catch(e){throw new web.Exception(e,'CronExpressionParseError')}}calculateNextIntervalTime(e){const t=Math.max(e,0);return new Date(Date.now()+1e3*t)}}class DockerClient extends RestClient{}class GitLabClient extends RestClient{}class KubernetesClient extends RestClient{constructor(e,t){super({headers:{Authorization:'Bearer '+t}}),this.api_server=e}url(e){return url.resolve(this.api_server,e)}listNamespaces(){return this.get(this.url('/api/v1/namespaces')).catch(e=>{throw new web.Exception(e,'Unable to list namespace')})}getNamespace(e){return this.get(this.url(`/api/v1/namespaces/${e}`)).catch(e=>{if(404===e.response.data.code)return null;throw new web.Exception(e,'Unable to get namespace')})}createNamespace(e){return this.post(this.url('/api/v1/namespaces'),{kind:'Namespace',apiVersion:'v1',metadata:{name:e}}).catch(e=>{throw new web.Exception(e,'Unable to create namespace')})}deleteNamespace(e){return this.delete(this.url(`/api/v1/namespaces/${e}`)).catch(e=>{throw new web.Exception(e,'Unable to delete namespace')})}listCronJobs(e){return'string'==typeof e&&e?this.get(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs`)):this.get(this.url('/apis/batch/v1beta1/cronjobs'))}getCronJob(e,t){return this.get(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs/${t}`)).catch(e=>{if(404===e.response.data.code)return null;throw new web.Exception(e,'Unable to get cronjob')})}createCronJob(e,t){return this.post(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs`),t).catch(e=>{throw new web.Exception(e,'Unable to create cronjob')})}deleteCronJob(e,t){return this.delete(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs/${t}`)).catch(e=>{throw new web.Exception(e,'Unable to delete cronjob')})}}class RedmineClient extends RestClient{}class TeamCityClient extends RestClient{}const fetch$1=require('node-fetch');function extractFunctionBody(e){if('function'==typeof e){const t=e.toString();return t.slice(t.indexOf('{')+1,t.lastIndexOf('}'))}return e||''}function FetchWebPage(e,t){const o={url:t.url,waitFor:t.waitFor,initScript:extractFunctionBody(t.initScript),script:extractFunctionBody(t.script)},r=new Date;if(!e.settings.JSONSDK_FETCH_API_URL)throw new Error('FetchUrlNotSet');return fetch$1(e.settings.JSONSDK_FETCH_API_URL,{method:'POST',headers:{"x-date":r.toUTCString(),"x-api-key":e.settings.JSONSDK_FETCH_API_KEY},body:JSON.stringify(o)}).then(e=>e.ok?e.json().then(t=>{const o={};if(t.cookies)for(const e of Object.keys(t.cookies)){const r=t.cookies[e];o[r.name]=r.value}return t.cookies=o,console.log('fetch bot ip',e.headers.get('x-bot-ip')),t}):{ok:0,cookies:{},logs:[e.status,e.headers.get('x-reason'),e.headers.get('x-request-ip'),e.headers.get('cf-ray')],result:null,results:[]})}class ExternalProviderGetters{static findByName(e,t){const o=e.collection(ExternalProviderCollection);return o.findOne({provider:t+''})}static findById(e,t){const o=e.collection(ExternalProviderCollection);return o.findOne({_id:t})}}exports.IdentityProfile=web.IdentityProfile,exports.WebFoundationApplication=WebFoundationApplication,exports.WebFoundationSettings=WebFoundationSettings,exports.WebFoundationService=WebFoundationService,exports.WebFoundationUserService=WebFoundationUserService,exports.WebFoundationController=WebFoundationController,exports.WebIdentity=WebIdentity,exports.DatabaseError=DatabaseError,exports.ValidationError=ValidationError,exports.user=user,exports.admin=admin,exports.role=role,exports.RoleAttribute=RoleAttribute,exports.Time=Time,exports.formatTime=formatTime,exports.formatNumber=formatNumber,exports.merge=merge,exports.Fetcher=Fetcher,exports.SYSTEM_MAX_UPLOAD_SIZE=15728640,exports.SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1,exports.Database=Database,exports.ImmutableModel=ImmutableModel,exports.Model=Model,exports.Collection=Collection,exports.Validator=Validator,exports.VertexModel=VertexModel,exports.EdgeCollection=EdgeCollection,exports.EmailCollection=EmailCollection,exports.MobileCollection=MobileCollection,exports.ExternalProviderCollection=ExternalProviderCollection,exports.ExternalUserCollection=ExternalUserCollection,exports.SessionCollection=SessionCollection,exports.UserCollection=UserCollection,exports.ApfsFileChunkCollection=ApfsFileChunkCollection,exports.ApfsFileCollection=ApfsFileCollection,exports.CurrentUser=CurrentUser,exports.UserDataProvider=UserDataProvider,exports.UserDataAzureStorageProvider=UserDataAzureStorageProvider,exports.SessionDataProvider=SessionDataProvider,exports.SessionDataAzureStorageProvider=SessionDataAzureStorageProvider,exports.AuthenticatedController=AuthenticatedController,exports.CurrentSession=CurrentSession,exports.FederationDataAzureStorageProvider=FederationDataAzureStorageProvider,exports.FederationDataProvider=FederationDataProvider,exports.OpenIdController=OpenIdController,exports.OpenIdAuthController=OpenIdAuthController,exports.EventDataProvider=EventDataProvider,exports.EventDataAzureStorageProvider=EventDataAzureStorageProvider,exports.OrganizationController=OrganizationController,exports.OrganizationCollection=OrganizationCollection,exports.OrganizationService=OrganizationService,exports.GoogleStorageService=GoogleStorageService,exports.StorageService=StorageService,exports.CronJobService=CronJobService,exports.CronJobCollection=CronJobCollection,exports.DockerClient=DockerClient,exports.GitLabClient=GitLabClient,exports.GoogleClient=GoogleClient,exports.KubernetesClient=KubernetesClient,exports.MicrosoftClient=MicrosoftClient,exports.OAuthClient=OAuthClient,exports.RedmineClient=RedmineClient,exports.RestClient=RestClient,exports.TeamCityClient=TeamCityClient,exports.WeiboClient=WeiboClient,exports.FetchWebPage=FetchWebPage,exports.ExternalProviderGetters=ExternalProviderGetters,exports.TableStorage=TableStorage,exports.TableBatchResult=TableBatchResult,exports.AzureKey=AzureKey,exports.ApfsFile=ApfsFile;
//# sourceMappingURL=index.js.map
