/* Enterprise Web Application Stack */import{Keygrip,Resolvable,BaseX,Base62,service,singleton,Symbols,AuthenticationError,ParameterError,WebApplication,RequestIdentityHelper,defineProperty,Directory,WebApplicationSettings,Exception,middleware,WebController,HttpError,PermissionError,IdentityProfile,ObjectId as ObjectId$1,PayloadTooLargeError,retry,ApplicationError,method,controller,CreateHashedObjectId as CreateHashedObjectId$1,CreateObjectSignature}from'@e2/web';export{IdentityProfile}from'@e2/web';import{ObjectId,CreateIdString,MongoDatabase,MongoModel,property,MongoCollection,MongoClient,model,CreateObjectId,IdStr,MongoAuditEvents,GetTotalCount}from'@e2/mongodb';import{Root}from'protobufjs';import{stringify}from'querystring';import{decorateClassMethod,IsNumber}from'agentframework';import{createHash,createCipheriv,createDecipheriv,randomBytes}from'crypto';import{URL,resolve}from'url';import{basename,join}from'path';import axios from'axios';import{service as service$1,singleton as singleton$1,Symbols as Symbols$1}from'@e2/lib';import{Duplex}from'stream';import{createBlobService}from'azure-storage';import{intersection}from'lodash';import{NotImplementedException,CreateHashedObjectId,singleton as singleton$2}from'@e2/core';import*as Stripe from'stripe';import{GoogleToken}from'gtoken';import{parseExpression}from'cron-parser';/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */function __decorate(e,t,n,o){var a,s=arguments.length,p=3>s?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if('object'==typeof Reflect&&'function'==typeof Reflect.decorate)p=Reflect.decorate(e,t,n,o);else for(var l=e.length-1;0<=l;l--)(a=e[l])&&(p=(3>s?a(p):3<s?a(t,n,p):a(t,n))||p);return 3<s&&p&&Object.defineProperty(t,n,p),p}function __metadata(e,t){if('object'==typeof Reflect&&'function'==typeof Reflect.metadata)return Reflect.metadata(e,t)}class SecuredCookie extends Resolvable{get name(){return'SecuredCookie'}constructor(e){super(e),console.log('WEB_SESSION_COOKIE_SECRET',e.settings.constructor.name,e.settings.WEB_SESSION_COOKIE_SECRET),this.crypts=new Keygrip(e.settings.WEB_SESSION_COOKIE_SECRET,'sha1'),this.base72=new BaseX('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ:/?&=.-,@%')}sign(e){const t=this.crypts.sign(e);return Base62.fromBuffer(this.base72.toBuffer(e))+'.'+Base62.fromBuffer(t)}verify(e){try{const t=e.split('.'),i=this.base72.fromBuffer(Base62.toBuffer(t[0])),n=Base62.toBuffer(t[1]);return!!this.crypts.verify(i,n)&&i}catch(e){return this.logger.warn(e,'Unable to verify signed cookie'),!1}}}let SessionCookieManager=class e extends Resolvable{get name(){return'SessionCookieManager'}get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t){const i=this.security.verify(t);if(i)return i;e.logger.warn({fingerprint:e.fingerprint(),cookie:t},'[INTRUSION DETECTED] User sent invalidate auth token:')}return null}set(e,t){const i={path:'/api',httpOnly:!0,secure:e.settings.SECURE,overwrite:!0};e.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,this.security.sign(t),i)}clear(e){const t={path:'/api',httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:e.settings.SECURE,overwrite:!0};e.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,'',t)}};__decorate([singleton(),__metadata('design:type',SecuredCookie)],SessionCookieManager.prototype,'security',void 0),SessionCookieManager=__decorate([service()],SessionCookieManager);class SessionProtocol{static[Symbols.Singleton](){return Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:'bytes',id:1},displayName:{type:'string',id:2},displayImageURL:{type:'string',id:3}}},WebSession:{fields:{session:{type:'bytes',id:1},user:{type:'bytes',id:2},token:{type:'bytes',id:3},roles:{type:'string',rule:'repeated',id:4},groups:{type:'string',rule:'repeated',id:5},scope:{type:'string',rule:'repeated',id:6},profile:{type:'IdentityProfile',id:7},theme:{type:'string',id:8},timezone:{type:'string',id:9},locale:{type:'string',id:10}}}}}).lookupType('WebSession')}static get schema(){const e=this[Symbols.Singleton];if(e){const e=this[Symbols.Singleton]();return Reflect.defineProperty(this,'schema',{value:e}),e}throw new Error('Symbols.Singleton is not found')}}class SessionScheme extends SessionProtocol{static encode(e){const t=Object.assign({},e);e.session instanceof ObjectId&&(t.session=e.session.id),e.user instanceof ObjectId&&(t.user=e.user.id),e.token instanceof ObjectId&&(t.token=e.token.id),e.token instanceof ObjectId&&(t.token=e.token.id);const i=t.profile;if(i){let e;e=i._id instanceof ObjectId?i._id.id:'string'==typeof i._id?Buffer.from(i._id,'hex'):new Buffer(0),i._id=e}return new Buffer(this.schema.encode(t).finish())}static decode(e){let t,i;try{i=this.schema.decode(e),t=i.toJSON()}catch(e){return null}Buffer.isBuffer(i.session)&&(t.session=new ObjectId(i.session)),Buffer.isBuffer(i.user)&&(t.user=new ObjectId(i.user)),Buffer.isBuffer(i.token)&&(t.token=new ObjectId(i.token));const n=i.profile;if(n){let e;e=Buffer.isBuffer(n._id)?new ObjectId(n._id):null,t.profile._id=e}return t}}class InternalSymbol{}InternalSymbol.ServiceContext=Symbol('WfCtx');class WebFoundationService extends Resolvable{}class WebFoundationUserService extends Resolvable{constructor(e,t){if(!t)throw new Error('User scoped service only can be created using ctx.resolve()');super(e),this[InternalSymbol.ServiceContext]=t}get domain(){const e=this[InternalSymbol.ServiceContext];return Reflect.defineProperty(this,'domain',{value:e.domain}),e.domain}addResponseHeader(e,t){this[InternalSymbol.ServiceContext].res.headers.append(e,t)}getRequestHeader(e){return this[InternalSymbol.ServiceContext].req.headers[e]}}class WfService extends WebFoundationService{}let WebSessionService=class e extends WfService{get name(){return'WebSessionService'}create(e,t){const i=this.sessionCookie.get(e);return i&&i.length?SessionScheme.decode(Base62.toBuffer(i)):null}update(e,t){const i=Object.keys(t);if(!i.length)throw new ParameterError('Unable to update empty identity, please use WebIdentityService.clear() instead');const n=SessionScheme.encode(t);if(!n||!n.byteLength)throw new AuthenticationError('Invalid session data (byteLength=0)');this.sessionCookie.set(e,Base62.fromBuffer(n))}clear(e){for(const t of Object.keys(e.identity))'id'!==t&&'address'!==t&&delete e.identity[t];this.sessionCookie.clear(e)}};__decorate([singleton(),__metadata('design:type',SessionCookieManager)],WebSessionService.prototype,'sessionCookie',void 0),WebSessionService=__decorate([service()],WebSessionService);class WebIdentity{}class WebFoundationApplication extends WebApplication{get root(){const e=this.onCreatingRootDirectory();return defineProperty(this,'root',e),e}directory(e=''){return this.root.directory(e)}file(e){return this.root.file(e)}get session(){const e=this.onCreatingWebSessionService();return defineProperty(this,'session',e),e}onCreatingWebSessionService(){return this.construct(WebSessionService)}onCreatingRootDirectory(){return Directory.withReadPermission(process.cwd())}onCreatingRequestIdentity(e){const t=new WebIdentity;t.id=RequestIdentityHelper.getDeviceId(e)||RequestIdentityHelper.createDeviceId(e),t.address=RequestIdentityHelper.createRequestAddress(e);const i=this.session.create(e);return i?Object.assign(t,i):t}}const SYSTEM_MAX_UPLOAD_SIZE=15728640,SYSTEM_MAX_CHUNK_SIZE=262144,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER=1;var OIDC_PROFILE_IMAGE_POLICIES;(function(e){e.REDIRECT='redirect',e.PROXY='proxy',e.AUTO='auto'})(OIDC_PROFILE_IMAGE_POLICIES||(OIDC_PROFILE_IMAGE_POLICIES={}));class WebFoundationSettings extends WebApplicationSettings{constructor(){super(...arguments),this.TRUSTED_EMAIL_PROVIDERS=[],this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[],this.WEB_SESSION_COOKIE_PATH='/api',this.WEB_SESSION_COOKIE_KEY='y',this.WEB_SESSION_COOKIE_SECRET=['1234567890abcdefgh'],this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEB_SIGNIN_PATH='/authentication/signin',this.WEB_SIGNIN_SUCCESS_PATH='/authentication/validate',this.WEB_SIGNIN_FAILED_PATH='/authentication/failed',this.WEB_ACCESS_DENIED_PATH='/authentication/access_denied',this.WEB_SIGNOUT_PATH='/authentication/signout',this.WEB_SIGNOUT_COMPLETE_PATH='/',this.MAX_NUMBER_OF_ACCOUNTS_PER_USER=SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,this.MAX_UPLOAD_SIZE=SYSTEM_MAX_UPLOAD_SIZE,this.MAX_CHUNK_SIZE=SYSTEM_MAX_CHUNK_SIZE,this.OIDC_PROFILE_IMAGE_POLICY=OIDC_PROFILE_IMAGE_POLICIES.REDIRECT}}const nodeFetch=require('node-fetch');function parseHTTPRequestArguments(e){const t=e.length-1;let i=null,n=null;for(let o=0;o<=t;o++)if(!i&&'string'==typeof e[o])i=e[o];else if(!n&&'object'==typeof e[o])n=e[o];else break;return{url:i,init:n}}function SendHTTPRequest(e,t,i){let n='json';const o={method:'get',headers:{"user-agent":e?e.req.headers['user-agent']:'fetch',"x-request-id":e?e.logger.context().req_id:`REQ/${CreateIdString()}`},redirect:'error'};if(i){if(i.url&&!t&&(t=i.url),i.method&&(o.method=(i.method+'').toLowerCase()),i.proxy&&e)for(const t of Object.keys(e.req.headers))o.headers[t.toLowerCase()]=e.req.headers[t];if(i.credentials&&e&&(o.headers.authorization='Bearer '+e.domain.token),i.headers)for(const e of Object.keys(i.headers))o.headers[e.toLowerCase()]=i.headers[e];i.data&&(o.body=i.data),i.agent&&(o.agent=i.agent),'boolean'==typeof i.compress&&(o.compress=i.compress),'number'==typeof i.follow&&(o.follow=i.follow),'number'==typeof i.size&&(o.size=i.size),'number'==typeof i.timeout&&(o.timeout=i.timeout),i.responseType&&(n=i.responseType)}if(o.method=o.method||'get',!t)throw new Error('InvalidURL');return nodeFetch(t,o).then(i=>{if(console.log('res'),e){const t=i.headers.get('server-timing');if(t&&t.length)for(const i of t)e.res.headers.append('server-timing',i)}const o={ok:i.ok,url:i.url,redirected:i.url!=t,headers:i.headers,status:i.status};if(!n||'json'===n)return i.json().then(e=>(Array.isArray(e)?o.results=e:o.result=e,o));if('stream'===n)o.stream=i.body||void 0;else{if('arraybuffer'===n)return i.arrayBuffer().then(e=>(o.data=e,o));if('blob'===n)return i.blob().then(e=>(o.data=e,o))}return o},e=>{throw console.log(e),e})}class InternalContextDomain{constructor(e,t){this.ctx=e,this.db=t}dispose(e){this.disposing=!0,delete this.ctx,delete this.db}get identity(){return this.ctx.identity}get resolver(){return this.ctx.req.resolver}construct(e,t,i){return this.resolver.construct(e,t,i)}resolve(e,t,i){return this.resolver.resolve(e,t,i)}get settings(){return this.ctx.settings}has(e){return Reflect.has(this.ctx.settings,e)}set(e,t){return this.ctx.set(e,t)}get logger(){return this.ctx.logger}get token(){throw new Error('Not Implemented')}collection(e){if(!this.db)throw new Error('Database support is disabled');return this.db.collection(e)}trace(e,t,...i){this.logger.trace.apply(this.logger,arguments)}debug(e,t,...i){this.logger.debug.apply(this.logger,arguments)}log(e,t,...i){this.logger.log.apply(this.logger,arguments)}info(e,t,...i){this.logger.info.apply(this.logger,arguments)}warn(e,t,...i){this.logger.warn.apply(this.logger,arguments)}error(e,t,...i){this.logger.error.apply(this.logger,arguments)}fatal(e,t,...i){this.logger.fatal.apply(this.logger,arguments)}child(e){return this.logger.child(e)}update(e){return this.logger.update(e)}context(){return this.logger.context()}async fetch(){const{url:e,init:t}=parseHTTPRequestArguments(arguments);return SendHTTPRequest(this.ctx,e,t)}}class Database extends MongoDatabase{constructor(e,t){super(e,t),this.identity=e.identity}audit(e,t={},i){return'boolean'==typeof i&&(t[''+e]=i),t[''+e+'At']=new Date,t[''+e+'From']=this.identity.address+'/id/'+this.identity.id,t[''+e+'By']=this.identity.profile,t}}var _a;class WebFoundationController extends WebController{async[_a=Symbol('Upgrade')](e,t){if(e.domain=e.settings.MONGODB_URL?new InternalContextDomain(e,(await e.resolve(Database))):new InternalContextDomain(e),e.identity&&e.identity.profile){const t=e.identity.profile;if(t&&t._id&&t._id.toString){const i=t._id.toString();e.state.uid=i,e.req.logger.update({uid:i})}}return t().then(t=>{const i=e.domain;return delete e.domain,i.dispose(!0),t},t=>{const i=e.domain;return delete e.domain,i.dispose(!0),Promise.reject(t)})}async getFailureURL(e,t){if(e.settings.WEB_SIGNIN_FAILED_PATH){const{req_id:i}=e.logger.context(),n={req_id:i,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEB_SIGNIN_FAILED_PATH+'?'+stringify(n)}throw new Exception(t,'"WEB_SIGNIN_FAILED_PATH" is not set')}}__decorate([middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],WebFoundationController.prototype,_a,null);class DatabaseError extends HttpError{get statusCode(){return 503}get statusMessage(){return'Database Error'}}class ValidationError extends HttpError{get statusCode(){return 400}get statusMessage(){return'Validation Error'}}class RoleAttribute{constructor(e){this.role=e}beforeDecorate(e,t,i){return!0}getInterceptor(){return this}intercept(e,t){const i=t[0];if(!i.identity.user)throw new AuthenticationError(`Please sign in`);if(!i.identity.roles||!i.identity.roles.includes(this.role))throw new PermissionError(`Require ${this.role} permission`);return e.invoke(t)}}function user(){return decorateClassMethod(new RoleAttribute('user'))}function admin(){return decorateClassMethod(new RoleAttribute('admin'))}function role(e){return decorateClassMethod(new RoleAttribute(e))}const sizeUnits=['B','KB','MB','GB','TB','PB'],timespanUnits=[{displayName:'d',value:864e5},{displayName:'h',value:36e5},{displayName:'m',value:6e4},{displayName:'s',value:1e3}];function formatTime(e){return 1e3>e?'':6e4>e?formatNumber(e,{format:'time',start:3,end:4}):formatNumber(e,{format:'time',start:1,end:3})}function formatNumber(e,i){if('percentage'===i.format){const t=new Intl.NumberFormat;return t.format(100*e)+'%'}if('time'===i.format){let n='',o=e;const d=i.end||timespanUnits.length;for(let e=i.start||0;e<d;e++){const t=timespanUnits[e],i=Math.floor(o/t.value);o-=i*t.value,n&&(n+=' '),n=n+i+t.displayName}return n}if('byte'===i.format){if(isNaN(e)||!isFinite(e))return'?';let t=0;for(;1024<=e;)e/=1024,t++;return e.toFixed(t?2:0)+' '+sizeUnits[t]}if('currency'===i.format){const t=new Intl.NumberFormat('en-US',{style:'currency',currency:i.format_currency_code||'USD'});return t.format(e)}if('number'===i.format){const t=new Intl.NumberFormat;return t.format(e)}return e+''}class Time{static duration(e,t){const i=t.getTime()-e.getTime();return formatTime(i)}}function merge(...e){return Object.assign({},e.map(e=>e||{}))}class Fetcher extends WebFoundationService{constructor(e,t){super(e),this.ctx=t||null}async fetch(){const{url:e,init:t}=parseHTTPRequestArguments(arguments);return SendHTTPRequest(this.ctx,e,t)}}class ImmutableModel extends MongoModel{}__decorate([property(),__metadata('design:type',Date)],ImmutableModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],ImmutableModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ImmutableModel.prototype,'createdBy',void 0);class Model extends ImmutableModel{}__decorate([property(),__metadata('design:type',Date)],Model.prototype,'expireAt',void 0),__decorate([property(),__metadata('design:type',Date)],Model.prototype,'updatedAt',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'updatedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],Model.prototype,'updatedBy',void 0),__decorate([property(),__metadata('design:type',Boolean)],Model.prototype,'activated',void 0),__decorate([property(),__metadata('design:type',Date)],Model.prototype,'activatedAt',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'activatedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],Model.prototype,'activatedBy',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'activatedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],Model.prototype,'blocked',void 0),__decorate([property(),__metadata('design:type',Date)],Model.prototype,'blockedAt',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'blockedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],Model.prototype,'blockedBy',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'blockedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],Model.prototype,'deleted',void 0),__decorate([property(),__metadata('design:type',Date)],Model.prototype,'deletedAt',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'deletedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],Model.prototype,'deletedBy',void 0),__decorate([property(),__metadata('design:type',String)],Model.prototype,'deletedReason',void 0);class Collection extends MongoCollection{static[Symbols.Initializer](e,t){const i=t||e;let n;t&&t.settings.MONGODB_URL&&t.settings.MONGODB_URL!==e.settings.MONGODB_URL?(n=t,n.logger.log({collection:this.name},'Resolving mongodb client from user scope for new collection')):n=e;const o=n.construct(MongoClient);return o.connected?i.construct(Database).collection(this):(o.logger.log({collection:this.name},'MongoClient is not ready, trying connecting database'),o.connect().then(()=>i.construct(Database).collection(this)))}}class Validator{static validate(e){if(!e)throw new ValidationError(`model should not be null`);if(e.deleted)if(e.deletedAt)throw new ValidationError(`${e.getType()} has been deleted at ${e.deletedAt.toISOString()}`);else throw new ValidationError(`${e.getType()} has been deleted`);if(e.blocked)if(e.blockedAt)throw new ValidationError(`${e.getType()} has been blocked at ${e.blockedAt.toISOString()}`);else throw new ValidationError(`${e.getType()} has been blocked`);if(e.expireAt&&e.expireAt.getTime()<Date.now())throw new ValidationError(`${e.getType()} has been expired at ${e.expireAt.toISOString()}`)}}class VertexModel extends Model{}let EdgeModel=class e extends Model{};__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'outType',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'label',void 0),__decorate([property(),__metadata('design:type',String)],EdgeModel.prototype,'inType',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'outV',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'inV',void 0),__decorate([property(),__metadata('design:type',Object)],EdgeModel.prototype,'meta',void 0),EdgeModel=__decorate([model('edge')],EdgeModel);let EdgeSymbolKey=Symbol('agentframework.mongodb.graph.edge');class EdgeCollection extends Collection{constructor(e){super(e,EdgeModel)}findInVertices(e,t,i,n){const o=i.getType();return this.aggregation({filter:n?{outV:e,outType:t,label:n,inType:o}:{outV:e,outType:t,inType:o},lookup:{inV:o}}).then(e=>{const t=[];return e.forEach(e=>{const n=i.wrap(e.inV)||{deleted:!0};Reflect.set(n,EdgeSymbolKey,e),t.push(n)}),t})}findOutVertices(e,t,i,n){const o=i.getType();return this.aggregation({filter:n?{inV:e,inType:t,label:n,outType:o}:{inV:e,inType:t,outType:o},lookup:{outV:o}}).then(e=>{const t=[];return e.forEach(e=>{const n=i.wrap(e.outV)||{deleted:!0};Reflect.set(n,EdgeSymbolKey,e),t.push(n)}),t})}outV(e,t,i={},n={},o={}){return this.aggregation({filter:merge(i,{outV:e,label:t}),lookup:{inV:t},projection:n,sort:o})}inV(e,t,i,n={},o={},d={}){return this.aggregation({filter:merge(n,{inV:e,label:t}),lookup:{outV:i},projection:o,sort:d})}removeRelationships(e){return Promise.all([this.find({outV:e}).then(e=>e.results),this.find({inV:e}).then(e=>e.results)]).then(([e,t])=>e.length||t.length?this.deleteMany([...e,...t]):[])}static getIndices(){return[{name:'unique_relationship',key:{inV:1,inType:1,label:1,outV:1,outType:1},unique:!0},{name:'index_outV_outType_inV_inType',key:{outV:1,outType:1,inV:1,inType:1}},{name:'index_outV_outType_label_inType',key:{outV:1,outType:1,label:1,inType:1}},{name:'index_outV_outType_label',key:{outV:1,outType:1,label:1}},{name:'index_outV_outType_inType',key:{outV:1,outType:1,inType:1}},{name:'index_outV_outType',key:{outV:1,outType:1}},{name:'index_inV_inType_label_inType',key:{inV:1,inType:1,label:1,outType:1}},{name:'index_inV_inType_label',key:{inV:1,inType:1,label:1}},{name:'index_inV_inType_inType',key:{inV:1,inType:1,outType:1}},{name:'index_inV_inType',key:{inV:1,inType:1}},{name:'index_deleted',key:{deleted:1}},{name:'index_blocked',key:{blocked:1}}]}createIndices(){return super.createIndex(EdgeCollection.getIndices())}}let EmailModel=class e extends Model{};__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',ObjectId)],EmailModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',Boolean)],EmailModel.prototype,'verified',void 0),__decorate([property(),__metadata('design:type',Date)],EmailModel.prototype,'verifiedAt',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],EmailModel.prototype,'verifiedBy',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'verifiedFrom',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'verifiedReason',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'verifyToken',void 0),__decorate([property(),__metadata('design:type',Number)],EmailModel.prototype,'verifyTokenFailures',void 0),__decorate([property(),__metadata('design:type',Date)],EmailModel.prototype,'verifyTokenExpires',void 0),__decorate([property(),__metadata('design:type',Date)],EmailModel.prototype,'resetPasswordAt',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'resetPasswordFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],EmailModel.prototype,'resetPasswordBy',void 0),__decorate([property(),__metadata('design:type',String)],EmailModel.prototype,'resetPasswordToken',void 0),__decorate([property(),__metadata('design:type',Number)],EmailModel.prototype,'resetPasswordTokenFailures',void 0),__decorate([property(),__metadata('design:type',Date)],EmailModel.prototype,'resetPasswordTokenExpires',void 0),EmailModel=__decorate([model('email')],EmailModel);class EmailCollection extends Collection{constructor(e){super(e,EmailModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(EmailCollection.getIndices())}}let MobileModel=class e extends Model{};__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',ObjectId)],MobileModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',Boolean)],MobileModel.prototype,'verified',void 0),__decorate([property(),__metadata('design:type',Date)],MobileModel.prototype,'verifiedAt',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],MobileModel.prototype,'verifiedBy',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'verifiedFrom',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'verifiedReason',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'verifyToken',void 0),__decorate([property(),__metadata('design:type',Number)],MobileModel.prototype,'verifyTokenFailures',void 0),__decorate([property(),__metadata('design:type',Date)],MobileModel.prototype,'verifyTokenExpires',void 0),__decorate([property(),__metadata('design:type',Date)],MobileModel.prototype,'resetPasswordAt',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'resetPasswordFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],MobileModel.prototype,'resetPasswordBy',void 0),__decorate([property(),__metadata('design:type',String)],MobileModel.prototype,'resetPasswordToken',void 0),__decorate([property(),__metadata('design:type',Number)],MobileModel.prototype,'resetPasswordTokenFailures',void 0),__decorate([property(),__metadata('design:type',Date)],MobileModel.prototype,'resetPasswordTokenExpires',void 0),MobileModel=__decorate([model('mobile')],MobileModel);class MobileCollection extends Collection{constructor(e){super(e,MobileModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(MobileCollection.getIndices())}}let ExternalProviderModel=class e extends Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):'{}',expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):'{}'}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'provider',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'providerProtocol',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'providerURL',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'providerFingerprint',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalProviderModel.prototype,'providerConfiguration',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'appID',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'appSecret',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'scope',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'displayImageURL',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'description',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalProviderModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ExternalProviderModel.prototype,'createdBy',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalProviderModel.prototype,'expireAt',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalProviderModel.prototype,'updatedAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalProviderModel.prototype,'updatedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ExternalProviderModel.prototype,'updatedBy',void 0),ExternalProviderModel=__decorate([model('external_provider')],ExternalProviderModel);class ExternalProviderCollection extends Collection{constructor(e){super(e,ExternalProviderModel)}static getIndices(){return[{name:'unique_external_provider',key:{provider:1,providerProtocol:1,providerURL:1,appID:1},unique:!0}]}createIndices(){return super.createIndex(ExternalProviderCollection.getIndices())}}let ExternalUserModel=class e extends Model{};__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'uid',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'provider',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'providerProtocol',void 0),__decorate([property(),__metadata('design:type',ObjectId)],ExternalUserModel.prototype,'providerId',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'providerData',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'userData',void 0),__decorate([property(),__metadata('design:type',Array)],ExternalUserModel.prototype,'identities',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'username',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'domain',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'email',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'emailCertified',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'mobile',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'mobileCertified',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'displayImageURL',void 0),__decorate([property(),__metadata('design:type',ObjectId)],ExternalUserModel.prototype,'displayImageFile',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'familyName',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'givenName',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'gender',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'dob',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'status',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'bio',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'homepage',void 0),__decorate([property(),__metadata('design:type',Object)],ExternalUserModel.prototype,'locale',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'blocked',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalUserModel.prototype,'blockedAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'blockedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ExternalUserModel.prototype,'blockedBy',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'blockedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],ExternalUserModel.prototype,'deleted',void 0),__decorate([property(),__metadata('design:type',Date)],ExternalUserModel.prototype,'deletedAt',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'deletedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ExternalUserModel.prototype,'deletedBy',void 0),__decorate([property(),__metadata('design:type',String)],ExternalUserModel.prototype,'deletedReason',void 0),ExternalUserModel=__decorate([model('external_user')],ExternalUserModel);class ExternalUserCollection extends Collection{constructor(e){super(e,ExternalUserModel)}static getIndices(){return[{name:'unique_external_user',key:{provider:1,providerProtocol:1,uid:1},unique:!0},{name:'index_provider',key:{provider:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(ExternalUserCollection.getIndices())}}let SessionModel=class e extends Model{};__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'device',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'provider',void 0),__decorate([property(),__metadata('design:type',ObjectId)],SessionModel.prototype,'providerId',void 0),__decorate([property(),__metadata('design:type',ObjectId)],SessionModel.prototype,'authenticator',void 0),__decorate([property(),__metadata('design:type',Object)],SessionModel.prototype,'authenticationToken',void 0),__decorate([property(),__metadata('design:type',ObjectId)],SessionModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',Array)],SessionModel.prototype,'roles',void 0),__decorate([property(),__metadata('design:type',ObjectId)],SessionModel.prototype,'token',void 0),__decorate([property(),__metadata('design:type',Array)],SessionModel.prototype,'tokens',void 0),__decorate([property(),__metadata('design:type',ObjectId)],SessionModel.prototype,'previous',void 0),__decorate([property(),__metadata('design:type',Boolean)],SessionModel.prototype,'impersonated',void 0),__decorate([property(),__metadata('design:type',Date)],SessionModel.prototype,'impersonatedAt',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'impersonatedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],SessionModel.prototype,'impersonatedBy',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'impersonatedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],SessionModel.prototype,'blocked',void 0),__decorate([property(),__metadata('design:type',Date)],SessionModel.prototype,'blockedAt',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'blockedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],SessionModel.prototype,'blockedBy',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'blockedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],SessionModel.prototype,'deleted',void 0),__decorate([property(),__metadata('design:type',Date)],SessionModel.prototype,'deletedAt',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'deletedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],SessionModel.prototype,'deletedBy',void 0),__decorate([property(),__metadata('design:type',String)],SessionModel.prototype,'deletedReason',void 0),SessionModel=__decorate([model('session')],SessionModel);class SessionCollection extends Collection{constructor(e){super(e,SessionModel)}static getIndices(){return[{name:'expires',key:{expireAt:1},expireAfterSeconds:0,sparse:!0}]}createIndices(){return super.createIndex(SessionCollection.getIndices())}}let UserModel=class e extends Model{};__decorate([property(),__metadata('design:type',Number)],UserModel.prototype,'id',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'displayImageURL',void 0),__decorate([property(),__metadata('design:type',Object)],UserModel.prototype,'signature',void 0),__decorate([property(),__metadata('design:type',Object)],UserModel.prototype,'location',void 0),__decorate([property(),__metadata('design:type',Object)],UserModel.prototype,'address',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'email',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'mobile',void 0),__decorate([property(),__metadata('design:type',Array)],UserModel.prototype,'roles',void 0),__decorate([property(),__metadata('design:type',Object)],UserModel.prototype,'identities',void 0),__decorate([property(),__metadata('design:type',Object)],UserModel.prototype,'settings',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'theme',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'timezone',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'locale',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'password',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'passwordSalt',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'paymentPassword',void 0),__decorate([property(),__metadata('design:type',String)],UserModel.prototype,'paymentPasswordSalt',void 0),UserModel=__decorate([model('user')],UserModel);class UserCollection extends Collection{constructor(e){super(e,UserModel)}static getIndices(){return[{name:'unique_name',key:{name:1},unique:!0,sparse:!0},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(UserCollection.getIndices())}}let ApfsFileChunkModel=class e extends ImmutableModel{};__decorate([property(),__metadata('design:type',Object)],ApfsFileChunkModel.prototype,'hash',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileChunkModel.prototype,'type',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileChunkModel.prototype,'byteLength',void 0),__decorate([property(),__metadata('design:type',Buffer)],ApfsFileChunkModel.prototype,'data',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileChunkModel.prototype,'dataOffset',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileChunkModel.prototype,'dataByteLength',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileChunkModel.prototype,'dataEncoding',void 0),__decorate([property(),__metadata('design:type',Date)],ApfsFileChunkModel.prototype,'expireAt',void 0),__decorate([property(),__metadata('design:type',Date)],ApfsFileChunkModel.prototype,'createdAt',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileChunkModel.prototype,'createdFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ApfsFileChunkModel.prototype,'createdBy',void 0),__decorate([property(),__metadata('design:type',Date)],ApfsFileChunkModel.prototype,'updatedAt',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileChunkModel.prototype,'updatedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],ApfsFileChunkModel.prototype,'updatedBy',void 0),ApfsFileChunkModel=__decorate([model('apfs_chunk')],ApfsFileChunkModel);class ApfsFileChunkCollection extends Collection{constructor(e){super(e,ApfsFileChunkModel)}static getIndices(){return[{name:'unique_chunk',key:{"hash.md5":1,"hash.sha1":1,"hash.sha256":1,"hash.ipfs":1},unique:!0,sparse:!0},{name:'index_hash_1',key:{"hash.md5":'hashed'}},{name:'index_hash_2',key:{"hash.sha1":'hashed'}},{name:'index_hash_3',key:{"hash.sha256":'hashed'}},{name:'index_hash_4',key:{"hash.ipfs":'hashed'}}]}createIndices(){return super.createIndex(ApfsFileChunkCollection.getIndices())}}let ApfsFileModel=class e extends Model{toUrl(){return'apfs://'+this.path}};__decorate([property(),__metadata('design:type',String)],ApfsFileModel.prototype,'path',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileModel.prototype,'type',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileModel.prototype,'byteLength',void 0),__decorate([property(),__metadata('design:type',String)],ApfsFileModel.prototype,'originalname',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileModel.prototype,'width',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileModel.prototype,'height',void 0),__decorate([property(),__metadata('design:type',Number)],ApfsFileModel.prototype,'duration',void 0),__decorate([property(),__metadata('design:type',Object)],ApfsFileModel.prototype,'hash',void 0),__decorate([property(),__metadata('design:type',Array)],ApfsFileModel.prototype,'chunks',void 0),__decorate([property(),__metadata('design:type',Object)],ApfsFileModel.prototype,'context',void 0),__decorate([property(),__metadata('design:type',Object)],ApfsFileModel.prototype,'stats',void 0),__decorate([property(),__metadata('design:type',Array)],ApfsFileModel.prototype,'tokens',void 0),__decorate([property(),__metadata('design:type',ObjectId$1)],ApfsFileModel.prototype,'previous',void 0),ApfsFileModel=__decorate([model('apfs_file')],ApfsFileModel);class ApfsFileCollection extends Collection{constructor(e){super(e,ApfsFileModel)}static getIndices(){return[{name:'unique_file',key:{path:1},unique:!0,sparse:!0}]}createIndices(){return super.createIndex(ApfsFileCollection.getIndices())}}var EventType;(function(e){e.SIGN_UP='sign-up',e.SIGN_UP_FAILED='sign-up-failed',e.SIGN_IN='sign-in',e.SIGN_IN_FAILED='sign-in-failed',e.SIGN_OUT='sign-out',e.SESSION_EXPIRED='session-expired',e.ACCESS_DENIED='access-denied'})(EventType||(EventType={}));let EventModel=class e extends Model{};__decorate([property(),__metadata('design:type',Number)],EventModel.prototype,'id',void 0),__decorate([property(),__metadata('design:type',String)],EventModel.prototype,'type',void 0),__decorate([property(),__metadata('design:type',Object)],EventModel.prototype,'context',void 0),EventModel=__decorate([model('event')],EventModel);class EventCollection extends Collection{constructor(e){super(e,EventModel)}static getIndices(){return[{name:'unique_event_id',key:{id:1},unique:!0}]}createIndices(){return super.createIndex(EventCollection.getIndices())}}let StripeCustomerModel=class e extends Model{};__decorate([property(),__metadata('design:type',ObjectId)],StripeCustomerModel.prototype,'user',void 0),__decorate([property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'customerId',void 0),__decorate([property(),__metadata('design:type',Boolean)],StripeCustomerModel.prototype,'blocked',void 0),__decorate([property(),__metadata('design:type',Date)],StripeCustomerModel.prototype,'blockedAt',void 0),__decorate([property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'blockedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],StripeCustomerModel.prototype,'blockedBy',void 0),__decorate([property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'blockedReason',void 0),__decorate([property(),__metadata('design:type',Boolean)],StripeCustomerModel.prototype,'deleted',void 0),__decorate([property(),__metadata('design:type',Date)],StripeCustomerModel.prototype,'deletedAt',void 0),__decorate([property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'deletedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],StripeCustomerModel.prototype,'deletedBy',void 0),__decorate([property(),__metadata('design:type',String)],StripeCustomerModel.prototype,'deletedReason',void 0),StripeCustomerModel=__decorate([model('payment_stripe_customer')],StripeCustomerModel);class StripeCustomerCollection extends Collection{constructor(e){super(e,StripeCustomerModel)}static getIndices(){return[{name:'unique_payment_stripe',key:{user:1},unique:!0}]}createIndices(){return super.createIndex(StripeCustomerCollection.getIndices())}}let OrganizationModel=class e extends VertexModel{};__decorate([property(),__metadata('design:type',Number)],OrganizationModel.prototype,'id',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'name',void 0),__decorate([property(),__metadata('design:type',ObjectId$1)],OrganizationModel.prototype,'owner',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'displayName',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'displayImageURL',void 0),__decorate([property(),__metadata('design:type',Object)],OrganizationModel.prototype,'settings',void 0),__decorate([property(),__metadata('design:type',Boolean)],OrganizationModel.prototype,'verified',void 0),__decorate([property(),__metadata('design:type',Date)],OrganizationModel.prototype,'verifiedAt',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'verifiedFrom',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],OrganizationModel.prototype,'verifiedBy',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'verifiedReason',void 0),__decorate([property(),__metadata('design:type',String)],OrganizationModel.prototype,'verifyToken',void 0),__decorate([property(),__metadata('design:type',Number)],OrganizationModel.prototype,'verifyTokenFailures',void 0),__decorate([property(),__metadata('design:type',Date)],OrganizationModel.prototype,'verifyTokenExpires',void 0),OrganizationModel=__decorate([model('organization')],OrganizationModel);class OrganizationCollection extends Collection{constructor(e){super(e,OrganizationModel)}static getIndices(){return[{name:'unique_organization_id',key:{id:1},unique:!0},{name:'unique_organization_name',key:{name:1},unique:!0}]}createIndices(){return super.createIndex(OrganizationCollection.getIndices())}makeIdQuery(e){let t;if(e instanceof ObjectId$1)t={_id:e};else if('number'==typeof e){if(isNaN(e))throw new Error('Organization id should not be an NaN');t={id:e}}else t={name:e+''};return t}}let CronJobModel=class e extends Model{};__decorate([property(),__metadata('design:type',String)],CronJobModel.prototype,'cron',void 0),__decorate([property(),__metadata('design:type',Number)],CronJobModel.prototype,'intervalInSeconds',void 0),__decorate([property(),__metadata('design:type',Date)],CronJobModel.prototype,'nextScheduleAt',void 0),__decorate([property(),__metadata('design:type',Date)],CronJobModel.prototype,'lastScheduleAt',void 0),__decorate([property(),__metadata('design:type',IdentityProfile)],CronJobModel.prototype,'lastScheduleBy',void 0),__decorate([property(),__metadata('design:type',String)],CronJobModel.prototype,'lastScheduleFrom',void 0),__decorate([property(),__metadata('design:type',Number)],CronJobModel.prototype,'lastScheduleRetries',void 0),__decorate([property(),__metadata('design:type',Number)],CronJobModel.prototype,'lastScheduleDuration',void 0),__decorate([property(),__metadata('design:type',String)],CronJobModel.prototype,'lastScheduleResult',void 0),__decorate([property(),__metadata('design:type',Object)],CronJobModel.prototype,'payload',void 0),CronJobModel=__decorate([model('cronjob')],CronJobModel);class CronJobCollection extends Collection{constructor(e){super(e,CronJobModel)}static getIndices(){return[{name:'unique_key',key:{key:1},unique:!0,sparse:!0},{name:'index_nextScheduleAt',key:{nextScheduleAt:1}},{name:'index_lastScheduleAt',key:{lastScheduleAt:1}},{name:'index_blocked',key:{blocked:1}},{name:'index_deleted',key:{deleted:1}}]}createIndices(){return super.createIndex(CronJobCollection.getIndices())}}let AdminService=class e extends WebFoundationService{constructor(e){super(e)}async createIndices(e){const t=[await e.collection(ApfsFileChunkCollection).createIndices(),await e.collection(ApfsFileCollection).createIndices(),await e.collection(EventCollection).createIndices(),await e.collection(ExternalProviderCollection).createIndices(),await e.collection(ExternalUserCollection).createIndices(),await e.collection(EdgeCollection).createIndices(),await e.collection(SessionCollection).createIndices(),await e.collection(StripeCustomerCollection).createIndices(),await e.collection(OrganizationCollection).createIndices(),await e.collection(CronJobCollection).createIndices(),await e.collection(EmailCollection).createIndices(),await e.collection(MobileCollection).createIndices(),await e.collection(UserCollection).createIndices()];return t}};AdminService=__decorate([service(),__metadata('design:paramtypes',[WebFoundationApplication])],AdminService);const ApfsFileMetadataFields=['originalname','duration','width','height','type'];let ApfsService=class e extends Resolvable{get name(){return'ApfsService'}parse(e){try{const t=new URL(e);return'apfs:'===t.protocol?{filename:t.pathname}:null}catch(e){return null}}async download(e,t,i=!1){return axios({method:'get',url:t,responseType:'stream'}).then(e=>e,e=>(this.logger.warn(e,`Unable to fetch remote url ${t}`),null))}async save(e,t,i=!1){const n=t.filename,o={md5:createHash('md5').update(t.data).digest(),sha1:createHash('sha1').update(t.data).digest(),sha256:createHash('sha256').update(t.data).digest()},d=e.collection(ApfsFileCollection),r=await d.findOne({path:n});let a=!1;if(r){if(!i)throw new Error(`File ${n} already exists`);let e=!0;for(const i of ApfsFileMetadataFields)'undefined'!=typeof t[i]&&(e=e&&r[i]===t[i]);let s=!0;if(s=s&&Buffer.isBuffer(r.hash.md5)&&0===Buffer.compare(o.md5,r.hash.md5),s=s&&Buffer.isBuffer(r.hash.sha1)&&0===Buffer.compare(o.sha1,r.hash.sha1),s=s&&Buffer.isBuffer(r.hash.sha256)&&0===Buffer.compare(o.sha256,r.hash.sha256),e&&s)return this.logger.trace({fileType:r.type,byteLength:r.byteLength},`Ignore updating same file ${r._id} at apfs://${n}`),r;if(!s){a=!0;const e=await d.findOneAndUpdate({_id:r._id},{$unset:{path:''}});this.logger.trace({fileType:r.type,byteLength:r.byteLength,unlinked:!!e},`Unlinked file ${r._id} from apfs://${n}`)}}else a=!0;let s;if(a){const i=e.collection(ApfsFileChunkCollection),{n:d,results:n}=await i.find({$and:[{"hash.md5":o.md5},{"hash.sha1":o.sha1},{"hash.sha256":o.sha256}]},{data:0});if(d!==n.length)throw new Error('Too many chunks for a hash, sha256='+o.sha256);if(!d){const d=t.data.byteLength;if(d>e.settings.MAX_UPLOAD_SIZE)throw new PayloadTooLargeError('Buffer size over system limit');const r=await i.insertOne({hash:o,type:t.type,byteLength:d,data:t.data,dataOffset:0,dataByteLength:t.data.byteLength,dataEncoding:'binary'});r&&n.push(r)}if(!n.length)throw new Error('unable to find or save file chunk');const r=n.reduce((e,t)=>e+t.dataByteLength,0);s={byteLength:r,hash:o,chunks:n.map(e=>({_id:e._id,offset:e.dataOffset,byteLength:e.dataByteLength}))}}else s={};for(const n of ApfsFileMetadataFields)'undefined'!=typeof t[n]&&(s[n]=t[n]);r&&(s.previous=r._id);const p=await d.findOneAndUpsert({path:t.filename},{$setOnInsert:{path:t.filename,name:basename(t.filename),stats:{update:0,read:0},tokens:[],context:null},$set:s},{_id:1});if(!p)throw new Error('Unable to save ');return d.findOneAndUpdate({_id:p._id},{$inc:{"stats.update":1}}).then(e=>e||p)}async load(e,t){const i=this.parse(t);if(!i)throw new Error('Invalid apfs url '+t);const n=i.filename,o=await e.collection(ApfsFileCollection),d=e.collection(ApfsFileChunkCollection),r=await o.findOneAndUpdate({path:n},{$inc:{"stats.read":1}});if(r&&r.chunks&&r.chunks.length){const e=r.chunks.map(e=>e._id),{results:t}=await d.find({_id:{$in:e}}),i=new Buffer(r.byteLength);for(const e of t)if(Buffer.isBuffer(e.data))e.data.copy(i,e.dataOffset);else throw new Error(`Invalid chunk, id: ${e._id} from: ${e.dataOffset} to: ${e.dataByteLength}`);return{filename:r.path,type:r.type,data:i,byteLength:r.byteLength,hash:r.hash,context:r.context,stats:r.stats,width:r.width,height:r.height,duration:r.duration,originalname:r.originalname,createdAt:r.createdAt,updatedAt:r.updatedAt}}return null}};ApfsService=__decorate([service()],ApfsService);class ApfsFile{}class Security{static encrypt(e){const t=randomBytes(16),i=randomBytes(32),n=createCipheriv('aes-256-cbc',i,t);let o=n.update(e);return o=Buffer.concat([o,n.final()]),{data:o.toString('hex'),salt:t.toString('hex')+'n'+i.toString('hex')}}static decrypt(e){const t=e.salt.split('n'),i=Buffer.from(t[0],'hex'),n=Buffer.from(t[1],'hex'),o=createDecipheriv('aes-256-cbc',n,i);let d=o.update(Buffer.from(e.data,'hex'));return d=Buffer.concat([d,o.final()]),d.toString()}}class EmailGetters{static async findOneByEmail(e,t){const i=e.collection(EmailCollection);return i.findOne({name:t})}static async findOneByUser(e,t){const i=e.collection(EmailCollection);return i.findOne({user:t})}}class UserGetters{static findOneById(e,t){const i=e.collection(UserCollection);return i.findOneById(t)}static findOneByName(e,t){const i=e.collection(UserCollection);return i.findOne({name:t})}}class UserMutations{static async insertOne(e,t){if(!t)throw new TypeError('user to insert should not be null');if(!t.displayName)throw new TypeError('displayName is required');const i=e.collection(UserCollection);return t.settings||(t.settings={}),i.insertOne(t).then(e=>{if(!e)throw new DatabaseError({user:t},'Unable to create user');return e})}static async updateUser(e,t,i,n){const o=e.collection(UserCollection);return o.findOneAndUpdate({_id:new ObjectId$1(t)},{$set:{[i]:n}})}static async updateUserFields(e,t,i){const n=e.collection(UserCollection);return n.findOneAndUpdate({_id:new ObjectId$1(t)},{$set:i})}}class MobileGetters{static async findOneByEmail(e,t){const i=e.collection(MobileCollection);return i.findOne({name:t})}static async findOneByUser(e,t){const i=e.collection(MobileCollection);return i.findOne({user:t})}}class UserDataProvider extends WfService{async findOneById(e,t){return UserGetters.findOneById(e,t)}async findOneByName(e,t){return UserGetters.findOneByName(e,t)}async findOneByEmail(e,t){const i=await EmailGetters.findOneByEmail(e,t);return i&&i.user?UserGetters.findOneById(e,i.user):null}insertOne(e,t){return UserMutations.insertOne(e,t)}updateUserFields(e,t,i){return UserMutations.updateUserFields(e,t,i)}updateUser(e,t,i,n){return UserMutations.updateUser(e,t,i,n)}findEmailByUser(e,t){return EmailGetters.findOneByUser(e,t)}findMobileByUser(e,t){return MobileGetters.findOneByUser(e,t)}}let UserService=class e extends WfService{get name(){return'UserService'}findEmailByUser(e,t){return this.data.findEmailByUser(e,t)}findMobileByUser(e,t){return this.data.findMobileByUser(e,t)}findOneById(e,t){if(!t)throw new Error('UserIdRequired');return this.data.findOneById(e,t)}findOneByName(e,t){if(!t)throw new Error('UsernameRequired');return this.data.findOneByName(e,t)}async findOneByEmail(e,t){if(!t)throw new TypeError('email is required');return this.data.findOneByEmail(e,t)}async insertOne(e,t){return this.data.insertOne(e,t)}async update(e,t,i,n){if(t){if('password'===i){const i=Security.encrypt(n),o={password:i.data,passwordSalt:i.salt};return this.data.updateUserFields(e,t,o)}return this.data.updateUser(e,t,i,n)}return null}async getCredential(e,t){if(t){const i=await this.data.findOneById(e,t);if(i)return{username:i.name,password:Security.decrypt({data:i.password,salt:i.passwordSalt})}}return null}};__decorate([singleton$1(),__metadata('design:type',UserDataProvider)],UserService.prototype,'data',void 0),UserService=__decorate([service$1()],UserService);class CurrentUser extends UserModel{static async[Symbols.Initializer](e,t){if(!t)throw new Error('CurrentUser is only resolvable from ctx scope');const i=t.identity.user;return i instanceof ObjectId$1?t.resolve(UserService).then(e=>e.findOneById(t.domain,i).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentUser.prototype),e))):null}}class LineReader{constructor(e,t='\r\n'){this.raw=e,this.linebreak=t,this.pos=0,this.ended=!1}read(){const e=this.raw.indexOf(this.linebreak,this.pos);let t;return 0>e?(this.ended=!0,t=this.raw.slice(this.pos),this.pos=this.raw.length):(t=this.raw.slice(this.pos,e),this.pos=e+this.linebreak.length),t}next(){const e=this.raw.indexOf(this.linebreak,this.pos);0>e?(this.ended=!0,this.pos=this.raw.length):this.pos=e+this.linebreak.length}rest(){const e=this.raw.slice(this.pos);return this.ended=!0,this.pos=this.raw.length,e}end(){return this.ended}}function ParseResponses(e){const t=e.headers.get('content-type'),i=extractBoundaryFromContentType(t),n=[];if(i){let t=e.text.split('--'+i);for(const e of t)e.length&&'--\r\n'!==e&&'--\n'!==e&&n.push(parseResponse(e))}else n.push(parseResponse(e.text));return n}function ParseResponse(e){return parseResponse(e.text)}function extractBoundaryFromContentType(e){if(!e||'string'!=typeof e)return'';const t=e.split(';');return 2>t.length||'multipart/mixed'!==t[0].toLowerCase()||0>t[1].indexOf('=')?'':t[1].split('=')[1]}function parseResponse(e){const t={status:0,statusText:'',headers:new Headers,text:'',json:null};e.startsWith('\r\n')?e=e.slice(2):e.startsWith('\n')&&(e=e.slice(1));for(const i=new LineReader(e);!i.end();){const e=i.read();if(e){const i=e.indexOf(':');if(0<i){const n=e.slice(0,i),o=e.slice(i+2);t.headers.set(n,o)}else{const i=e.split(' ');t.status=+i[1],t.statusText=i.slice(2).join(' ')}}else{const e=i.rest(),n=t.headers.get('content-type');n&&n.startsWith('application/json')?t.json=JSON.parse(e):t.text=e}}return t}const digestLength=32,blockSize=64,K=new Uint32Array([1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298]);function hashBlocks(t,n,e,o,r){for(let s,a,p,l,d,y,c,g,m,u,i,f,h;64<=r;){for(s=n[0],a=n[1],p=n[2],l=n[3],d=n[4],y=n[5],c=n[6],g=n[7],u=0;16>u;u++)i=o+4*u,t[u]=(255&e[i])<<24|(255&e[i+1])<<16|(255&e[i+2])<<8|255&e[i+3];for(u=16;64>u;u++)m=t[u-2],f=(m>>>17|m<<15)^(m>>>19|m<<13)^m>>>10,m=t[u-15],h=(m>>>7|m<<25)^(m>>>18|m<<14)^m>>>3,t[u]=(0|f+t[u-7])+(0|h+t[u-16]);for(u=0;64>u;u++)f=0|(0|((d>>>6|d<<26)^(d>>>11|d<<21)^(d>>>25|d<<7))+(d&y^~d&c))+(0|g+(0|K[u]+t[u])),h=0|((s>>>2|s<<30)^(s>>>13|s<<19)^(s>>>22|s<<10))+(s&a^s&p^a&p),g=c,c=y,y=d,d=0|l+f,l=p,p=a,a=s,s=0|f+h;n[0]+=s,n[1]+=a,n[2]+=p,n[3]+=l,n[4]+=d,n[5]+=y,n[6]+=c,n[7]+=g,o+=64,r-=64}return o}class Hash{constructor(){this.digestLength=digestLength,this.blockSize=blockSize,this.state=new Int32Array(8),this.temp=new Int32Array(64),this.buffer=new Uint8Array(128),this.bufferLength=0,this.bytesHashed=0,this.finished=!1,this.reset()}reset(){return this.state[0]=1779033703,this.state[1]=3144134277,this.state[2]=1013904242,this.state[3]=2773480762,this.state[4]=1359893119,this.state[5]=2600822924,this.state[6]=528734635,this.state[7]=1541459225,this.bufferLength=0,this.bytesHashed=0,this.finished=!1,this}clean(){for(let e=0;e<this.buffer.length;e++)this.buffer[e]=0;for(let e=0;e<this.temp.length;e++)this.temp[e]=0;this.reset()}update(e,t=e.length){if(this.finished)throw new Error('SHA256: can\'t update because hash was finished.');let i=0;if(this.bytesHashed+=t,0<this.bufferLength){for(;64>this.bufferLength&&0<t;)this.buffer[this.bufferLength++]=e[i++],t--;64===this.bufferLength&&(hashBlocks(this.temp,this.state,this.buffer,0,64),this.bufferLength=0)}for(64<=t&&(i=hashBlocks(this.temp,this.state,e,i,t),t%=64);0<t;)this.buffer[this.bufferLength++]=e[i++],t--;return this}finish(e){if(!this.finished){const e=this.bytesHashed,t=this.bufferLength,i=0|e/536870912,n=e<<3,o=56>e%64?64:128;this.buffer[t]=128;for(let e=t+1;e<o-8;e++)this.buffer[e]=0;this.buffer[o-8]=255&i>>>24,this.buffer[o-7]=255&i>>>16,this.buffer[o-6]=255&i>>>8,this.buffer[o-5]=255&i>>>0,this.buffer[o-4]=255&n>>>24,this.buffer[o-3]=255&n>>>16,this.buffer[o-2]=255&n>>>8,this.buffer[o-1]=255&n>>>0,hashBlocks(this.temp,this.state,this.buffer,0,o),this.finished=!0}for(let t=0;8>t;t++)e[4*t+0]=255&this.state[t]>>>24,e[4*t+1]=255&this.state[t]>>>16,e[4*t+2]=255&this.state[t]>>>8,e[4*t+3]=255&this.state[t]>>>0;return this}digest(){const e=new Uint8Array(this.digestLength);return this.finish(e),e}_saveState(e){for(let t=0;t<this.state.length;t++)e[t]=this.state[t]}_restoreState(e,t){for(let n=0;n<this.state.length;n++)this.state[n]=e[n];this.bytesHashed=t,this.finished=!1,this.bufferLength=0}}class HMAC{constructor(e){this.inner=new Hash,this.outer=new Hash,this.blockSize=this.inner.blockSize,this.digestLength=this.inner.digestLength;const t=new Uint8Array(this.blockSize);if(e.length>this.blockSize)new Hash().update(e).finish(t).clean();else for(let n=0;n<e.length;n++)t[n]=e[n];for(let n=0;n<t.length;n++)t[n]^=54;this.inner.update(t);for(let n=0;n<t.length;n++)t[n]^=106;this.outer.update(t),this.istate=new Uint32Array(8),this.ostate=new Uint32Array(8),this.inner._saveState(this.istate),this.outer._saveState(this.ostate);for(let n=0;n<t.length;n++)t[n]=0}reset(){return this.inner._restoreState(this.istate,this.inner.blockSize),this.outer._restoreState(this.ostate,this.outer.blockSize),this}clean(){for(let e=0;e<this.istate.length;e++)this.ostate[e]=this.istate[e]=0;this.inner.clean(),this.outer.clean()}update(e){return this.inner.update(e),this}finish(e){return this.outer.finished?this.outer.finish(e):(this.inner.finish(e),this.outer.update(e,this.digestLength).finish(e)),this}digest(){const e=new Uint8Array(this.digestLength);return this.finish(e),e}}function hmac(e,t){const i=new HMAC(e).update(t),n=i.digest();return i.clean(),n}const fetch=require('node-fetch');class FetchClient{constructor(e={}){this.defaults=e}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),i=Object.assign({},this.defaults.headers,e.headers||{}),n=Object.assign({},this.defaults,e),o=n.headers=new Headers(i),d=new URL(n.url);for(const i of Object.keys(t))d.searchParams.append(i,t[i]);return n.data&&(n.body='application/json'===o.get('Content-Type')?JSON.stringify(n.data):n.data,'string'==typeof n.body&&o.append('Content-Length',n.body.length+'')),delete n.url,delete n.query,{url:d.toString(),init:n}}request(e){const{url:t,init:i}=this.makeFetchOptions(e);return fetch(t,i).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get('content-type')||'text/html',body:e,data:{},text:''};return t.type.startsWith('application/json')?t.data=await e.json():t.type.startsWith('text/')&&(t.text=await e.text()),t})}post(e,t,i={}){return i.method='POST',i.url=e,i.data=t,this.request(i)}put(e,t,i={}){return i.method='PUT',i.url=e,i.data=t,this.request(i)}get(e,t={}){return t.method='GET',t.url=e,this.request(t)}delete(e,t={}){return t.method='DELETE',t.url=e,this.request(t)}}class TableStorageRestClient extends FetchClient{constructor(e,t){super(),this.account=e,this.key=t,this.endpointSuffix='core.windows.net',this.timeoutInSeconds=30,this.version='2018-03-28'}request(e){return super.request(e).then(this.throwErrorForNon2xxCode)}post(e,t,i={}){return super.post(e,t,i).then(this.throwErrorForNon2xxCode)}put(e,t,i={}){return super.put(e,t,i).then(this.throwErrorForNon2xxCode)}merge(e,t,i={}){return i.method='MERGE',i.url=e,i.data=t,super.request(i).then(this.throwErrorForNon2xxCode)}get(e,t={}){return super.get(e,t).then(this.throwErrorForNon2xxCode)}delete(e,t={}){return super.delete(e,t).then(this.throwErrorForNon2xxCode)}makeAuthorizationHeader(e,t){const i=new Date,n=i.toUTCString()+'\n'+`/${this.account}${t}`;return console.log('sig --->',JSON.stringify(n)),{Accept:'application/json;odata=fullmetadata',Authorization:`SharedKeyLite ${this.account}:${this.sign(n)}`,"Content-Type":'application/json',DataServiceVersion:'3.0',Date:i.toUTCString(),"x-ms-version":'2018-03-28'}}makeRequestUrl(e,t=''){const i='https://'+this.account+'.'+(e||'table')+'.'+this.endpointSuffix;return t?i+t:i}encodeSpecialCharacters(e){return e.replace(/'/g,'%27')}sign(e){const t=Buffer.from(this.key,'base64');return new Buffer(hmac(t,Buffer.from(e,'utf8'))).toString('base64')}throwErrorForNon2xxCode(e){if(e.data&&e.data['odata.error']){const t=e.data['odata.error'].code;throw console.log('unknown error',e.data['odata.error']),new Error(t||e.statusText)}else return e}}class TableStorage extends TableStorageRestClient{constructor(){super(...arguments),this.etags=new WeakMap,this.tableNameRegex=/^[A-Za-z][A-Za-z0-9]{2,62}$/,this.entityNameRegex=/^[A-Za-z0-9\-_.]{1,1023}$/}static[Symbols.Initializer](e,t){const i=t?t.settings:e.settings;return new TableStorage(i.AZURE_STORAGE_ACCOUNT,i.AZURE_STORAGE_ACCESS_KEY)}queryTables(){const e=this.makeRequestUrl('table','/Tables'),t=this.makeAuthorizationHeader('table','/Tables');return this.get(e,{headers:t}).then(e=>e.data.value.map(e=>e.TableName))}async createTable(e){if(!this.isValidTableName(e))throw new Error('InvalidTableName');const t=this.makeRequestUrl('table','/Tables'),i=this.makeAuthorizationHeader('table','/Tables');return this.post(t,{TableName:e},{headers:i}).then(e=>e.data.TableName)}async deleteTable(e){if(!this.isValidTableName(e))throw new Error('InvalidTableName');const t=`/Tables(%27${e}%27)`,i=this.makeRequestUrl('table'),n=this.makeAuthorizationHeader('table',t);return this.delete(i+t,{headers:n}).then(()=>e,e=>'ResourceNotFound'===e.message?Promise.reject(new Error('TableNotFound')):Promise.reject(e))}batch(e){return new TableBatchRestClient(this,e)}async insertEntity(t,e){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if(!e)throw new Error('InvalidEntity');if('string'!=typeof e.PartitionKey)throw new Error('InvalidPartitionKey');if('string'!=typeof e.RowKey)throw new Error('InvalidRowKey');const i='/'+t,n=this.makeRequestUrl('table',i),o=this.makeAuthorizationHeader('table',i),d=()=>this.post(n,this.fromEntity(e),{headers:o}).then(e=>this.toEntity(e.data,e.headers));return d().catch(i=>{if('TableNotFound'===i.message)return this.createTable(t).then(()=>d());throw i})}upsertEntity(t,e){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if(!e)throw new Error('InvalidEntity');if('string'!=typeof e.PartitionKey)throw new Error('InvalidPartitionKey');if('string'!=typeof e.RowKey)throw new Error('InvalidRowKey');const i='/'+t+`(PartitionKey=%27${encodeURIComponent(e.PartitionKey)}%27,RowKey=%27${encodeURIComponent(e.RowKey)}%27)`,n=this.makeRequestUrl('table',i),o=this.makeAuthorizationHeader('table',i),d=()=>this.put(n,e,{headers:o}).then(t=>this.toEntity(t.data,t.headers,e));return d().catch(i=>{if('TableNotFound'===i.message)return this.createTable(t).then(()=>d());throw i})}updateEntity(e,t,i,n){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof i)throw new Error('InvalidRowKey');const o='/'+e+`(PartitionKey=%27${encodeURIComponent(t)}%27,RowKey=%27${encodeURIComponent(i)}%27)`,d=this.makeRequestUrl('table',o),r=this.makeAuthorizationHeader('table',o);return r['If-Match']='*',this.merge(d,n,{headers:r}).then(e=>this.toEntity(Object.assign(e.data,n,{PartitionKey:t,RowKey:i}),e.headers,n),e=>'ResourceNotFound'===e.message?Promise.reject(new Error('EntityNotFound')):Promise.reject(e))}deleteEntity(e,t,i,n){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof i)throw new Error('InvalidRowKey');const o='/'+e+`(PartitionKey=%27${encodeURIComponent(t)}%27,RowKey=%27${encodeURIComponent(i)}%27)`,d=this.makeRequestUrl('table',o),r=this.makeAuthorizationHeader('table',o);return r['If-Match']=n||'*',console.log('delete',o),this.delete(d,{headers:r}).then(()=>!0,e=>{if('ResourceNotFound'===e.message)return!1;throw e}).catch(t=>{if('TableNotFound'===t.message)return!0;throw t})}queryEntity(t,e,i){if(!this.isValidTableName(t))throw new Error('InvalidTableName');if('string'!=typeof e)throw new Error('InvalidPartitionKey');if('string'!=typeof i)throw new Error('InvalidRowKey');const n='/'+t+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(i)}%27)`,o=this.makeRequestUrl('table',n),d=this.makeAuthorizationHeader('table',n);return this.get(o,{headers:d}).then(e=>this.toEntity(e.data,e.headers)).catch(i=>{if('TableNotFound'===i.message)return this.createTable(t).then(()=>null);if('ResourceNotFound'===i.message)return null;throw i})}queryEntities(t,e={}){if(!this.isValidTableName(t))throw new Error('InvalidTableName');const i='/'+t+`()`,n=this.makeRequestUrl('table',i),o=this.makeAuthorizationHeader('table',i);return this.get(n,{headers:o,query:e}).then(e=>e.data.value.map(e=>this.toEntity(e))).catch(i=>{if('TableNotFound'===i.message)return this.createTable(t).then(()=>[]);throw i})}queryEntitiesByPartitionKey(e,t){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');const i='/'+e+`()`,n=this.makeRequestUrl('table',i),o=this.makeAuthorizationHeader('table',i);return this.get(n,{headers:o,query:{$filter:`PartitionKey eq '${t}'`}}).then(e=>e.data.value.map(e=>this.toEntity(e))).catch(t=>{if('TableNotFound'===t.message)return[];throw t})}queryEntitiesWithPrefix(e,t,i){if(!this.isValidTableName(e))throw new Error('InvalidTableName');if('string'!=typeof t)throw new Error('InvalidPartitionKey');if('string'!=typeof i)throw new Error('InvalidRowKey');const n='/'+e+`()`,o=this.makeRequestUrl('table',n),d=this.makeAuthorizationHeader('table',n);return this.get(o,{headers:d,query:{$filter:`PartitionKey gt '${t}~' and PartitionKey lt '${t}~~' and RowKey gt '${i}~' and RowKey lt '${i}~~'`}}).then(e=>e.data.value.map(t=>this.toEntity(t,e.headers))).catch(t=>{if('TableNotFound'===t.message)return[];throw t})}getETag(e){return this.etags.get(e)}isValidTableName(e){return!!('string'==typeof e&&2<e.length&&64>e.length)&&'Tables'!==e&&'tables'!==e&&this.tableNameRegex.test(e)}isValidTableEntityName(e){return!!('string'==typeof e&&0<e.length&&1025>e.length)&&this.entityNameRegex.test(e)}fromEntity(e){for(const t of Object.keys(e)){const i=e[t];'[object Date]'===Object.prototype.toString.call(i)&&(e[t+'@odata.type']='Edm.DateTime')}return e}toEntity(e,t,i){const n=e['odata.etag']||e['@odata.etag']||t&&t.get('etag');if(!n)throw new Error('ETagNotFound');this.etags.set(e,n);const o=!e.Timestamp;i&&Object.assign(e,i),o&&(e.Timestamp=decodeURIComponent(n.split('\'')[1]));for(const n of Object.keys(e)){const t=e[n];if(n.startsWith('odata.'))delete e[n];else if(n.endsWith('@odata.type'))if('Edm.DateTime'===t){const t=n.slice(0,-11);e[t]=new Date(e[t]),delete e[n]}else console.log('delete typing without change',n,t),delete e[n]}return e}}class TableBatchResult{}class TableBatchRestClient{constructor(e,t){this.client=e,this.tableName=t,this.batchBoundary='batch_'+Date.now(),this.changesetBoundary='changeset_'+Date.now(),this.payload=[],this.secondaryKeys=new Set,this.count=0}get size(){return this.count}insertEntity(e){this.validate(e.PartitionKey,e.RowKey);const t='/'+this.tableName,i=this.client.makeRequestUrl('table',t);return this.addNewRequest('POST',i,e),this}upsertEntity(e){this.validate(e.PartitionKey,e.RowKey);const t='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e.PartitionKey)}%27,RowKey=%27${encodeURIComponent(e.RowKey)}%27)`,i=this.client.makeRequestUrl('table',t);return this.addNewRequest('MERGE',i,e),this}deleteEntity(e,t,i){this.validate(e,t);const n='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(t)}%27)`,o=this.client.makeRequestUrl('table',n);return this.addNewRequest('DELETE',o,null,i),this}updateEntity(e,t,i){this.validate(e,t);const n='/'+this.tableName+`(PartitionKey=%27${encodeURIComponent(e)}%27,RowKey=%27${encodeURIComponent(t)}%27)`,o=this.client.makeRequestUrl('table',n);return this.addNewRequest('MERGE',o,i),this}commit(){const e=this.client.makeRequestUrl('table','/$batch'),t=this.client.makeAuthorizationHeader('table','/$batch');t['Content-Type']='multipart/mixed; boundary='+this.batchBoundary;const i=[`--${this.batchBoundary}`,`Content-Type: multipart/mixed; boundary=${this.changesetBoundary}`,'',`${this.payload.join('\n')}`,'',`--${this.changesetBoundary}--`,`--${this.batchBoundary}--`,''];return this.client.post(e,i.join('\n'),{headers:t}).then(e=>e.body.text().then(t=>{e.text=t;const i=ParseResponses(e).map(e=>ParseResponses(e).map(e=>ParseResponse(e)));let n;if(i.length&&i[0].length&&i[0][0]){if(n=i[0][0].json,n&&n['odata.error']&&n['odata.error'].code){const{code:e,message:t}=n['odata.error'];if('CommandsInBatchActOnDifferentPartitions'===e)throw new Error('InconstantPrimaryKey');else if('InvalidDuplicateRow'===e)throw new Error('DuplicateSecondaryKey');else if('InvalidInput'===e)throw console.log('error',n['odata.error']),new Error('InvalidRequest');throw console.log('Error commit batch: '+t.value),new Error(e)}return{ok:1,n:i[0].length}}return{ok:1,n:0}}))}validate(e,t){if('string'!=typeof e)throw new Error('InvalidPartitionKey');if('string'!=typeof t)throw new Error('InvalidRowKey');if(this.primaryKey&&e!==this.primaryKey)throw new Error('InconstantPrimaryKey');if(this.primaryKey=e,this.secondaryKeys.has(t))throw new Error('DuplicateSecondaryKey');if(this.secondaryKeys.add(t),100<=this.count)throw new Error('BatchTooLarge');this.count++}addNewRequest(e,t,i,n){this.payload.push('--'+this.changesetBoundary),this.payload.push('Content-Type: application/http'),this.payload.push('Content-Transfer-Encoding: binary'),this.payload.push(''),this.payload.push(`${e} ${t} HTTP/1.1`),this.payload.push('Content-Type: application/json'),this.payload.push('Accept: application/json;odata=fullmetadata'),this.payload.push('DataServiceVersion: 3.0;'),'DELETE'===e?this.payload.push(`If-Match: ${n||'*'}`):i&&(this.payload.push(''),this.payload.push(JSON.stringify(i))),this.payload.push('')}}class AzureKey{constructor(e='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'){this.digits=e.split(''),this.base=e.length,this.last=0,this.lastIndex=0}generate(){return this.fromDateTime(new Date)}convert(e){return e?this.fromDateTime(new Date(e)):this.generate()}fromDateTime(e){var t=Math.floor;const i=3468672e9-100*e.getTime(),n=this.base;let o=i,d='';for(this.last==i?(this.lastIndex++,o=i-this.lastIndex):(this.lastIndex=0,this.last=i);1<=o;)d=this.digits[o-n*t(o/n)]+d,o=t(o/n);return d}}function bufferToStream(e){let t=new Duplex;return t.push(e),t.push(null),t}class StorageService extends WfService{constructor(){super(...arguments),this.key=new AzureKey}static[Symbols$1.Initializer](e,t){const i=t||e,n=new StorageService(i);return n.identity=i.identity,n.table=new TableStorage(i.settings.AZURE_STORAGE_ACCOUNT,i.settings.AZURE_STORAGE_ACCESS_KEY),n.blob=createBlobService(i.settings.AZURE_STORAGE_ACCOUNT,i.settings.AZURE_STORAGE_ACCESS_KEY),n}async createTable(e){return this.table.createTable(e)}async update(e,t,i,n){return this.table.updateEntity(e,t,i,n)}async updateById(e,t,i){let n=this.parseId(t);return this.table.updateEntity(e,n,'metadata',i)}async updateChild(e,t,i,n,o){const d=`id~${t}`,r=`${i}~${n}`;return this.table.updateEntity(e,d,r,o)}async find(e,t){return this.table.queryEntities(e,t)}async findAll(e){return this.table.queryEntities(e,{$filter:`RowKey eq 'metadata'`})}async findOneById(e,t){let i=this.parseId(t);return this.table.queryEntity(e,i,'metadata')}async findOneChild(e,t,i,n){const o=`id~${t}`,d=`${i}~${n}`;return this.table.queryEntity(e,o,d)}async findAllById(e,t){const i={$filter:`PartitionKey eq 'id~${t}'`};return this.table.queryEntities(e,i)}async findChildByType(e,t,i){const n={$filter:`PartitionKey eq 'id~${t}' and RowKey gt '${i}~' and RowKey lt '${i}~~'`};return this.table.queryEntities(e,n)}async insertOne(e,t,i){console.log('ins',this.settings);const n=this.parseId(t);return this.table.insertEntity(e,Object.assign({},i,{PartitionKey:n,RowKey:'metadata',id:t}))}async insert(e,t){const i=t.id||CreateIdString(),n=this.parseId(i);return this.table.insertEntity(e,Object.assign({},t,{PartitionKey:n,RowKey:'metadata',id:i}))}async insertChild(e,t,i,n){return this.table.insertEntity(e,Object.assign({},n,{PartitionKey:`id~${t}`,RowKey:`${i}~${n.id}`,type:i,parentId:t}))}async removeChild(e,t,i,n){return this.table.deleteEntity(e,`id~${t}`,`${i}~${n}`)}async removeById(e,t){return this.table.deleteEntity(e,`id~${t}`,'metadata')}async remove(e,t,i){return this.table.deleteEntity(e,t,i)}async removeAll(e,t){const i=await this.findAllById(e,t);for(const n of i)await this.table.deleteEntity(e,n.PartitionKey,n.RowKey);return i}async insertBlob(e,t){const i=CreateIdString(),n=bufferToStream(t.data);return new Promise((e,o)=>{this.blob.createBlockBlobFromStream('files',i,n,t.data.length,{contentSettings:{contentType:t.mimetype}},(n,d)=>{n?o(n):e({id:i,title:t.originalname,type:t.mimetype,size:t.data.length,url:this.blob.getUrl('files',i),blob:d})})})}async removeBlob(e,t){return new Promise((i,n)=>{this.blob.deleteBlobIfExists(e,t,(e,t)=>{e?n(e):i(t)})})}parseId(e){if(e instanceof ObjectId)return`id~${e.toHexString()}`;return e?`id~${e}`:''}}class UserDataAzureStorageProvider extends UserDataProvider{async findOneById(e,t){if(!t)return null;const i=await e.resolve(StorageService);let n=await i.findOneById('User',t);if(n){const e=new UserModel;return Object.assign(e,n),e}return null}async findOneByEmail(e,t){const i=await e.resolve(StorageService),n=await i.findOneById('UserEmail',t);if(n){console.log('findOneByEmail ref',n);const e=await i.findOneById('User',n.user);if(console.log('findOneByEmail user',e),e){const t=new UserModel;return Object.assign(t,e),t}}return null}findOneByName(e,t){throw new Error('NotImplemented')}async insertOne(e,t){throw new Error('NotImplemented')}async update(e,t,i,n){throw new Error('NotImplemented')}async getCredential(e,t){throw new Error('NotImplemented')}}function IsExpires(e){return!e||e<new Date}function IsEqual(e,t){return!(e!==t)||('function'==typeof e&&'function'==typeof t?e.toString()===t.toString():e instanceof Date&&t instanceof Date?e.getTime()===t.getTime():e instanceof RegExp&&t instanceof RegExp?e.source===t.source:e instanceof ObjectId$1&&t instanceof ObjectId$1?0===Buffer.compare(e.id,t.id):!!('number'==typeof e&&'number'==typeof t&&isNaN(e)&&isNaN(t))||!(typeof e==typeof t||!e!=!t)||e==t)}class SessionMutations{static async CreateSession(e,t,i,n,o,d,r){Validator.validate(t);const a=CreateObjectId(),s={device:e.identity.id,provider:i.provider,providerId:i.providerId,authenticator:i._id,authenticationToken:i.token,user:t._id,roles:intersection(t.roles,n),expireAt:new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS),token:a,tokens:[{token:a,context:o}]};d&&(s.previous=d._id.toString(),r&&(s.impersonated=!0,s.impersonatedAt=new Date));const p=e.collection(SessionCollection);return retry(()=>p.insertOne(s)).then(e=>{if(!e)throw new AuthenticationError('unable to create session');return e})}static async CreateOrUpdateSession(e,t,i,n,o){const d=CreateObjectId(),r=e.collection(SessionCollection);return r.findOneAndUpdate({_id:CreateObjectId(e.identity.id)},{$set:{user:IdStr(t),device:e.identity.id,account:n,roles:intersection(t.roles,i),token:d,expires:new Date(Date.now()+31536000000)},$push:{tokens:{token:d,context:o}}}).then(a=>a?a:r.insertOne({_id:CreateObjectId(e.identity.id),user:IdStr(t),device:e.identity.id,account:n,roles:intersection(t.roles,i),expireAt:new Date(Date.now()+31536000000),token:d,tokens:[{token:d,context:o}]}))}static async ExtendSession(e,t){const i=CreateObjectId(),n=e.identity,o=e.collection(SessionCollection),d=n.session;return d?(e.debug({session:d,device:n.id},'extending session'),o.findOneAndUpdate({_id:d,device:n.id,user:n.user,token:n.token,expireAt:{$gt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:i,expireAt:new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS)},$push:{tokens:{token:i,context:t}}},{tokens:0}).then(t=>t?t:(e.info({session:d,device:n.id},'session is been extended by another connection'),o.findOne({_id:d,tokens:{$elemMatch:{token:n.token}}},{tokens:0}).then(e=>{if(!e)throw new AuthenticationError('Session not found');if(!IsEqual(e.device,n.id))throw new AuthenticationError('Unable to extend other device\'s session');if(!IsEqual(e.user,n.user))throw new AuthenticationError('Unable to extend other user\'s session');if(IsExpires(e.expireAt))throw new AuthenticationError('Unable to extend expired session');if(e.deleted)throw new AuthenticationError('Unable to extend deleted session');if(e.blocked)throw new AuthenticationError('Unable to extend blocked session');return e})))):Promise.reject(new AuthenticationError('No session to extend'))}static async RestoreSession(e,t,i,n){const o=CreateObjectId(),d=e.identity,r=e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS,a=e.collection(SessionCollection);return a.findOneAndUpdate({_id:t._id.toString(),device:d.id,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{token:o,expireAt:new Date(Date.now()+r)},$push:{tokens:{token:o,context:i,restoreReason:n}}},{tokens:0})}static async TerminateSession(e,t){const i=e.identity;if(!i.session)return Promise.resolve(null);const n=e.collection(SessionCollection);return n.findOneAndAudit({_id:CreateObjectId(i.session),user:i.user,device:i.id},MongoAuditEvents.Deleted,!0,{$set:{deletedReason:t}},{tokens:0}).then(t=>(t||e.warn({identity:{user:e.identity.user,session:e.identity.session}},`SessionMutations.TerminateSession(): Session not found or already terminated`),t),e=>{throw new Exception(e,`Error during terminate user session, need manual update session '${i.session}.exited' to 'true'`)})}}class SessionGetters{static async GetSessionById(e,t){if(!t)return null;const i=e.collection(SessionCollection);return i.findOneById(t)}static async GetExternalUserFromUser(e,t,i,n){const o=e.collection(ExternalUserCollection);return o.findOne({user:t._id,provider:i,providerProtocol:n})}}class SessionDataProvider extends WfService{FindSessionById(e,t){return SessionGetters.GetSessionById(e,t)}CreateSession(e,t,i,n,o,d,r){return SessionMutations.CreateSession(e,t,i,n,o,d,r)}ExtendSession(e,t){return SessionMutations.ExtendSession(e,t)}TerminateSession(e,t){return SessionMutations.TerminateSession(e,t)}}class SessionDataAzureStorageProvider extends SessionDataProvider{CreateSession(e,t,i,n,o,d,r){throw new Error('NotImplemented')}ExtendSession(e,t){throw new Error('NotImplemented')}TerminateSession(e,t){throw new Error('NotImplemented')}}class CurrentSession extends SessionModel{static[Symbols.Initializer](e,t){const i=t.identity.session;return i instanceof ObjectId$1?t.domain.resolve(SessionDataProvider).then(e=>e.FindSessionById(t.domain,i).then(e=>(e&&Reflect.setPrototypeOf(e,CurrentSession.prototype),e))):null}}let WebAuthenticationService=class e extends WfService{async login(e,t,i,n=['user','admin']){const o=e.identity,d=e.domain,r=e.fingerprint();if(e.logger.context().new_device)throw new Error('Unable to authenticate without identity');let a;if(t instanceof ObjectId$1||'string'==typeof t?a=await this.Users.findOneById(e.domain,t):t instanceof UserModel&&(a=t),!a)throw new Error('Not a user for login');let s=null;if(o.session){const t=await this.Sessions.TerminateSession(d,'new login');t&&(e.logger.debug({session:t._id},'Automatically logged out previous session for new user login'),s=await this.Sessions.CreateSession(d,a,i,n,r,t))}return s||(s=await this.Sessions.CreateSession(d,a,i,n,r)),this.updateWebSession(e,s,a),s}async update(e,t){const i=await e.resolve(CurrentSession);let n;if(t instanceof ObjectId$1||'string'==typeof t?n=await this.Users.findOneById(e.domain,t):t instanceof UserModel&&(n=t),!n)throw new AuthenticationError('Unable to find user '+e.identity.user+' for extended session '+e.identity.session);return this.updateWebSession(e,i,n),i}async refresh(e,t){const i=await this.Sessions.ExtendSession(e.domain,e.fingerprint());if(!i)throw new AuthenticationError('Unable to extend session '+e.identity.session);let n;if(t instanceof ObjectId$1||'string'==typeof t?n=await this.Users.findOneById(e.domain,t):t instanceof UserModel&&(n=t),!n)throw new AuthenticationError('Unable to find user '+e.identity.user+' for extended session '+e.identity.session);return this.updateWebSession(e,i,n),i}async logout(e,t='LogOut'){const i=await this.Sessions.TerminateSession(e.domain,t);return this.WebSessions.clear(e),i}updateWebSession(e,t,i){this.WebSessions.update(e,{session:t._id,user:t.user,token:t.token,roles:t.roles,groups:[],scope:[],profile:{_id:i._id,displayName:i.displayName,displayImageURL:i.displayImageURL},theme:i.theme,timezone:i.timezone,locale:i.locale})}};__decorate([singleton(),__metadata('design:type',SessionDataProvider)],WebAuthenticationService.prototype,'Sessions',void 0),__decorate([singleton(),__metadata('design:type',WebSessionService)],WebAuthenticationService.prototype,'WebSessions',void 0),__decorate([singleton(),__metadata('design:type',UserService)],WebAuthenticationService.prototype,'Users',void 0),WebAuthenticationService=__decorate([service()],WebAuthenticationService);class AuthenticatedController extends WebFoundationController{async __WebFoundationController_InitRequest(e,t){return e.identity.user?t():void e.redirect(e.settings.WEB_SIGNIN_PATH)}async getFailureURL(e,t){if(e.settings.WEB_SIGNIN_FAILED_PATH){const i=e.res.get('X-Request-Id')||'',n={req_id:i,message:t.message};return e.logger.warn(t,'Redirect to error page'),e.settings.WEB_SIGNIN_FAILED_PATH+'?'+stringify(n)}throw new Exception(t,'"WEB_SIGNIN_FAILED_PATH" is not set')}}__decorate([middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],AuthenticatedController.prototype,'__WebFoundationController_InitRequest',null);class ExternalProviderMutations{static async findExternalProviderById(e,t){const i=e.collection(ExternalProviderCollection);return i.findOneById(t)}static async updateExternalProvider(e,t,i){const n=e.collection(ExternalProviderCollection),o=await n.insertOne({_id:t,provider:i.provider+'',providerProtocol:i.providerProtocol+'',providerURL:i.providerURL+'',providerFingerprint:i.providerFingerprint?i.providerFingerprint+'':null,providerConfiguration:i.providerConfiguration,appID:i.appID?i.appID+'':null,appSecret:i.appSecret?i.appSecret+'':null,scope:i.scope||null,displayName:i.displayName?i.displayName+'':null,displayImageURL:i.displayImageURL?i.displayImageURL+'':null});if(!o)throw new Error('Unable to create external provider');return o}static async GetExternalProvider(e,t){const i=e.collection(ExternalProviderCollection);return i.findOneById(t)}}function Audit(e,t,i={},n,o){return'boolean'==typeof n&&(i[''+t]=n),i[''+t+'At']=new Date,i[''+t+'From']=e.address||null,i[''+t+'By']=e.profile||null,o&&(i[''+t+'Reason']=o),i}class ExternalUserMutations{static async CreateOrUpdateExternalUser(e,t){const i=e.collection(ExternalUserCollection),n={uid:IsNumber(t.uid)?+t.uid:t.uid+'',providerId:new ObjectId(t.providerId)};return i.findOneAndUpsertDifference(n,t).then(e=>{if(!e)throw new Error('Unable to create external user');return e})}static async FindOrCreateUser(e,t){const i=e.collection(UserCollection);return t.user?i.findOneById(t.user).then(e=>{if(!e)throw new AuthenticationError(`External user ${t._id.toString()} connected to an non-exists user`);return e}):ExternalUserMutations.CreateNewUserFromExternalUser(e,t)}static async CreateNewUserFromExternalUser(e,t){const i=e.collection(UserCollection),n=e.collection(ExternalUserCollection),o=await i.nextSequenceId(!0),d=e.settings,r={id:o,displayName:t.displayName,displayImageURL:t.displayImageURL,roles:['user']};return t.emailCertified&&d.ADMIN_EMAIL&&d.ADMIN_EMAIL===t.email&&r.roles.push('admin'),UserMutations.insertOne(e,r).then(i=>n.findOneAndUpdate({_id:t._id,user:{$exists:!1}},{$set:{user:i._id}}).then(n=>{if(!n)throw new ApplicationError(`Unable to update external user ${t._id} with new created user. Need delete user ${i._id}`);return n.email&&n.emailCertified?ExternalUserMutations.CreateEmail(e,n).then(()=>i,()=>i):i}))}static async UpdateUserFromExternalUser(e,t){if(!t.user)throw new ApplicationError(`Unable to update user (${t.user}) info from external user ${t._id}`);const i=e.collection(UserCollection),n={displayName:t.displayName,displayImageURL:t.displayImageURL};return i.findOneAndUpdate({_id:t.user},{$set:n}).then(e=>{if(!e)throw new ApplicationError(`Unable to update user ${t.user} from external user ${t._id}`);return e})}static async CreateEmail(e,t){if(!t.user)throw new AuthenticationError(`Unable to create email for external user ${t._id} without user account linked`);if(!t.email)throw new AuthenticationError(`Unable to create email for external user ${t._id} without a valid email address`);if(!t.emailCertified)throw new AuthenticationError(`Unable to create email for external user ${t._id} without a certified email address`);const i=Audit(e.identity,'verified',{name:t.email,displayName:t.displayName,user:t.user},!0,`Certified by ${t.provider} account ${t.uid}@${t.providerId}`),n=e.collection(EmailCollection);return n.insertOne(i)}}class FederationDataProvider extends WfService{findExternalProviderById(e,t){return ExternalProviderMutations.findExternalProviderById(e,t)}updateExternalProvider(e,t,i){return ExternalProviderMutations.updateExternalProvider(e,t,i)}createOrUpdateExternalUser(e,t){return ExternalUserMutations.CreateOrUpdateExternalUser(e,t)}findOrCreateUser(e,t){return ExternalUserMutations.FindOrCreateUser(e,t)}updateUserFromExternalUser(e,t){return ExternalUserMutations.UpdateUserFromExternalUser(e,t)}}class FederationDataAzureStorageProvider extends FederationDataProvider{async findExternalProviderById(e,t){const i=await e.resolve(StorageService);let n=await i.findOneById('ExternalProvider',t);if(n){const e=new ExternalProviderModel;return console.log('findExternalProviderById',n),e.fromJSON(n),e}return null}async updateExternalProvider(e,t,i){const n=await e.resolve(StorageService),o=ExternalProviderModel.toJSON(i);console.log('profile',o);let d=await n.insert('ExternalProvider',Object.assign({id:t},o));const r=new ExternalProviderModel;return console.log('updateExternalProvider',d),r.fromJSON(d),r}async createOrUpdateExternalUser(e,t){const i=t.providerId+'~'+t.uid,n=await e.resolve(StorageService);let o=await n.findOneById('ExternalUser',i);throw console.log('data',o),new NotImplementedException('createOrUpdateExternalUser')}async findOrCreateUser(e,t){throw new NotImplementedException('findOrCreateUser')}async updateUserFromExternalUser(e,t){throw new NotImplementedException('updateUserFromExternalUser')}}class OpenIdConnect extends WfService{constructor(){super(...arguments),this.ConfigurationEndpoint='/.well-known/openid-configuration'}discovery(e){e.pathname=join(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return axios(t).then(e=>e.data)}}let ExternalProviderService=class e extends WfService{get name(){return'ExternalProviderService'}async findOrDiscoverExternalProvider(e,t){if(!t.provider||!t.providerProtocol||!t.providerURL)throw new Error('Unable to find provider without primary fields');const i=this.createProviderId(t),n=await this.data.findExternalProviderById(e,i);if(n)return n;if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error('Unable to discover external id provider');return this.data.updateExternalProvider(e,i,t)}createProviderId(e){const t=[e.provider+'',e.providerProtocol+'',e.providerURL+''];return e.appID&&t.push(e.appID+''),CreateHashedObjectId(t)}async discoverProviderConfiguration(e,t){let i;try{i=new URL(t)}catch(e){throw new Exception(e,'Invalid external provider: '+t)}if('https:'!==i.protocol)throw new Error('Unsupported external id provider protocol: '+t);const n=e.construct(OpenIdConnect);return n.discovery(i).catch(t=>(e.warn(t,{issuer:i},'Unable to discover the configuration'),null))}};__decorate([singleton$2(),__metadata('design:type',FederationDataProvider)],ExternalProviderService.prototype,'data',void 0),ExternalProviderService=__decorate([service()],ExternalProviderService);let ExternalUserService=class e extends WfService{get name(){return'ExternalUserService'}createOrUpdateExternalUser(e,t){if(!t)throw new ApplicationError('Unable to create external user without profile');return this.data.createOrUpdateExternalUser(e,t)}findOrCreateUser(e,t){return this.data.findOrCreateUser(e,t)}updateUserFromExternalUser(e,t){return this.data.updateUserFromExternalUser(e,t)}saveProfileImage(e,t,i,n,o){const d={type:n,data:o,filename:'/Federation/Google/ProfileImages/'+i.uid};return this.apfs.save(e,d,!0).then(e=>e?e.toUrl():null).catch(e=>(this.logger.warn(e,`Unable to save profile image for user ${i.uid} on ${i.provider}`),null))}async getProfileImage(e,t){if(e.settings.OIDC_PROFILE_IMAGE_POLICY===OIDC_PROFILE_IMAGE_POLICIES.PROXY){const i=t.displayImageURL||e.settings.OIDC_PROFILE_IMAGE_URL,n=await e.fetch(i,{responseType:'arraybuffer'});if(n.ok&&Buffer.isBuffer(n.data)){let e;try{e=basename(new URL(i).pathname)}catch(t){e=''}return{filename:e,type:n.headers['content-type'],data:n.data}}}else e.warn('OIDC_PROFILE_IMAGE_POLICY: '+e.settings.OIDC_PROFILE_IMAGE_POLICY+' is not supported, fall back to REDIRECT');return t.displayImageURL||e.settings.OIDC_PROFILE_IMAGE_URL}};__decorate([singleton(),__metadata('design:type',FederationDataProvider)],ExternalUserService.prototype,'data',void 0),__decorate([singleton(),__metadata('design:type',ApfsService)],ExternalUserService.prototype,'apfs',void 0),ExternalUserService=__decorate([service()],ExternalUserService);class RestClient{constructor(e={}){this.defaults=e}makeAxiosOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),i=Object.assign({},this.defaults.headers,e.headers||{}),n=Object.assign({},this.defaults,e);return delete n.query,n.params=t,n.headers=i,n}request(e){return axios.request(this.makeAxiosOptions(e)).then(e=>(console.log('res',e.request.res),{status:e.status,statusText:e.statusText,responseUrl:e.request.res.responseUrl,redirects:e.request.res.redirects,headers:e.headers,data:e.data}))}post(e,t,i){return axios.post(e,t,this.makeAxiosOptions(i)).then(e=>e.data)}postBuffer(e,t,i){return this.post(e,t,Object.assign({responseType:'arraybuffer'},i||{}))}put(e,t,i){return axios.put(e,t,this.makeAxiosOptions(i)).then(e=>(console.log('put headers',e.headers),e.data))}putBuffer(e,t,i={}){return this.put(e,t,Object.assign({responseType:'arraybuffer'},i||{}))}get(e,t={}){return axios.get(e,this.makeAxiosOptions(t)).then(e=>e.data)}getBuffer(e,t={}){return this.get(e,Object.assign({responseType:'arraybuffer'},t||{}))}delete(e,t={}){return axios.delete(e,this.makeAxiosOptions(t)).then(e=>e.data)}deleteBuffer(e,t={}){return this.delete(e,Object.assign({responseType:'arraybuffer'},t||{}))}}class OAuthClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}}let GitLabService=class e extends WfService{async getProfile(e,t,i){const n=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=new OAuthClient(t.access_token),d=await o.get(i.providerConfiguration.userinfo_endpoint);let r=d.picture;return{uid:n.sub,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:d,userData:{},identities:[],user:null,username:d.nickname||null,domain:null,email:n.email||d.email||null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:n.name||d.name,displayImageURL:r,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:null,homepage:d.profile||null,locale:null}}};GitLabService=__decorate([service()],GitLabService);let GitHubService=class e extends WfService{async getProfile(e,t,i){const n=new OAuthClient(t.access_token),o=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const d=await n.get(i.providerConfiguration.userinfo_endpoint),r=await n.get('https://api.github.com/user/emails').then(t=>[]);let a=d.id,s=null,p=d.avatar_url;if(r&&r.length)for(const t of r)t.primary&&t.verified&&(s=t.email);return{uid:a,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:d,userData:{},identities:[],user:null,username:d.login,domain:null,email:s,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:d.name||d.login,displayImageURL:p,familyName:null,givenName:null,gender:null,dob:null,status:null,bio:d.bio||null,homepage:d.blog||d.html_url||null,locale:o.locale}}};GitHubService=__decorate([service()],GitHubService);let GoogleService=class e extends WfService{constructor(){super(...arguments),this.TrustedEmailDomains=['gmail.com']}async getProfile(e,t,i){const n=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=new OAuthClient(t.access_token),d=await o.get(i.providerConfiguration.userinfo_endpoint).catch(()=>null);let r=[],a=null,s=null,p=null,l=!1;if(n.picture?p=n.picture:d&&d.picture&&(p=d.picture),n.email&&(a=n.email),a){const e=a.split('@');s=e[0],0<=this.TrustedEmailDomains.indexOf(e[1].toLowerCase())&&(l=n.email_verified)}return a&&l&&r.push({type:'email',value:a}),{uid:n.sub,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:d,userData:{},identities:r,user:null,username:s,domain:null,email:a,emailCertified:l,mobile:null,mobileCertified:!1,displayName:n.name,displayImageURL:p,familyName:n.family_name,givenName:n.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:n.locale}}};GoogleService=__decorate([service()],GoogleService);class MicrosoftClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://graph.microsoft.com/v1.0/me')}photo(){return this.get('https://graph.microsoft.com/v1.0/me/photo').catch(e=>{const t=e.response.status;if(404===t||501===t)return null;throw new Exception(e,e.response.data,'Unable to resolve user photo')})}photoImage(e){return e?this.getBuffer(`https://graph.microsoft.com/v1.0/me/photos/${e}/$value`):this.getBuffer(`https://graph.microsoft.com/v1.0/me/photo/$value`)}photoImageFile(e){return this.photo().then(t=>{if(!t)return Promise.resolve(null);const i=t['@odata.mediaContentType'],n=t.id;return this.photoImage(n).then(t=>{const[o,d]=n.split('X');return{type:i,data:t,filename:'/Federation/Microsoft/ProfileImages/'+e,width:+o,height:+d}})})}photoImageDataURL(){return this.photo().then(e=>{if(!e)return Promise.resolve(null);const t=e['@odata.mediaContentType'],i=e.id;return this.photoImage(i).then(e=>`data:${t};charset=utf-8;base64,${e.toString('base64')}`)})}users(){return this.get(`https://graph.microsoft.com/v1.0/users`)}}let MicrosoftService=class e extends WfService{constructor(){super(...arguments),this.TrustedEmailDomains=['outlook.com','hotmail.com','live.com','msn.com','passport.com','passport.net']}async getProfile(e,t,i){const n=t.id_token;if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const o=await new MicrosoftClient(t.access_token).profile().catch(()=>null);let d=null,r=null,a=[],s=null,p=null,l=null,u=!1;if(o?(d=o.id,r=o.displayName):(d=n.oid||n.sub,r=n.name),n.preferred_username?s=n.preferred_username:o&&o.userPrincipalName&&(s=o.userPrincipalName),s){const e=s.split('@');2===e.length&&(p=e[1].toLowerCase())}if(n.email?l=n.email:o&&o.mail&&(l=o.mail),l){const e=l.split('@');2===e.length&&0<=this.TrustedEmailDomains.indexOf(e[1].toLowerCase())&&(u=!0)}return l&&u&&a.push({type:'email',value:l}),{uid:d,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:o,userData:{},identities:a,user:null,username:s,domain:p,email:l,emailCertified:u,mobile:o&&o.mobilePhone,mobileCertified:!1,displayName:r,displayImageURL:null,familyName:o&&o.surname,givenName:o&&o.givenName,gender:null,dob:null,status:null,bio:null,homepage:null,locale:o&&o.preferredLanguage}}};__decorate([singleton(),__metadata('design:type',ApfsService)],MicrosoftService.prototype,'apfs',void 0),MicrosoftService=__decorate([service()],MicrosoftService);class WeiboClient extends RestClient{constructor(e){if(super({query:{access_token:e}}),!e)throw new Error('Access token can not be null or empty')}comments(e={}){return this.get('https://api.weibo.com/2/comments/to_me.json',e)}mentions(e={}){return this.get('https://api.weibo.com/2/comments/mentions.json',e)}reposts(e={}){return this.get('https://api.weibo.com/2/statuses/mentions.json',e)}weibo(e={}){return this.get('https://api.weibo.com/2/statuses/home_timeline.json',e)}getLimits(){return this.get('https://api.weibo.com/2/account/rate_limit_status.json',{})}}let WeiboService=class e extends WfService{async getProfile(e,t,i){if(!i.providerConfiguration||!i.providerConfiguration.userinfo_endpoint)return null;const n=new WeiboClient(t.access_token),o=await n.post('https://api.weibo.com/oauth2/get_token_info');t.appkey=o.appkey;const d=await n.get(i.providerConfiguration.userinfo_endpoint,{query:{uid:t.uid}}).catch(e=>{throw console.log('unable to get weibot profile',e),e});return{uid:d.id,provider:i.provider,providerProtocol:i.providerProtocol,providerId:i._id,providerData:d,userData:{},identities:[],user:null,username:d.domain||null,domain:null,email:null,emailCertified:!1,mobile:null,mobileCertified:!1,displayName:d.screen_name,displayImageURL:d.profile_image_url,familyName:null,givenName:null,gender:d.gender,dob:null,status:d.status?d.status.text:null,bio:d.description,homepage:d.url||null,locale:d.lang}}};WeiboService=__decorate([service()],WeiboService);class WfUserService extends WebFoundationUserService{}class OAuth2Client extends RestClient{constructor(e){super({headers:{Accept:'application/json',"Content-Type":'application/json'}}),this.options=e}authorizeURL(e){const t={client_id:this.options.client_id,response_type:'code'};Array.isArray(e.scope)&&(e.scope=e.scope.join(' '));const i=Object.assign({},t,e);return`${this.options.authorization_endpoint}?${stringify(i)}`}getToken(e){Array.isArray(e.scope)&&(e.scope=e.scope.join(' '));const t=Object.assign({},e,{client_id:this.options.client_id,client_secret:this.options.client_secret,grant_type:'authorization_code'});return super.post(this.options.token_endpoint,stringify(t),{headers:{"Content-Type":'application/x-www-form-urlencoded'}}).catch(e=>(console.log('errror get token',e.response),console.log('try get token using json payload',t),super.post(this.options.token_endpoint,t)))}}let OpenIdAuthenticator=class e extends WfUserService{get name(){return'OpenIdAuthenticator'}update(e){this.idProvider=e.provider,this.oauth=new OAuth2Client({client_id:e.appID,client_secret:e.appSecret,authorization_endpoint:e.authorization_endpoint,token_endpoint:e.token_endpoint}),this.scope=e.scope?e.scope:'openid'}getAuthorizeURL(e,t){return this.oauth.authorizeURL({redirect_uri:e,scope:this.scope,state:t+''})}getSuccessURL(e){return'/#'+this.settings.WEB_SIGNIN_SUCCESS_PATH}getFailureURL(e){return'/#'+this.settings.WEB_SIGNIN_FAILED_PATH}getToken(e,t){return this.oauth.getToken({redirect_uri:e,code:t,scope:this.scope}).then(e=>{try{if(e.id_token){const t=e.id_token.split('.'),i=Buffer.from(t[1],'base64');e.id_token=JSON.parse(i.toString())}else e.id_token={},e.id_token_error='id_token is not found'}catch(t){e.id_token_error=t.message}return e})}async refreshToken(e){throw new Error('Not implemented refresh token')}async getProfile(e){const t=e.id_token;let i=[],n=null,o=null,d=null,r=!1;if(t.email&&(n=t.email,r=t.email_verified),n){const e=n.split('@');o=e[0],d=e[1]}return n&&r&&i.push({type:'email',value:n}),{uid:t.sub,providerData:null,identities:i,username:o,domain:d,email:n,emailCertified:r,mobile:null,mobileCertified:!1,displayName:t.name,displayImageURL:t.picture,familyName:t.family_name,givenName:t.given_name,gender:null,dob:null,status:null,bio:null,homepage:null,locale:t.locale}}};OpenIdAuthenticator=__decorate([service()],OpenIdAuthenticator);var _a$1,_b;class OpenIdController extends WebFoundationController{async getAuthenticator(e){const t=e.construct(OpenIdAuthenticator,!0),i=await this.discover(e);return t.update({provider:i,issuer:i.providerURL,appID:i.appID,appSecret:i.appSecret,token_endpoint:i.providerConfiguration.token_endpoint,authorization_endpoint:i.providerConfiguration.authorization_endpoint,scope:i.scope}),t}OnProfile(e,t,i){return Promise.resolve(null)}async[_a$1=Symbol('start')](e){let t;try{const i=await this.getAuthenticator(e),n=resolve(e.publicUrl,'callback');t=i.getAuthorizeURL(n,Date.now())}catch(i){t=await this.getFailureURL(e,new Exception(i,'Unable to start authentication'))}e.redirect(t)}async[_b=Symbol('callback')](e){const t=await this.getAuthenticator(e),i=t.idProvider,n=resolve(e.publicUrl,'callback'),o=+e.query.state;if(o>Date.now()||o<Date.now()-e.settings.OIDC_AUTHENTICATION_EXPIRES_IN_MILLISECONDS)return void e.redirect(t.getFailureURL(new Error('Invalid Authentication State')));if(e.query.error){const i=new Error(`${e.query.error}: ${e.query.error_description}`);return e.logger.error(i,'Authentication Error'),void e.redirect(t.getFailureURL(i))}try{const o=e.query.code,d=await t.getToken(n,o);let r=await this.OnProfile(e,d,i).catch(()=>null);if(r||(r=await t.getProfile(d).catch(()=>null)),!r||!r.uid){let i=new Error('Unable to get unique user identity from provider');return e.logger.error(i),void e.redirect(t.getFailureURL(i))}r&&(Reflect.has(r,'user')&&(r.user instanceof ObjectId$1?e.logger.warn(`External user ${r.uid}@${i._id} already set the user field to ${r.user}`):r.user=null),!r.displayImageURL&&e.logger.warn(`External user ${r.uid}@${i._id} do not have a profile image`),r.provider=i.provider,r.providerProtocol=i.providerProtocol,r.providerId=i._id);const a=await this.ExternalUsers.createOrUpdateExternalUser(e.domain,r);let s;if(!a.user)s=null;else if(s=await this.Users.findOneById(e.domain,a.user),s){const t=a.updatedAt||a.createdAt,i=s.updatedAt||s.createdAt;t>i&&(e.logger.warn({eid:a._id,uid:s._id,d1:t,d2:i},`Updating user info from external user`),s=await this.ExternalUsers.updateUserFromExternalUser(e.domain,a))}const p=await e.resolve(CurrentUser),l=await this.OnAuthenticated(e,i,d,a,s,p);e.redirect(t.getSuccessURL(l))}catch(i){e.logger.error(i,'Authentication Callback Error'),e.redirect(t.getFailureURL(i))}}}__decorate([singleton(),__metadata('design:type',ExternalUserService)],OpenIdController.prototype,'ExternalUsers',void 0),__decorate([singleton(),__metadata('design:type',UserService)],OpenIdController.prototype,'Users',void 0),__decorate([method('GET','/start'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OpenIdController.prototype,_a$1,null),__decorate([method('GET','/callback'),__metadata('design:type',Function),__metadata('design:paramtypes',[Object]),__metadata('design:returntype',Promise)],OpenIdController.prototype,_b,null);class EventGetters{static async GetLatestEvents(e){const t=e.collection(EventCollection);return t.find({},{},{id:-1},0,30).then(e=>e.results)}}class EventMutations{static async createEvent(e,t,i){const n=e.collection(EventCollection),o=await n.nextSequenceId();return n.insertOne({id:o,type:t,context:i||{}})}}class EventDataProvider{async getLatestEvents(e){return EventGetters.GetLatestEvents(e)}async createEvent(e,t,i){return EventMutations.createEvent(e,t,i)}}let EventService=class e extends WfService{get name(){return'EventService'}async getLatestEvents(e){return this.data.getLatestEvents(e)}async createSignInEvent(e,t,i){const n=EventType.SIGN_IN,o={provider:t.displayName,providerId:t._id,userId:i._id};return this.data.createEvent(e,n,o)}async createSignUpEvent(e,t,i){const n=EventType.SIGN_UP,o={provider:t.displayName,providerId:t._id,userId:i._id};return this.data.createEvent(e,n,o)}async createSignOutEvent(e,t){const i=EventType.SIGN_OUT,n={provider:t.displayName,providerId:t._id};return this.data.createEvent(e,i,n)}};__decorate([singleton$1(),__metadata('design:type',EventDataProvider)],EventService.prototype,'data',void 0),EventService=__decorate([service$1()],EventService);class OpenIdAuthController extends OpenIdController{async OnAuthenticated(e,t,i,n,o,d){const r={_id:n._id,provider:t.provider,providerId:t._id,displayName:n.displayName,displayImageURL:n.displayImageURL,token:i};if(o){const i=await this.WebAuth.login(e,o,r);return e.logger.debug({user:o._id,email:n.email,roles:i.roles.join(','),session:i._id.toString()},`Logged in with ${t.displayName}`),await this.Events.createSignInEvent(e.domain,t,o),o}if(n.email){const t=await this.Users.findOneByEmail(e.domain,n.email);if(t)throw new AuthenticationError(`Please login ${n.email} using password`)}const a=await this.ExternalUsers.findOrCreateUser(e.domain,n);if(!a)throw new AuthenticationError(`Unable to register using ${t.displayName}`);return this.WebAuth.login(e,a,r).then(i=>(e.logger.debug({user:a._id,email:n.email,roles:i.roles.join(','),session:i._id.toString()},`First time logged in with ${t.displayName}`),this.Events.createSignUpEvent(e.domain,t,a).then(()=>a)))}}__decorate([singleton(),__metadata('design:type',EventService)],OpenIdAuthController.prototype,'Events',void 0),__decorate([singleton(),__metadata('design:type',WebAuthenticationService)],OpenIdAuthController.prototype,'WebAuth',void 0);let GoogleOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GoogleOpenIdAuthController'}async discover(e){const t={provider:'google',providerProtocol:'openid',providerURL:e.settings.OIDC_GOOGLE_ISSUER_URL,displayName:'Google Account',displayImageURL:'https://www.google.com/favicon.ico'},i=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return i.appID=i.appID||e.settings.OIDC_GOOGLE_CLIENT_ID,i.appSecret=e.settings.OIDC_GOOGLE_CLIENT_SECRET,i.scope=e.settings.OIDC_GOOGLE_SCOPES.join(' '),i}async OnProfile(e,t,i){return this.google.getProfile(e.domain,t,i)}};__decorate([singleton(),__metadata('design:type',ExternalProviderService)],GoogleOpenIdAuthController.prototype,'idp',void 0),__decorate([singleton(),__metadata('design:type',GoogleService)],GoogleOpenIdAuthController.prototype,'google',void 0),GoogleOpenIdAuthController=__decorate([controller('/api/integration/google/auth')],GoogleOpenIdAuthController);let MicrosoftOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'MicrosoftOpenIdAuthController'}async discover(e){const t={provider:'microsoft',providerProtocol:'openid',providerURL:e.settings.OIDC_MICROSOFT_ISSUER_URL,displayName:'Microsoft Account',displayImageURL:'https://www.microsoft.com/favicon.ico'},i=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return i.appID=i.appID||e.settings.OIDC_MICROSOFT_CLIENT_ID,i.appSecret=e.settings.OIDC_MICROSOFT_CLIENT_SECRET,i.scope=e.settings.OIDC_MICROSOFT_SCOPES.join(' '),i}async OnProfile(e,t,i){return this.microsoft.getProfile(e.domain,t,i)}};__decorate([singleton(),__metadata('design:type',ExternalProviderService)],MicrosoftOpenIdAuthController.prototype,'idp',void 0),__decorate([singleton(),__metadata('design:type',MicrosoftService)],MicrosoftOpenIdAuthController.prototype,'microsoft',void 0),MicrosoftOpenIdAuthController=__decorate([controller('/api/integration/microsoft/auth')],MicrosoftOpenIdAuthController);let GitLabOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GitLabOpenIdAuthController'}async discover(e){const t={provider:'gitlab',providerProtocol:'openid',providerURL:e.settings.OIDC_GITLAB_ISSUER_URL,displayName:'GitLab Account',displayImageURL:'https://about.gitlab.com/ico/favicon-192x192.png'},i=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return i.appID=i.appID||e.settings.OIDC_GITLAB_CLIENT_ID,i.appSecret=e.settings.OIDC_GITLAB_CLIENT_SECRET,i.scope=e.settings.OIDC_GITLAB_SCOPES.join(' '),i}async OnProfile(e,t,i){return this.gitlab.getProfile(e.domain,t,i)}};__decorate([singleton(),__metadata('design:type',ExternalProviderService)],GitLabOpenIdAuthController.prototype,'idp',void 0),__decorate([singleton(),__metadata('design:type',GitLabService)],GitLabOpenIdAuthController.prototype,'gitlab',void 0),GitLabOpenIdAuthController=__decorate([controller('/api/integration/gitlab/auth')],GitLabOpenIdAuthController);let GitHubOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'GitHubOpenIdAuthController'}async discover(e){const t={provider:'github',providerProtocol:'oauth',providerURL:e.settings.OIDC_GITHUB_ISSUER_URL,displayName:'GitHub Account',displayImageURL:'https://github.com/favicon.ico',providerConfiguration:{issuer:e.settings.OIDC_GITHUB_ISSUER_URL,authorization_endpoint:'https://github.com/login/oauth/authorize',token_endpoint:'https://github.com/login/oauth/access_token',userinfo_endpoint:'https://api.github.com/user'}},i=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return i.appID=i.appID||e.settings.OIDC_GITHUB_CLIENT_ID,i.appSecret=i.appSecret||e.settings.OIDC_GITHUB_CLIENT_SECRET,i.scope=i.scope||e.settings.OIDC_GITHUB_SCOPES.join(' '),i}async OnProfile(e,t,i){return this.github.getProfile(e.domain,t,i)}};__decorate([singleton(),__metadata('design:type',ExternalProviderService)],GitHubOpenIdAuthController.prototype,'idp',void 0),__decorate([singleton(),__metadata('design:type',GitHubService)],GitHubOpenIdAuthController.prototype,'github',void 0),GitHubOpenIdAuthController=__decorate([controller('/api/integration/github/auth')],GitHubOpenIdAuthController);let WeiboOpenIdAuthController=class e extends OpenIdAuthController{get name(){return'WeiboOpenIdAuthController'}async discover(e){const t={provider:'weibo',providerProtocol:'oauth',providerURL:e.settings.OIDC_WEIBO_ISSUER_URL,displayName:'Weibo Account',displayImageURL:'https://www.weibo.com/favicon.ico',providerConfiguration:{issuer:e.settings.OIDC_WEIBO_ISSUER_URL,authorization_endpoint:'https://api.weibo.com/oauth2/authorize',token_endpoint:'https://api.weibo.com/oauth2/access_token',userinfo_endpoint:'https://api.weibo.com/2/users/show.json'}},i=await this.idp.findOrDiscoverExternalProvider(e.domain,t);return i.appID=i.appID||e.settings.OIDC_WEIBO_CLIENT_ID,i.appSecret=e.settings.OIDC_WEIBO_CLIENT_SECRET,i.scope=e.settings.OIDC_WEIBO_SCOPES.join(' '),i}async OnProfile(e,t,i){return this.weibo.getProfile(e.domain,t,i)}};__decorate([singleton(),__metadata('design:type',ExternalProviderService)],WeiboOpenIdAuthController.prototype,'idp',void 0),__decorate([singleton(),__metadata('design:type',WeiboService)],WeiboOpenIdAuthController.prototype,'weibo',void 0),WeiboOpenIdAuthController=__decorate([controller('/api/integration/weibo/auth')],WeiboOpenIdAuthController);class EventDataAzureStorageProvider extends EventDataProvider{async getLatestEvents(e){return[]}async createEvent(e,t,i){return null}}var _a$2;class OrganizationController extends WebFoundationController{async[_a$2=Symbol('Tenant')](e,t){if(!e.params.tenant)throw new Error('Missing tenant parameters');return e.req.settings.MONGODB_DATABASE=e.params.tenant,t()}}__decorate([middleware(),__metadata('design:type',Function),__metadata('design:paramtypes',[Object,Function]),__metadata('design:returntype',Promise)],OrganizationController.prototype,_a$2,null);class OrganizationMutations{static CreateOrganization(e,t,i){const n=e.collection(OrganizationCollection);return n.nextSequenceId(!0).then(e=>{if(!e)throw new ApplicationError('unable to generate Organization id');return n.insertOne({id:e,name:t.name||e+'',owner:i,displayName:t.displayName||'Organization '+(e+''),displayImageURL:t.displayImageURL||null,settings:merge(t.settings,{MAX_MEMBERS:1,LICENSE_TYPE:'FREE',LICENSE_EXPIRE_AT:new Date(Date.now()+316224e5)})}).then(e=>{if(!e)throw new ApplicationError('unable to create Organization');return e})})}static UpdateOrganizationField(e,t,i,n){if('string'!=typeof i)throw new Error('invalid field to update');const o=e.collection(OrganizationCollection);return o.findOneAndUpdate(o.makeIdQuery(t),{$set:{[i]:n}})}static UpdateOrganization(e,t,i){const n=e.collection(OrganizationCollection);return n.findOneAndUpdate(n.makeIdQuery(t),{$set:i})}static DeleteOrganization(e,t){const i=e.collection(OrganizationCollection);return i.findOneAndAudit({_id:t._id},MongoAuditEvents.Deleted,!0)}}class OrganizationGetters{static FindOrganizations(e,t){const i=e.collection(OrganizationCollection);return i.find({$text:{$search:t,$caseSensitive:!1,$diacriticSensitive:!1},deleted:{$ne:!0}})}static FindOrganizationsByOwner(e,t){const i=e.collection(OrganizationCollection),n=t||e.identity.user;if(!n)throw new Error('owner can not be null');return i.find({owner:new ObjectId(n),deleted:{$ne:!0}})}static FindOrganizationsByMember(e,t){const i=e.collection(OrganizationCollection),n=e.collection(EdgeCollection),o=t||e.identity.user;if(!o)throw new Error('member can not be null');return n.findOutVertices(o,UserModel.getType(),i).then(e=>({n:GetTotalCount(e),results:e}))}static FindOrganization(e,t){const i=e.collection(OrganizationCollection);return i.findOne(merge(i.makeIdQuery(t),{deleted:{$ne:!0}}))}}class OrganizationService extends WfService{createOrganization(e,t,i){return OrganizationMutations.CreateOrganization(e,t,i)}updateOrganization(e,t,i){const n=arguments[2],o=arguments[3];return o?OrganizationMutations.UpdateOrganizationField(e,t,n,o):OrganizationMutations.UpdateOrganization(e,t,n)}findOrganization(e,t){return OrganizationGetters.FindOrganization(e,t)}findOrganizationsByMember(e,t){return OrganizationGetters.FindOrganizationsByMember(e,t)}findOrganizationsByOwner(e,t){return OrganizationGetters.FindOrganizationsByOwner(e,t)}searchOrganization(e,t){return OrganizationGetters.FindOrganizations(e,t)}}let StripeService=class e extends WfService{get client(){const e=new Stripe(this.settings.CUSTOM_STRIPE_SECRET_KEY);return Reflect.set(this,'client',e),e}async addCard(e,t,i){if(!t)throw new Error('Unable create stripe customer without user');const n={user:new ObjectId$1(t)},o={app:this.settings.NAME,uid:n.user.toString()},d=e.collection(StripeCustomerCollection);await d.createIndices(),console.log('qqq',n);const r=await d.findOneAndUpsert(n);if(!r)throw new Error('Unable to create stripe customer mapping');let a;if(r.customerId&&(a=await this.getStripeCustomer(r.customerId)),a){const e=await this.client.customers.createSource(a.id,{source:i.id,metadata:o});return this.normalizeCard(e,a.default_source)}if(a=await this.client.customers.create({description:`Customer for ${t}@${this.settings.NAME}`,source:i.id,metadata:o}),!a)throw new Error('unable to create stripe customer with token');const s=await this.client.customers.retrieveCard(a.id,i.card.id);return d.findOneAndUpdate(n,{$set:{customerId:a.id}}).then(()=>this.normalizeCard(s,s.id),e=>{const i=`Unable to link stripe customer ${a.id} to ${t}, because of: ${e.message}`;throw this.logger.warn(e,i),new Exception(e,i)})}async listCards(e,t){if(!t)throw new Error('Unable create stripe customer without user');const i={user:new ObjectId$1(t)},n=e.collection(StripeCustomerCollection),o=await n.findOne(i);if(!o)return[];if(!o.customerId)return[];const d=await this.getStripeCustomer(o.customerId);return d?this.client.customers.listCards(d.id).then(e=>e.data.map(e=>this.normalizeCard(e,d.default_source))):[]}async removeCard(e,t,i){const n=await this.getCustomer(e,t);if(!n.customerId)throw new Error('unable to map to stripe customer');const o=await this.getStripeCustomer(n.customerId);if(!o)throw new Error('unable to remove card for stripe customer: '+n.customerId);return this.client.customers.deleteCard(n.customerId,i)}async activeCard(e,t,i){const n=await this.getCustomer(e,t);if(!n.customerId)throw new Error('unable to map to stripe customer');const o=await this.getStripeCustomer(n.customerId);if(!o)throw new Error('unable to remove card for stripe customer: '+n.customerId);const d=await this.client.customers.update(o.id,{default_source:i});return{id:d.default_source}}async setPrimaryCard(e,t,i){}async getCustomer(e,t){if(!t)throw new Error('Unable create stripe customer without user');const i={user:new ObjectId$1(t)},n=e.collection(StripeCustomerCollection),o=await n.findOneAndUpsert(i);if(!o)throw new Error('Unable to create stripe customer mapping');return o}async getStripeCustomer(e){const t=await this.client.customers.retrieve(e).catch(()=>null);return t&&t.deleted?null:t}normalizeCard(e,t){return{id:e.id,active:e.id===t,type:e.brand,last4:e.last4,name:e.name,expiry:e.exp_month+'/'+e.exp_year}}};StripeService=__decorate([service()],StripeService);class GoogleClient extends RestClient{constructor(e){if(super({headers:{authorization:`Bearer ${e}`}}),!e)throw new Error('Access token can not be null or empty')}profile(){return this.get('https://www.googleapis.com/userinfo/v2/me')}people(){return this.get('https://www.googleapis.com/admin/directory/v1/users/userKey')}}class GoogleStorageService extends WfService{constructor(e){super(e),this.google=new GoogleToken({key:e.settings.CUSTOM_GOOGLE_API_PRIVATE_KEY,email:e.settings.CUSTOM_GOOGLE_API_EMAIL_ID,scope:['https://www.googleapis.com/auth/devstorage.read_write']})}async insert(e,t,i){const n=await this.google.getToken();if(!n)throw new Error('Error get access token to insert file');const o=new GoogleClient(n);return o.post('https://www.googleapis.com/upload/storage/v1/b/'+e+'/o',i,{query:{uploadType:'media',name:t},headers:{"Content-Type":'application/json'}})}async copy(e,t,i,n){const o=await this.google.getToken();if(!o)throw new Error('Error get access token to insert file');const d=new GoogleClient(o);return d.post(`https://www.googleapis.com/storage/v1/b/${e}/o/${encodeURIComponent(t)}/copyTo/b/${i}/o/${encodeURIComponent(n)}`)}async remove(e,t){const i=await this.google.getToken();if(!i)throw new Error('Error get access token to insert file');const n=new GoogleClient(i);return n.delete('https://www.googleapis.com/storage/v1/b/'+e+'/o/'+encodeURIComponent(t))}async list(e,t){const i=await this.google.getToken();if(!i)throw new Error('Error get access token to insert file');const n=new GoogleClient(i);return n.get('https://www.googleapis.com/storage/v1/b/'+e+'/o',{query:{prefix:t,versions:!0},headers:{"Content-Type":'application/json'}})}}class CronJobService extends WebFoundationService{findAll(e){const t=e.collection(CronJobCollection);return t.find().then(e=>e.results)}insert(e,t,i){const n=e.collection(CronJobCollection),o=this.calculateNextScheduleTime(t),d=CreateObjectSignature({trigger:t,payload:i});return n.insertOne({_id:CreateHashedObjectId$1(d),key:d,cron:'string'==typeof t?t:null,intervalInSeconds:'number'==typeof t?t:null,nextScheduleAt:o,lastScheduleAt:new Date(0),lastScheduleBy:null,lastScheduleFrom:null,lastScheduleRetries:0,lastScheduleDuration:0,lastScheduleResult:null,payload:i})}remove(e,t){const i=e.collection(CronJobCollection);return i.findOneAndDelete({_id:t}).then(e=>{if(!e)throw new Error('DeleteCronJobFailed');return e})}async findAllScheduledCronJob(e){const t=e.collection(CronJobCollection);return t.find({nextScheduleAt:{$lt:new Date},deleted:{$ne:!0},blocked:{$ne:!0}}).then(e=>{if(e.n&&Array.isArray(e.results)&&e.results.length){const i=e.results;return Promise.all(i.map(e=>t.findOneAndUpdate({_id:e._id,nextScheduleAt:e.nextScheduleAt,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{nextScheduleAt:this.calculateNextScheduleTime(e)}}))).then(e=>e.filter(e=>null!=e))}return e.results})}async findOneScheduledCronJob(e){const t=e.collection(CronJobCollection),i=await t.findOne({deleted:{$ne:!0},blocked:{$ne:!0},nextScheduleAt:{$lt:new Date}});return i?t.findOneAndUpdate({_id:i._id,nextScheduleAt:i.nextScheduleAt,deleted:{$ne:!0},blocked:{$ne:!0}},{$set:{nextScheduleAt:this.calculateNextScheduleTime(i)}}):null}async updateOneScheduledCronJob(e,t,i={}){const n=e.collection(CronJobCollection);return n.findOneAndUpdate({_id:CreateObjectId(t)},{$set:{lastScheduleAt:i.lastScheduleAt||new Date,lastScheduleBy:i.lastScheduleBy||null,lastScheduleFrom:i.lastScheduleFrom||null,lastScheduleRetries:i.lastScheduleRetries||0,lastScheduleDuration:i.lastScheduleDuration||0,lastScheduleResult:i.lastScheduleResult||null}})}calculateNextScheduleTime(e){let t;const i=typeof e;if('string'==i)t=this.calculateNextCronTime(e);else if('number'==i)t=this.calculateNextIntervalTime(e);else if(!('object'==i))throw new Error('InvalidCronOrInterval');else if('string'==typeof e.cron&&e.cron)t=this.calculateNextCronTime(e.cron);else if('number'==typeof e.intervalInSeconds&&!isNaN(e.intervalInSeconds))t=this.calculateNextIntervalTime(e.intervalInSeconds);else throw new Error('InvalidCronJob');return t}calculateNextCronTime(e){try{const t=parseExpression(e);return t.next().toDate()}catch(e){throw new Exception(e,'CronExpressionParseError')}}calculateNextIntervalTime(e){const t=Math.max(e,0);return new Date(Date.now()+1e3*t)}}class DockerClient extends RestClient{}class GitLabClient extends RestClient{}class KubernetesClient extends RestClient{constructor(e,t){super({headers:{Authorization:'Bearer '+t}}),this.api_server=e}url(e){return resolve(this.api_server,e)}listNamespaces(){return this.get(this.url('/api/v1/namespaces')).catch(e=>{throw new Exception(e,'Unable to list namespace')})}getNamespace(e){return this.get(this.url(`/api/v1/namespaces/${e}`)).catch(e=>{if(404===e.response.data.code)return null;throw new Exception(e,'Unable to get namespace')})}createNamespace(e){return this.post(this.url('/api/v1/namespaces'),{kind:'Namespace',apiVersion:'v1',metadata:{name:e}}).catch(e=>{throw new Exception(e,'Unable to create namespace')})}deleteNamespace(e){return this.delete(this.url(`/api/v1/namespaces/${e}`)).catch(e=>{throw new Exception(e,'Unable to delete namespace')})}listCronJobs(e){return'string'==typeof e&&e?this.get(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs`)):this.get(this.url('/apis/batch/v1beta1/cronjobs'))}getCronJob(e,t){return this.get(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs/${t}`)).catch(e=>{if(404===e.response.data.code)return null;throw new Exception(e,'Unable to get cronjob')})}createCronJob(e,t){return this.post(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs`),t).catch(e=>{throw new Exception(e,'Unable to create cronjob')})}deleteCronJob(e,t){return this.delete(this.url(`/apis/batch/v1beta1/namespaces/${e}/cronjobs/${t}`)).catch(e=>{throw new Exception(e,'Unable to delete cronjob')})}}class RedmineClient extends RestClient{}class TeamCityClient extends RestClient{}const fetch$1=require('node-fetch');function extractFunctionBody(e){if('function'==typeof e){const t=e.toString();return t.slice(t.indexOf('{')+1,t.lastIndexOf('}'))}return e||''}function FetchWebPage(e,t){const i={url:t.url,waitFor:t.waitFor,initScript:extractFunctionBody(t.initScript),script:extractFunctionBody(t.script)},n=new Date;if(!e.settings.JSONSDK_FETCH_API_URL)throw new Error('FetchUrlNotSet');return fetch$1(e.settings.JSONSDK_FETCH_API_URL,{method:'POST',headers:{"x-date":n.toUTCString(),"x-api-key":e.settings.JSONSDK_FETCH_API_KEY},body:JSON.stringify(i)}).then(e=>e.ok?e.json().then(t=>{const i={};if(t.cookies)for(const e of Object.keys(t.cookies)){const n=t.cookies[e];i[n.name]=n.value}return t.cookies=i,console.log('fetch bot ip',e.headers.get('x-bot-ip')),t}):{ok:0,cookies:{},logs:[e.status,e.headers.get('x-reason'),e.headers.get('x-request-ip'),e.headers.get('cf-ray')],result:null,results:[]})}class ExternalProviderGetters{static findByName(e,t){const i=e.collection(ExternalProviderCollection);return i.findOne({provider:t+''})}static findById(e,t){const i=e.collection(ExternalProviderCollection);return i.findOne({_id:t})}}export{WebFoundationApplication,WebFoundationSettings,WebFoundationService,WebFoundationUserService,WebFoundationController,WebIdentity,DatabaseError,ValidationError,user,admin,role,RoleAttribute,Time,formatTime,formatNumber,merge,Fetcher,SYSTEM_MAX_UPLOAD_SIZE,SYSTEM_MAX_NUMBER_OF_ACCOUNTS_PER_USER,Database,ImmutableModel,Model,Collection,Validator,VertexModel,EdgeModel,EdgeCollection,EmailCollection,EmailModel,MobileCollection,MobileModel,ExternalProviderCollection,ExternalProviderModel,ExternalUserCollection,ExternalUserModel,SessionCollection,SessionModel,UserCollection,UserModel,ApfsFileChunkCollection,ApfsFileChunkModel,ApfsFileCollection,ApfsFileModel,AdminService,ApfsService,CurrentUser,UserService,UserDataProvider,UserDataAzureStorageProvider,SessionDataProvider,SessionDataAzureStorageProvider,WebAuthenticationService,WebSessionService,AuthenticatedController,CurrentSession,FederationDataAzureStorageProvider,FederationDataProvider,ExternalProviderService,ExternalUserService,GitLabService,GitHubService,GoogleService,MicrosoftService,WeiboService,OpenIdController,OpenIdAuthController,GoogleOpenIdAuthController,MicrosoftOpenIdAuthController,GitLabOpenIdAuthController,GitHubOpenIdAuthController,WeiboOpenIdAuthController,EventModel,EventType,EventService,EventDataProvider,EventDataAzureStorageProvider,OrganizationController,OrganizationCollection,OrganizationModel,OrganizationService,StripeService,GoogleStorageService,StorageService,CronJobService,CronJobCollection,CronJobModel,DockerClient,GitLabClient,GoogleClient,KubernetesClient,MicrosoftClient,OAuthClient,RedmineClient,RestClient,TeamCityClient,WeiboClient,FetchWebPage,ExternalProviderGetters,TableStorage,TableBatchResult,AzureKey,ApfsFile};
//# sourceMappingURL=index.mjs.map
